var step0Html = api.readFile({
    sync: true,
    path: 'widget://html/tweelog/modules/step0/step0.html'
})
MSG = JSON.parse(api.readFile({
    sync: true,
    path: 'widget://res/i18n/'+ lan +'.json'
}));
var step0 = Vue.component('step0', {
    template: step0Html,
    props: {
        tweelogdata: {
            default: function(){return {}},
            type: Object
        },
        gettype: {
            default: function(){return {}},
            type: Function
        }
    },
    data: function(){
        return {
            message: MSG,
            type: '',
            collabEnabled: api.pageParam.collabEnabled || false,
            personalEnabled: api.pageParam.personalEnabled || false,
            isPersonal: true, // 如果true 表示已经创建过黄页
        }
    },
    created: function(){
        if (Object.keys(this.tweelogdata).length){
            this.type = this.tweelogdata.type;
        }
    },
    computed: {

    },
    methods: {
        checkData: function(){
            const promise = new Promise(function(resolve, reject) {
                var errorMessage = '';
                if (!this.type){
                    errorMessage = MSG.tweeLog.typeError;
                }
                if (errorMessage){
                    api.toast({
                        msg: errorMessage,
                        duration: 2000,
                        location: 'middle'
                    });
                }else {
                    var data = {
                        type: this.type,
                    };
                    resolve(data);
                }
            }.bind(this));
            return promise;
        },
        selectType: function(type){
            this.type = type;
            this.gettype({type: this.type});
        }
    }
})
