
apiready = function () {
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName:'FAQ'});
    api.setWinAttr({
            bounces: false
        });
    backListener('FAQ');
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var faq = new Vue({
        el: '#faq',
        mounted: function () {
            this.getData();

            var type = api.pageParam.type;
            if (type) {
                var index = api.pageParam.index;
                this.changeType(type);
                this.unfold(api.pageParam.index);

                setTimeout(function () {
                    var top = $('#faqList').find('li').eq(index).offset().top;
                    $("body").scrollTop(top);
                }, 0);
            }
        },
        data: {
            type:'community',
            faqData:'',
            faqDetail:'',
            inputKeys: '',
            List:[],
            topQ:[],
            avatars:[],
            message:MSG,
            icon_community:["icon-help-attraction","icon-help-post","icon-help-account","icon-help-search","icon-help-tbean","icon-help-invite","icon-help-report"],
            icon_products:["icon-help-product","icon-Group2014","icon-help-traffic","icon-help-order"],
            iconColors:['#FCB781','#799DF3','#B0BFDE','#FBDA93','#6E90E0','#81D7EB','#AFB8CB','#FCB781','#799DF3','#B0BFDE','#FBDA93','#6E90E0','#81D7EB','#AFB8CB']
        },
        methods: {
            changeType:function(type){
                this.type = type;
                this.faqList()
            },
            getData:function(){
                var that  = this;
                that.faqData = faqdatasall;
                that.getTopQ();
                that.faqList();
            },
            showIcon:function(index){
                return this['icon_'+this.type][index];
            },
            iconColor:function(index){
                return  {
                    background: this.iconColors[index],
                }
            },
            openDetail:function (index,i) {
                var that  = this;
                var QId = this.faqData[lan].category[that.type][index].Ids[i];
                openTabLayout("faqDetail",this.faqData[lan].category[that.type][index].title,'widget://html/access/faq-detail.html',{
                    categoryIndex:index,
                    questionId:QId,
                    questionIndex:i,
                    type:that.type
                });
            },
            toTop:function (index) {
                if(index){
                    var QId = this.topQ[index].id;
                }
                openTabLayout("faqDetail",this.message.mine.topQuestions,'widget://html/access/faq-detail.html',{
                    questionId:QId || "",
                    questionIndex:index
                });
            },
            faqList:function(){
                var that = this;
                var preList = [];
                for(var i=0;i<that.faqData[lan].category[that.type].length;i++){
                    var pr = {
                        "id": that.faqData[lan].category[that.type][i].id,
                        "title":that.faqData[lan].category[that.type][i].title,
                        "fold":2
                    };
                    preList.push(pr);
                    var qList = [];
                    for(var l=0;l<that.faqData[lan].faq.length;l++){
                        if(that.faqData[lan].category[that.type][i].Ids.indexOf(that.faqData[lan].faq[l].id) !== -1){
                            var pre ={
                                "id": that.faqData[lan].faq[l].id,
                                "question": that.faqData[lan].faq[l].question,
                            };
                            qList.push(pre);
                        }
                    }
                    preList[i].qlist = qList;
                }
                that.List = preList;
            },
            getTopQ:function(){
                var that = this;
                var ids = that.faqData[lan].top;

                for(var i=0;i<that.faqData[lan].faq.length;i++){
                    var top = {
                        "id": that.faqData[lan].faq[i].id,
                        "question":  that.faqData[lan].faq[i].question,
                    };
                    if(ids.indexOf(that.faqData[lan].faq[i].id) !== -1){
                        that.topQ.push(top);
                    }
                }
            },
            unfold:function (index) {
                var that = this;
                if(this.List[index].fold === 2 ){
                    for(var i = 0; i<this.List.length;i++){
                        that.List[i].fold = 2;
                    }
                    this.List[index].fold = this.List[index].qlist.length;
                }else{
                    for(var i = 0; i<this.List.length;i++){
                        that.List[i].fold = 2;
                    }
                }
            }


        }
    });

};
