
var Code,t,phoneNumber;
var selectedCallingCode = 86;

apiready = function () {
    backListener();
    // api.setTabLayoutAttr({
    //     hideNavigationBar: true
    // });
    api.addEventListener({
        name:'swiperight'
    }, function(ret, err){
        back();
    });

    api.setWinAttr({
        name: 'forgotPassword',
        bounces: false
    });

    api.addEventListener({
        name: 'selectedCallCode'
    }, function(ret, err) {
        selectedCallingCode = ret.value.num;
        forgotPassword.selectCode = ret.value.num
    });

    Code = api.loadSecureValue({
        sync: true,
        key: 'yunpankey_slider'
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var forgotPassword = new Vue({
        el: '#forgotPassword',
        mounted: function () {
            var that =this;
            //国家号码
            var countryCode = localStorage.getItem('countryCode');
            for (var l= 0; l<callingCode.length;l++){
                if(countryCode === callingCode[l].code){
                    selectedCallingCode = callingCode[l].number;
                    // $('#selectCode').text(callingCode[l].show);
                    that.selectCode = callingCode[l].number
                }
            }

            this.initYP();

        },
        data: {
            selectCode:86,
            phoneNumber:'',
            verifyCode:"",
            verifyToken:'',
            verifyAuthenticate:'',
            password:"",
            cpassword:"",
            isCounting: false,
            countdown: VERIFY_COUNT_SECONDS,
            inputType:'password',
            isRequesting: false,
            isSuccess: false,
            message: MSG
        },
        methods:{
            resetYP: function() {
                // this.verifyToken = '';
                // this.verifyAuthenticate = '';
                this.initYP();
            },
            initYP: function() {
                var that = this;
                new YpRiddler({
                    expired: 10,
                    mode: 'dialog',
                    winWidth: api.winWidth * 0.9,
                    lang: lan === 'zh' ?"zh-cn":"en",
                    // langPack: LANG_OTHER, // 你可以通过该参数自定义语言包, 其优先级高于lang
                    container: document.getElementById('cbox'),
                    appId: Code,
                    version: 'v1',
                    onError: function (param) {
                        if (!param.code) {
                            console.error('错误请求');
                        }
                        else if (parseInt(param.code / 100) == 5) {
                            // 服务不可用时，开发者可采取替代方案
                            console.error('验证服务暂不可用');
                        }
                        else if (param.code == 429) {
                            console.warn('请求过于频繁，请稍后再试');
                        }
                        else if (param.code == 403) {
                            console.warn('请求受限，请稍后再试');
                        }
                        else if (param.code == 400) {
                            console.warn('非法请求，请检查参数');
                        }
                        // 异常回调
                        console.error('验证服务异常:' + param.code)
                        api.toast({
                            msg: '验证服务异常:' + param.code,
                            duration: 2000,
                            location: 'middle'
                        });
                    },
                    onSuccess: function (validInfo, close, useDefaultSuccess) {
                        // 成功回调
                        // console.log('验证通过! token=' + validInfo.token + ', authenticate=' + validInfo.authenticate)
                        // 验证成功默认样式
                        that.verifyAuthenticate = validInfo.authenticate;
                        that.verifyToken = validInfo.token;
                        useDefaultSuccess(true);
                        close();

                        setTimeout(function () {
                            that.sendCode();
                        }, 200);
                    },
                    onFail: function (code, msg, retry) {
                        // 失败回调
                        // alert('出错啦：' + msg + ' code: ' + code);
                        retry()
                    },
                    beforeStart: function (next) {
                        //console.log('验证马上开始')
                        next()
                    }
                })
            },
            changeInputType:function () {
                if(this.inputType === 'password'){
                    this.inputType = "text"
                }else{
                    this.inputType = 'password'
                }
            },
            getVerifyCode:function(){
                if (!this.phoneNumber) {
                    api.toast({
                        msg: MSG.tips.phoneEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length < 8) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooShort,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length > 11) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooLong,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                $('.yp-riddler-button').trigger('click');
            },
            sendCode:function () {

                if (!this.verifyToken) {
                    return;
                }

                var phone = this.phoneNumber;
                var that = this;
                loading('show');
                if (phone) {
                    var paramStr = {
                        "authenticate": that.verifyAuthenticate,
                        "cellphone": phone,
                        "countryCode": that.selectCode,
                        "token": that.verifyToken,
                        "lang": lan = lan ==="es"?'en':lan
                    };
                    apiUserCenter.post("/api/v1/uas/smsv2f", paramStr).done(function (rep) {
                        loading('hide');
                        if (rep.code === 0) {
                            that.isCounting = true;
                            that.startCountDown();
                        } else {
                            api.toast({
                                msg: rep.message + " (4000)",
                                duration: 2000,
                                location: 'middle'
                            });
                            that.resetYP();
                        }
                    }).fail(function (err) {
                        loading('hide');
                        api.toast({
                            msg:MSG.tips.systemError + " (5000)",
                            duration: 2000,
                            location: 'middle'
                        });
                    });

                }

            },
            startCountDown:function () {
                var that = this;
                if (this.countdown === 0) {
                    //$(This).removeAttribute("disabled");
                    this.countdown = 60;
                    this.isCounting = false;
                    this.resetYP();
                    clearTimeout(t);
                } else {
                    t = setTimeout(function () {
                        that.countdown--;
                        that.startCountDown();
                    }, 1000);
                }
            },
            restPassword:function () {
                // 1. 手机号
                if (!this.phoneNumber) {
                    api.toast({
                        msg: MSG.tips.phoneEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length < 8) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooShort,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length > 11) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooLong,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                // 2. 验证码
                if (!this.verifyCode) {
                    api.toast({
                        msg: MSG.tips.verifyCodeEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.verifyCode.length !== 6) {
                    api.toast({
                        msg: MSG.tips.verifyCodeIncorrect,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                // 3. 登录密码
                if (!this.password) {
                    api.toast({
                        msg: MSG.tips.passwordEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (REG_PATTERN_PASSWORD.test(this.password) === false) {
                    api.toast({
                        msg: MSG.tips.password6,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                // 4. 确认密码
                if (this.password !== this.cpassword) {
                    api.toast({
                        msg: MSG.tips.passwordNotMatch,
                        duration: 2000,
                        location: 'top'
                    });
                    return
                }

                var that = this;
                var paramStr = {
                    "cellphone": this.phoneNumber,
                    "countryCode": selectedCallingCode,
                    "password": this.password,
                    "verifyCode": this.verifyCode
                };
                loading('show');
                this.isRequesting = true;
                apiUserCenter.post("/api/v1/uas/resetpwd", paramStr).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that.isSuccess = true;
                        setTimeout(function () {
                            back();
                        },2000)
                    } else {
                        that.isRequesting = false;
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    loading('hide');
                    api.toast({
                        msg:MSG.tips.systemError + " (5000)",
                        duration: 2000,
                        location: 'middle'
                    });
                });

            }


        }
    });

};


function selectCodeBtn() {
    openTabLayout('selectCodePage','','select-code-page.html');
}


//
// //使用电话找回
function resetByPhone(){
    var password = $('#password').val().trim();
    var cPassword = $('#conformPassword').val().trim();
    var phone = $('#phoneNumber').val().trim();
    var code = $('#verifyCode').val().trim();

    if (!phone) {
        api.toast({
            msg:MSG.tips.phoneEmpty,
            duration: 2000,
            location: 'top'
        });
        return;
    }

    if (!code) {
        api.toast({
            msg: MSG.tips.verifyCodeEmpty,
            duration: 2000,
            location: 'top'
        });
        return;
    }

    if (!password) {
        api.toast({
            msg: MSG.tips.passwordEmpty,
            duration: 2000,
            location: 'top'
        });
        return;
    }

    if (password.length < 6) {
        api.toast({
            msg: MSG.tips.password6,
            duration: 2000,
            location: 'top'
        });
        return;
    }

    // if(!phone){
    //     messages(message[lan].phoneEmpty, 'error', 'top', 2);
    //     return
    // }else if(!password||password.length <6 ){
    //     messages(message[lan].password6, 'error', 'top', 2);
    //     return
    // }
    if (password !== cPassword) {
        api.toast({
            msg: MSG.tips.passwordNotMatch,
            duration: 2000,
            location: 'top'
        });
        return
    }

    var paramStr = {
        "Password": password,
        "CountryCallingCode": selectedCallingCode,
        "PhoneNumber": phone,
        "VerifyCode": code,
    };
    var url = getUASApi()+'resetpwd?lang='+lan;
    var method = "POST";
    loading('show');
    $.when(postApi(url, method, paramStr, null, 'contentTypeStr')).done(function (data) {
        //console.log(JSON.stringify(data));
        loading('hide');
        if(data.success){
            messages(data.message,'success','top',2);
            setTimeout(function () {
                back();
            },2000)
        }else{
            messages(data.message,'error','top',2);
        }
    });
}
