
apiready = function () {
    var Address = api.pageParam.addressInfo ?JSON.parse(api.pageParam.addressInfo):null;
    var checkoutInfo = JSON.parse(api.pageParam.checkoutInfo);
    var checkedList = api.pageParam.checkedList;
    //console.log(JSON.stringify(checkoutInfo));
    $('.addShopping-bar').height((api.safeArea.bottom + 60) + 'px');
    var checkout = new Vue({
        el: '#checkout',
        mounted: function () {

        },
        data: {
            listData: checkoutInfo,
            defaultCurrency: localStorage.getItem('primaryCurrencyCode'),
            addressInfo:Address,
            checkedList:checkedList,
        },
        filters: {
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
        },
        methods:{
            submitOrder:function () {
                var that = this;
                var addressId = this.addressInfo ? this.addressInfo.Id : null;
                var paramStr = {
                    "ShippingAddress" : {"AddressId": addressId} ,
                    "buyerId" : localStorage.getItem('userId'),
                    "BillingAddress" : null,
                    "CurrencyCode" : localStorage.getItem('primaryCurrencyCode'),
                    "ShoppingCartItems":this.checkedList,
                };
                //console.log(JSON.stringify(paramStr));
                var url = getBaseUrl() + "/api/v2/shopping-cart/to/order";
                $('.ui-loading').removeClass('invisible');
                getAxois(url, "POST", paramStr).then(function (response) {
                    $('.ui-loading').addClass('invisible');

                    api.closeWin({
                        name: 'shoppingCart'
                    });
                    api.closeWin({
                        name: 'productDetail'
                    });

                    if(that.listData.Total > 0){
                        openWindows('payment','widget://html/business/payment.html',{
                            orders:response.data.Orders,
                        })
                    }else{
                        var token = api.getPrefs({
                            sync: true,
                            key: 'accessToken'
                        });
                        var paramStr = {
                            "PaymentMethod" :'alipay',
                            "Amount" :0,
                            "CurrencyCode" :  "",
                            "Orders":response.data.Orders,
                            "Data":''
                        };
                        var url = getBaseUrl() + "/api/v2/orders/verify";
                        var method = "PUT";
                        $.when(postApi(url, method, paramStr, token, null)).done(function (data) {
                            // console.log(JSON.stringify(data));
                            paymentResult('',response.data.Orders,response.data,"free");
                        });
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + ' review API 报错');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            }
        }
    });

};

function paymentResult(paymentResult,paymentData,paymentMethod) {
    api.openWin({
        name: 'paymentResult',
        url: 'payment-result.html',
        bounces:false,
        animation:{
            type:"movein",
            subType:"from_right"
        },
        pageParam: {
            paymentResult:paymentResult,
            paymentMethod:paymentMethod,
            paymentData:paymentData,
            price:0,
            paymentCurrency:"",
            orders:orders,
        }
    });
}
