//header 部分
function switchHomeTag(type,that) {
    if(!$(that).hasClass('active')){
        $(that).addClass('active').siblings().removeClass('active');
        // homePage.switchTage(type);
        api.execScript({
            frameName: 'home',
            script: "homePage.switchTage('"+type+"')"
        });
        var $tagList = $('#postTagList');
        if (type === 'following') {
            $tagList.find('.item').removeClass('active');
            $tagList.css({
                opacity: 0.3,
                pointerEvents: 'none'
            });
        } else if(type === 'wall'){
            // 标签切到世界
            var $firstTag = $tagList.find('.item').eq(1);
            $tagList.find('.item').eq(0).hide();
            $firstTag.siblings('li.item').removeClass('active');
            $firstTag.addClass('active');
            $tagList.css({
                opacity: 1,
                pointerEvents: 'inherit'
            });
        } else {
            // 标签切到最新
            $tagList.find('.item').eq(0).show();
            var $firstTag = $tagList.find('.item').eq(0);
            $firstTag.siblings('li.item').removeClass('active');
            $firstTag.addClass('active');
            $tagList.css({
                opacity: 1,
                pointerEvents: 'inherit'
            });
        }
    }else{
        api.pageUp({
            top: true
        });
    }
}

var currentFeedType = localStorage.getItem('feedType') || 'auto';

toggleFeed(currentFeedType);

function toggleFeed(currentFeedType) {
    if (currentFeedType === 'full') {
        $('.feed-btn.full').hide();
        $('.feed-btn.auto').show();
    } else {
        $('.feed-btn.full').show();
        $('.feed-btn.auto').hide();
    }
}

function switchFeedType(type) {
    toggleFeed(type);
    api.execScript({
        frameName: 'home',
        script: "homePage.switchFeedType('"+type+"')"
    });
}

function openConversationMenu() {
    var mnPopups = api.require('MNPopups');
    mnPopups.open({
        rect: {
            w: 140,
            h: 138
        },
        position: {
            x: api.winWidth - 26,
            y: getRightPxFromFontSize(68)
        },
        styles: {
            mask: 'rgba(0,0,0,0.2)',
            bg: '#fff',
            corner: 8,
            cell: {
                bg: {
                    normal: '#ffffff',
                    highlight: ''
                },
                h: 44,
                title: {
                    marginL: 20,
                    color: '#000',
                    size: 14,
                    textAlign: 'left'
                },
                icon: {
                    marginL: 140,
                    w: 20,
                    h: 20,
                    corner: 0
                },
                separateLine: {
                    width: 0.5,
                    marginLR: 10,
                    bg: '#DADADA',
                    hideLastSeparateLine: true
                }
            },
            pointer: {
                size: 0,
                xPercent: 88,
                yPercent: 0,
                orientation: 'downward'
            }
        },
        datas: [
            {
                icon: 'widget://image/chat-follow.png',
                title: MSG.chat.followings,
            },
            {
                icon: 'widget://image/chat-create.png',
                title: MSG.chat.createGroup
            },
            {
                icon: 'widget://image/chat-qun.png',
                title: MSG.chat.joinedGroup
            }
        ],
        animation: true,
        animationDuration: 100
    }, function(ret) {
        if (ret) {
            if (ret.index === 0) {  //关注
                api.execScript({
                    frameName: 'messages',
                    script: "menuTag('followings')"
                });
            } else if (ret.index === 1) {   // 创建群
                api.execScript({
                    frameName: 'messages',
                    script: "menuTag('createGroup')"
                });
            } else if (ret.index === 2) {   // 我的群
                api.execScript({
                    frameName: 'messages',
                    script: "menuTag('joinedGroup')"
                });
            }
        }
    });
}

function toSearchFriend() {
    openWindows('searchFriend','widget://html/chat/search-friend.html');
}

function openSettingPage() {
    openTabLayout('configuration', MSG.general.setting, 'widget://html/users/configuration.html');
}

function switchDiscoveryTag(type,that) {
    if(!$(that).hasClass('.active')){
        $(that).addClass('active').siblings().removeClass('active');
        $('#discoveryAddText').text(MSG.index["add"+type]);
        api.execScript({
            frameName: 'discovery',
            script: "discovery.switchTag('"+type+"')"
        });
    }
}

function switchProductTag(type, that) {

    if (type === 'evaluation') {
        var Token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        }) || localStorage.getItem('access_token');
        if (!Token) {
            openLogin();
            return;
        }
    }

    if(!$(that).hasClass('.active')){
        $(that).addClass('active').siblings().removeClass('active');
        api.execScript({
            frameName: 'products',
            script: "tproductsList.switchType('"+type+"')"
        });
    }
}

function openCategoryPage() {
    var title = MSG.products.category;
    openTabLayout('categoryPage', title, 'widget://html/frame/select-category.html');
}

function openSortMenu(e) {

    var mnPopups = api.require('MNPopups');
    mnPopups.open({
        rect: {
            w: 180,
            h: 138
        },
        position: {
            x: api.winWidth - getRightPxFromFontSize(26),
            y: getRightPxFromFontSize(68)
        },
        styles: {
            mask: 'rgba(0,0,0,0.2)',
            bg: '#fff',
            corner: 8,
            cell: {
                bg: {
                    normal: '#fff',
                    highlight: ''
                },
                h: 44,
                title: {
                    marginL: 20,
                    color: '#000',
                    size: 14,
                    textAlign: 'left'
                },
                icon: {
                    marginL: 140,
                    w: 20,
                    h: 20,
                    corner: 0
                },
                separateLine: {
                    width: 0.5,
                    marginLR: 10,
                    bg: '#DADADA',
                    hideLastSeparateLine: true
                }
            },
            pointer: {
                size: 0,
                xPercent: 90,
                yPercent: 0,
                orientation: 'downward'
            }
        },
        datas: [
            {
                icon: 'widget://image/placeholder.png',
                title: MSG.tProduct.default
            },
            {
                icon: 'widget://image/ranking-up.png',
                title:  MSG.tProduct.lowToHigh
            },
            {
                icon: 'widget://image/ranking-down.png',
                title:  MSG.tProduct.highToLow
            }
        ],
        animation: true,
        animationDuration: 100
    }, function(ret) {
        if (ret) {
            var type;
            if ($('#navProduct').hasClass('active') === true) {
                type = 'products';
            } else {
                type = 'evaluation';
            }
            if (ret.index === 0) {  //默认
                api.execScript({
                    frameName: 'products',
                    script: "tproductsList.changeSortBy('default', '" + type + "')"
                });
            } else if (ret.index === 1) {   // 价格由低到高
                api.execScript({
                    frameName: 'products',
                    script: "tproductsList.changeSortBy('lowToHigh', '" + type + "')"
                });
            } else if (ret.index === 2) {   // 价格由高到低
                api.execScript({
                    frameName: 'products',
                    script: "tproductsList.changeSortBy('highToLow', '" + type + "')"
                });
            }
        }
    });
}

function discoveryAddBtn() {
    api.execScript({
        frameName: 'discovery',
        script: "discovery.addBtn()"
    });
}
function searchUsersFocus() {
    api.execScript({
        frameName: 'home',
        script: "homePage.searchFocus()"
    });
}

function createBtn() {
    api.execScript({
        frameName: 'home',
        script: "homePage.togglePostMenu()"
    });
}

function selectPostList() {
    api.execScript({
        frameName: 'home',
        script: "homePage.togglePostMenu()"
    });
}

function selectProductList() {
    api.execScript({
        frameName: 'products',
        script: "tproductsList.toggleTypeMenu()"
    });
}

function openTweeTycoonSearch() {
    api.execScript({
        frameName: 'home',
        script: "homePage.searchFocus()"
    });
}

//打开帮助
function openTweeProdTips() {
    $('#pointer').remove();
    api.setPrefs({
        key: 'firstInPord',
        value: 'firstInPord'
    });
    api.execScript({
        frameName: 'products',
        script: "tproductsList.openTips()"
    });
}

//打开搜索
function openTweeSearch() {
    var type;
    if ($('#navProduct').hasClass('active') === true) {
        type = 'products';
    } else {
        type = 'evaluation';
    }
    api.execScript({
        frameName: 'products',
        script: "tproductsList.openSearch('" + type + "')"
    });
}

//打开添加
function openAddNewProducts() {
    api.execScript({
        frameName: 'products',
        script: "tproductsList.openCreateMenu()"
    });
}

// function openCategoryPage() {
//     api.execScript({
//         frameName: 'products',
//         script: "tproductsList.openCategory()"
//     });
// }

// function changePrdCategory(id) {
//     if(id){
//         $('#'+id).addClass('active').siblings().removeClass('active');
//         $('#all').removeClass('active');
//     }else{
//         $('.category').removeClass('active');
//         $('#all').addClass('active');
//     }
//     api.execScript({
//         frameName: 'products',
//         script: "tproductsList.changeCategory("+ id +")"
//     });
// }

// function getTweebaaProdCategory(lang) {
//     $('ul.tweebaa-pro-nav li:not(#hold)').remove();
//     var url = getBaseUrl()+ "api/category/v2/L1";
//     getAxois(url, "GET", {}).then(function (response) {
//         //console.log(JSON.stringify(response.data.Data));
//         var c = response.data.Data;
//         for(i= 0;i<response.data.Data.length;i++){
//             var li = "<li id='"+ c[i].id +"' class='category' onclick='changePrdCategory("+ c[i].id +")'>"+ c[i][lang] +"</li>";
//             $('#tweebaaProNav').find('ul.tweebaa-pro-nav').append(li);
//         }
//     }).catch(function (error) {
//         console.log(JSON.stringify(error));
//     });
// }

//end header 部分

function switchToIndex(index,name){
    api.setFrameGroupIndex({
        name: 'index',
        index: index,
    });
    // 去除以前
    currentActiveFooter.removeClass('active');
    var currentKey = currentActiveFooter.attr('id');
    currentActiveFooter.find('.icon-tweebaa')
        .removeClass(footerMap[currentKey].activeIcon)
        .addClass(footerMap[currentKey].icon);

    // 设置当前
    currentActiveFooter = $('#'+name);
    currentActiveFooter.addClass('active');
    currentActiveFooter.find('.icon-tweebaa')
        .removeClass(footerMap[name].icon)
        .addClass(footerMap[name].activeIcon);

    $('#header').children().hide();
    $('#header').find('.header-nav.'+name).show();

}

$('#mineSign').click(function() {
    api.execScript({
        frameName: 'mine',
        script: "workPlace.toSign();"
    });
});

//签到红点提示
function hasSignTips(type) {
    var el = $('#mineSign').find('.red-circle');
    if(type){
        el.removeClass('d-none');
    }else{
        if(!el.hasClass('d-none')){
            el.addClass('d-none');
        }
    }
}
