

apiready = function () {
    backListener();

    var page = 0;


    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500
        }
    }, function (ret, err) {
        page++;
        orgList.getOrgList();
    });

    var orgList = new Vue({
        el: '#orgList',
        mounted: function () {
            this.getOrgList();
        },
        data: {
            orgList:[],
        },
        methods: {

            getOrgList:function () {
                var that = this;
                var url = getBaseUrl() + "api/voics/organizations/verified?currentpage="+ page +"&itemsperpage=24";
                if(page === 0){
                    $('#placeHolderLoad').show();
                }
                getAxois(url,"GET",{}).then(function (response) {
                    // console.log(JSON.stringify(response.data));
                    $('#placeHolderLoad').hide();
                    if (response.data.length !== 0) {
                        that.orgList = that.orgList.concat(response.data);
                    }
                }).catch(function (error) {
                    $('#placeHolderLoad').hide();
                    console.log(JSON.stringify(error));
                });
            },
            openTycoonplace:function(index){
                openUserTycoonPlace(this.orgList[index].User.Id,this.orgList[index].User.StoreName,this.orgList[index].User.AvatarUrl);
            },
            openDetial:function (index) {
                var that =this;
                openTabLayout('org-detail',$.i18n.prop('tweeLog'),'widget://html/discovery/org-detail.html',{
                    userId: JSON.stringify(that.orgList[index].User.Id)
                })
            },
        }
    });
};
