
apiready = function () {
    api.setNavBarAttr({
        rightButtons: [{
            text: '关于志愿者',
            color:'#a1a1a1',
            fontSize:'12'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            volunteerList.aboutVolunteer();
        }else{
            back();
        }
    });

    var page = 0;

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500
        }
    }, function (ret, err) {
        page++;
        volunteerList.getVolunteerList();
    });

    var volunteerList = new Vue({
        el: '#volunteerList',
        mounted: function () {
            this.getVolunteerList();
        },
        data: {
            volunteerList:[],
            Verified:Boolean(localStorage.getItem('IDVerified') === 'true'),
        },
        methods: {

            getVolunteerList:function () {
                var that = this;
                var url = getBaseUrl() + "api/voics/volunteers/verified?currentpage="+ page +"&itemsperpage=20" ;
                if(page === 0){
                    $('#placeHolderLoad').show();
                }
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    $('#placeHolderLoad').hide();
                    if (response.data.length !== 0) {
                        that.volunteerList = that.volunteerList.concat(response.data);
                    }
                }).catch(function (error) {
                    $('#placeHolderLoad').hide();
                    console.log(JSON.stringify(error));
                });
            },
            openVolunteerDetail: function (index) {
                openTabLayout('activityDetail',this.volunteerList[index].Name,'widget://html/discovery/volunteer-detail.html',{
                    data:JSON.stringify(this.volunteerList[index])
                },0);
                //openWindows('activityDetail','widget://html/activity/activity-detail.html');
            },
            aboutVolunteer:function () {
                openTabLayout('whatIsVolunteer', '', 'widget://html/access/menu-detail.html',{
                    Id:13
                });
            }
        }
    });
};
