
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setWinAttr({
        slidBackEnabled:false,
        hScrollBarEnabled:false
    });

    var setMentioned = new Vue({
        el: '#setMentioned',
        mounted: function () {
            'name'.toLowerCase()
        },
        created: function() {
            var that = this;
            var members = api.pageParam.members;
            var result = [];
            $.map(members, function (item, index) {
                if (item.UserId !== that.myID) {
                    result.push(item);
                }
            });
            this.listData = result;
        },
        data: {
            listData: [],
            myID: localStorage.getItem('chatID'),
            inputKeys: '',
            message: MSG
        },
        methods:{
            select: function(user) {
                api.sendEvent({
                    name: 'inputMentionedUser',
                    extra: {
                        user: user
                    }
                });
                console.log('====================================: ' + user.StoreNames);
                console.log('====================================: ' + user.UserId);
                api.closeFrame();
            },
            selectAll: function() {
                api.sendEvent({
                    name: 'inputMentionedAll'
                });
                api.closeFrame();
            },
            close: function() {
                api.closeFrame();
            }
        }

    });

};
