
var videoURL,tags,selectedCategory,ToTweebaa;
var uploading = false;
var pictures = [];
var sending = false;
var tagProject = [];
var tweebucksPrice;
var tweebucksShippingFee;

autosize(document.querySelectorAll('textarea'));

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#media [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    //写入文字信息
    $(".replace-text").each(function () {
        $(this).text(MSG.products[$(this).attr('id')]);
    });

    $(".replace-placeholder").each(function () {
        $(this).attr("placeholder",MSG.products[$(this).attr('id')]).on('blur',function () {
            if(!$(this).val()){
                $(this).attr("placeholder",MSG.products[$(this).attr('id')]);
            }
        });
    });

    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false,
    });
    var postBtn = MSG.products.post;
    api.setNavBarAttr({
        rightButtons: [{
            text: postBtn,
            color:'#4578F3',
            fontSize:'15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {

        if(ret.type ==='right'){
            submitFunction()
        }else{
            confirm(MSG.products.wantExit, function () {
                back();
            });
        }
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew,#videoBtn,#showVideo').height(imgW);

    //写入分类
    api.addEventListener({
        name: 'category'
    }, function(ret, err) {
        selectedCategory = JSON.parse(ret.value.c);

    });
    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        // 分类处理
        $('#categoryName').html(ret.value.list.join(', '));
    });

    //写入showroom信息
    api.addEventListener({
        name: 'showroom'
    }, function(ret, err) {
        if(ret.value.toTweebaa){
            ToTweebaa = ret.value.toTweebaa;
            // console.log(JSON.stringify(ToTweebaa));
        }
    });

    //写入tag信息
    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tags = ret.value.tags.split(',');
            $('#productTags').empty();
            for(i=0;i<tags.length;i++){
                tagProject.push({"name":tags[i]});
                $('#productTags').append("<span class='product-tags'>"+ tags[i] +"</span>")
            }
            //console.log(JSON.stringify(tagProject));
        }
    });

    $('#description').editor({
        placeholder: MSG.products.description
    });

    new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
        console.log('tweebuckValue: ' + tweebuckValue);
        if (tweebuckValue) {
            tweebucksPrice = tweebuckValue.toFixed(4);
        } else {
            tweebucksPrice = '';
        }
    });

    new CurrencySelector(document.getElementById('shippingFeePlaceholder'), function (tweebuckValue) {
        console.log('tweebuckValue: ' + tweebuckValue);
        if (tweebuckValue) {
            tweebucksShippingFee = tweebuckValue.toFixed(4);
        } else {
            tweebucksShippingFee = '';
        }
    });

};

var Btns = {
    openCategoryPage:function () { //分类
        openTabLayout('categoryPhysical','','widget://html/products/category-physical.html')
    },
    openProductTags:function () { // 打开tag输入
        openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
            tags:tags?tags.join(','):null
        })
    },
    openPrepareShowroomPage:function(){
        openTabLayout('prepareShowroomPage','','widget://html/products/prepare-showroom.html',{
            price:Number($('#price').val()),
            profit:ToTweebaa ? ToTweebaa.TargetTweebuckProfit : null,
            productType:2,
        })
    }

};


//预览上传的视频
function playProdVideo(){
    // api.openWin({
    //     name: 'videoPlayer',
    //     url: 'widget://html/frame/video-player.html',
    //     bounces:false,
    //     bgColor:'#000000',
    //     hideHomeIndicator:true,
    //     slidBackEnabled:false,
    //     animation:{
    //         type:"none",
    //     },
    //     pageParam: {
    //         url: productVideoURL,
    //         pic: productVideoThumbnailURL,
    //         isCache:false
    //     }
    // });
    playVideo( productVideoURL);
}

function submitFunction() {

    if(sending){
        return false;
    }
    var prodTitle = $('#title').val();
    var description = $.trim($('#description').html());

    console.log('description: ' + description);

    if(imgUploading || uploading){
        api.toast({
            msg: MSG.tips.uploadDataTips,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(picArray.length===0){
        api.toast({
            msg: MSG.tips.noPicError,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(!prodTitle) {
        api.toast({
            msg: MSG.tips.productNameEmpty,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(prodTitle.length>80) {
        api.toast({
            msg: MSG.tips.productNameTooLong,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(!tweebucksPrice || tweebucksPrice == 0){
        api.toast({
            msg: MSG.tips.productPriceEmpty,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(!description || description === '<br>') {
        api.toast({
            msg: MSG.tips.descriptionEmpty,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(!selectedCategory){
        api.toast({
            msg: MSG.tips.categoryEmpty,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    else if(!tags){
        api.toast({
            msg: MSG.tips.tag2,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }
    // 库存
    else if(!$('#quantity').val() || $('#quantity').val() == 0){
        api.toast({
            msg: MSG.tips.quantityEmpty,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }

    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.DisplayOrder = index;
        pictures.push(pic);
    });
    setTimeout(function () {
        var prodObj = {
            "ProductType":1,
            "Name": prodTitle,
            "Sku": $('#SKU').val(),
            "En" : {
                "Name" : prodTitle,
                "ShortDescription" : '',
                "FullDescription" : description,
                "AdvisoryReason" : ToTweebaa ? ToTweebaa.AdvisoryReason :null
            },
            "Cn" : {
                "Name" : prodTitle,
                "ShortDescription" : '',
                "FullDescription" : description,
                "AdvisoryReason" : ToTweebaa ? ToTweebaa.AdvisoryReason :null
            },
            "Quantity": Number($('#quantity').val()),
            "TweebuckPrice":tweebucksPrice,
            "DisplayOrder": 0,
            "OrderMinimumQuantity":  1,
            "ProductTags": tagProject,
            "FullDescription": description,
            "Categories": selectedCategory,
            "IsFreeShipping":!tweebucksShippingFee,
            "ShippingFee":tweebucksShippingFee ? Number(tweebucksShippingFee) : null,
            "ShowOnHomePage": true,
            "Pictures": pictures,
            "CurrencyCode":null,
            "SampleDownload": videoURL,
            "ContactEmail" :ToTweebaa ? ToTweebaa.ContactEmail :null,
            "ProductToTweebaa":ToTweebaa
        };
        sending = true;

        var url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId');
        loading('show');
        getAxois(url, "POST", prodObj).then(function (response) {
            // console.log(JSON.stringify(response));
            loading('hide');
            if(response.data.Success){
                api.toast({
                    msg: MSG.products.added,
                    duration: 2000,
                    location: 'middle'
                });
                api.sendEvent({
                    name: 'productListReload',
                });
                api.closeWin({
                    name: 'prepareAdd'
                });
                setTimeout(function () {
                    back();
                }, 2000);
            }else{
                sending = false;
            }

        }).catch(function (error) {
            api.toast({
                msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                duration: 2000,
                location: 'middle'
            });
            loading('hide');
            sending = false;
        });
    });

}
