
var uploading = false;
var sending = false;
var pictures = [];
var Video = {};
var token ='';

// autosize(document.querySelectorAll('textarea'));

// PHYSICAL, DIGITAL, INVENTION

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#media [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    backListener();

    api.setWinAttr({
        bounces: false
    });

    var postBtn = lan === "zh" ? "发布" : "Post";
    api.setNavBarAttr({
        rightButtons: [{
            text: postBtn,
            color:'#4578F3',
            fontSize:'15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            if (presaleProduct.isRequesting === false) {
                presaleProduct.submit();
            }
        } else {
            if (presaleProduct.isEdit === false) {
                presaleProduct.beforeBack();
            } else {
                back();
            }
        }
    });

    api.addEventListener({
        name: 'keyback'
    }, function (ret, err) {
        if (presaleProduct.isEdit === false) {
            presaleProduct.beforeBack();
        } else {
            back();
        }
    });

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew, #videoBtn, #showVideo').height(imgW);

    api.addEventListener({   //写入分类
        name: 'category'
    }, function(ret, err) {
        var categorys = JSON.parse(ret.value.c);
        var ids = [];
        $.each(categorys, function (index, item) {
            ids.push(item.Id);
        });
        presaleProduct.form.productCategories = ids;
    });

    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        presaleProduct.currentCategoryName = ret.value.list.join(', ');
    });

    api.addEventListener({
        name: 'selectedCountries'
    }, function(ret, err) {
        presaleProduct.form.shipToCountries = ret.value.countries;
        presaleProduct.displayShipToCountries = ret.value.displayCountries;
    });

    var tags = [];
    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tags = ret.value.tags.split(',');
            presaleProduct.form.productTags = tags;
        }
    });

    api.addEventListener({
        name: 'uploadedDigitalFile'
    }, function(ret, err) {
        presaleProduct.form.productLink = ret.value.productURL;
        presaleProduct.digitalFileName = ret.value.fileName;
    });

    if (api.pageParam.product) {
        $('#upload').hide();
    }

    var kv = api.require('snKVStorage');
    var hasPresaleProductDraft = kv.has({
        key: 'presaleProductDraft'
    });
    var presaleProductDraft = {};
    if (hasPresaleProductDraft) {
        presaleProductDraft = kv.getObject({
            key: 'presaleProductDraft'
        });
    }

    /**
     * 1. 建议已有产品
     * 2. 建议新的产品：包含：数字产品、实体产品
     */
    var presaleProduct = new Vue({
        el: '#presaleProduct',
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
                // console.log("lan is: " + lan);
                // 按照系统语言切换显示的时间语言
                if (lan === 'zh') {
                    moment.locale('zh-cn');
                } else if (lan === 'es') {
                    moment.locale('es');
                }
                var today = moment();
                var time = moment.utc(value).local().format('YYYY-MM-DD HH:mm');
                var time2 = moment.utc(value).local().format('M-D');
                var diff = today.diff(time, 'days');
                // console.log("diff is: " + diff);
                var result;
                if (diff === 0) {
                    return moment(time).fromNow();
                } else {
                    return time2;
                }
                return time;

            },
            filterSuppliers: function (value) {
                var result;
                switch (value) {
                    case 'WITHOUT_SUPPLIER':
                        result = MSG.suggestion.withoutSupplier;
                        break;
                    case 'WITH_SUPPLIER':
                        result = MSG.suggestion.withASupplier;
                        break;
                    case 'AS_SUPPLIER':
                        result = MSG.suggestion.asASupplier;
                        break;
                    default:
                        result = MSG.suggestion.withoutSupplier;
                }
                return result;
            }
        },
        computed: {

        },
        mounted: function() {
            if (this.isEdit === false) {
                this._initDom();
            }
        },
        created: function() {

            if (api.pageParam.isEdit === true) {
                this.isEdit = true;
                this.setPresale(api.pageParam.presale);
            } else {
                // 判断是否有草稿
                var form = presaleProductDraft[this.currentType];
                if (form) {
                    this.form = form;

                    if (this.form.productImageLinks && this.form.productImageLinks.length > 0) {
                        this._setImageHtml(this.form.productImageLinks);
                    }

                    // 视频
                    if (this.form.productVideoInfos) {
                        var video = this.form.productVideoInfos[0];
                        Video = {
                            DownloadUrl: video.downloadUrl,
                            ThumbnailUrl: video.thumbnailUrl,
                            DurationSeconds: video.durationSeconds
                        };
                        renderVideo(video.thumbnailUrl);
                    }

                    // 类别
                    if (this.form.productCategories && this.form.productCategories.length > 0) {
                        this._setCategoryName(this.form.productCategories);
                    }

                    // 数字产品的上传产品部分
                    if (this.form.productLink) {
                        this._setFileLabel(this.form.productLink);
                    }
                }
            }
        },
        data: {
            isEdit: false,

            currentType: 'PHYSICAL',
            currentCategoryName: '',

            digitalFileName: '',

            isRequesting: false,
            form: {
                type: 'PHYSICAL',
                userName:localStorage.getItem('userName'),
                productVideoInfos: [],
                productImageLinks: [],  // 必填

                productName: '',
                productDescription: '',
                sellingPrice: '',
                shippingFee: '',
                stockQuantity: '',  // 库存
                sku: '',
                productCategories: [],
                productTags: [],
                myIncome: '',
                tycoonComment: '',
                productPitch: '',   // 推荐理由

                productLink: '',    // 数字产品链接

                // AS_SUPPLIER, WITHOUT_SUPPLIER, WITH_SUPPLIER
                supplierType: 'WITH_SUPPLIER',

                // WITHOUT_SUPPLIER
                priceReferenceLink: '',
                supplierName: '',
                supplierContactName: '',
                supplierContactEmail: '',
                supplierContactPhone: '',
                supplierWebsiteLink: '',
                shipToCountries: '',    //

                presalePrice: '',    //预售价格
                presaleTargetCount: '',    //预售目标
                presaleValidityDays: '',    //预售天数
                planedStartTime: '', //预售开始时间
                presaleDaysShipStart: ''
            },
            displayShipToCountries:'',
            minStartTime:moment().add(1, 'days').format('YYYY-MM-DDThh:mm'),
            message: MSG,
        },
        methods: {
            _initDom: function() {
                var that = this;

                $('#description').editor({
                    placeholder: MSG.suggestion.pDescription,
                    content: this.form.productDescription
                });

                $('#price').val(this.form.sellingPrice);
                new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
                    // console.log('tweebuckValue: ' + tweebuckValue);
                    if (tweebuckValue) {
                        that.form.sellingPrice = tweebuckValue;
                    } else {
                        that.form.sellingPrice = '';
                    }
                });

                $('#shippingFee').val(this.form.shippingFee);
                new CurrencySelector(document.getElementById('shippingFee'), function (tweebuckValue) {
                    // console.log('tweebuckValue: ' + tweebuckValue);
                    if (tweebuckValue !== '') {
                        that.form.shippingFee = tweebuckValue;
                    } else {
                        that.form.shippingFee = '';
                    }
                });

                $('#presalePrice').val(this.form.presalePrice);
                new CurrencySelector(document.getElementById('presalePrice'), function (tweebuckValue) {
                    // console.log('tweebuckValue: ' + tweebuckValue);
                    if (tweebuckValue !== '') {
                        that.form.presalePrice = tweebuckValue;
                    } else {
                        that.form.presalePrice = '';
                    }
                });

                $('#myIncome').val(this.form.myIncome);
                new CurrencySelector(document.getElementById('myIncome'), function (tweebuckValue) {
                    console.log('tweebuckValue: ' + tweebuckValue);
                    if (tweebuckValue) {
                        that.form.myIncome = tweebuckValue.toFixed(4);
                    } else {
                        that.form.myIncome = '';
                    }
                });
            },
            saveDraft: function() {

                // 描述
                var description = $.trim($('#description').html());
                if (description && description !== '<br>') {
                    this.form.productDescription = description;
                } else {
                    this.form.productDescription = '';
                }

                // 图片
                var pictures = [];
                $("#uploadImgBox").find('img').each(function (index) {
                    var pic = $(this).data('picture');
                    pic.DisplayOrder = index;
                    pictures.push({
                        "pictureUrl": pic.DownloadUrl,
                        "thumbnailUrl": pic.ThumbnailUrl
                    });
                });
                this.form.productImageLinks = pictures;

                // 视频
                if (Video) {
                    this.form.productVideoInfos = [
                        {
                            downloadUrl: Video.DownloadUrl,
                            thumbnailUrl: Video.ThumbnailUrl,
                            durationSeconds: Video.DurationSeconds
                        }
                    ];
                }

                presaleProductDraft[this.currentType] = $.extend({}, this.form);
                kv.setObject({
                    key: 'presaleProductDraft',
                    value: presaleProductDraft
                });
                setTimeout(function () {
                    back();
                }, 100)
            },
            beforeBack: function() {
                var that = this;
                confirm(MSG.suggestion.beforeBackTipPresale, [
                    {
                        text: MSG.moment.saveDraft,
                        callback: function () {
                            that.saveDraft();
                        }
                    },
                    {
                        text: MSG.moment.exitDirectly,
                        callback: function () {
                            delete presaleProductDraft[that.currentType];
                            kv.setObject({
                                key: 'presaleProductDraft',
                                value: presaleProductDraft
                            });
                            setTimeout(function () {
                                back();
                            }, 100);
                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            openWarn: function(key, $event) {
                // alert(MSG.suggestion[key]);
                $event && $event.stopPropagation();
                dialog({
                    title: MSG.tips.title,
                    content: MSG.suggestion[key],
                    primaryText: MSG.tips.gotit,
                    asideText: '',
                    onClose: "show",
                    textAlign: 'left',
                    onWarning: function() {
                    },
                    onPrimary: function () {

                    }
                });
            },
            getLangKey: function() {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            _setCategoryName: function(productCategories) {
                var categoryNames = getCategoryNameByIds(productCategories, lan);
                this.currentCategoryName = categoryNames.join(', ');
            },
            _setImageHtml: function(productImageLinks) {
                id = id + productImageLinks.length;
                $.map(productImageLinks, function (item, index) {
                    var picData =  {
                        "MediaType": "Picture",
                        "FileName": "testimage.png",
                        "MediaFileUrl": item.pictureUrl,
                        "DownloadUrl": item.pictureUrl,
                        "ThumbnailUrl" : item.thumbnailUrl
                    };
                    $('#uploadImgBox').prepend(
                        getPhotoItem(index, liWith, item.pictureUrl, false)
                    );
                    $("#p" + index).data("picture", picData);

                    Sortable.create(document.getElementById('uploadImgBox'),
                        {
                            animation: 150,
                            onEnd: function (e) {
                            },
                            ghostClass:'.img-li',
                            handle:'.drag-handle'
                        });
                });
            },
            setPresale: function(presale) {
                var product = presale;
                var that = this;

                that.form.id = presale.id;

                // 呈现
                // 1. 上传图片+视频
                if (product.productImageLinks) {
                    that._setImageHtml(product.productImageLinks);
                }

                that.form.productVideoInfos = product.productVideoInfos;
                var video = product.productVideoInfos[0];
                if (video.downloadUrl) {
                    Video = {
                        DownloadUrl: video.downloadUrl,
                        ThumbnailUrl: video.thumbnailUrl,
                        DurationSeconds: video.durationSeconds
                    };
                    renderVideo(video.thumbnailUrl);
                }

                that.form.productImageLinks = product.productImageLinks;
                that.form.productName = product.productName;
                that.form.productDescription = product.productDescription;
                that.form.sellingPrice = product.sellingPrice;
                that.form.shippingFee = product.shippingFee;
                that.form.sku = product.sku;

                // 2. 分类
                that.form.productCategories = product.productCategories;
                that._setCategoryName(product.productCategories);

                // 3. Tags
                that.form.productTags = product.productTags;

                that.form.myIncome = product.myIncome;
                that.form.tycoonComment = product.tycoonComment;
                that.form.productPitch = product.productPitch;
                that.form.supplierType = product.supplierType;
                that.form.priceReferenceLink = product.priceReferenceLink;
                that.form.supplierName = product.supplierName;
                that.form.supplierContactName = product.supplierContactName;
                that.form.supplierContactEmail = product.supplierContactEmail;
                that.form.supplierContactPhone = product.supplierContactPhone;
                that.form.supplierWebsiteLink = product.supplierWebsiteLink;
                that.form.shipToCountries = product.shipToCountries;

                // 预售
                that.form.presalePrice = product.presalePrice;
                that.form.presaleTargetCount = product.presaleTargetCount;
                that.form.presaleValidityDays = product.presaleValidityDays;
                if (product.planedStartTime) {
                    that.form.planedStartTime = moment.utc(product.planedStartTime).local().format('YYYY-MM-DDThh:mm');
                }
                that.form.presaleDaysShipStart = product.presaleDaysShipStart;

                setTimeout(function () {
                    that._initDom();
                });

            },
            getProductDetail: function (prodId) {
                var that = this;
                var param = {
                    viewerId: localStorage.getItem('userId'),
                    productId: prodId,
                    LanguageCode: lan
                };

                var url = getBaseUrl() + "api/v6/product?" + $.param(param);
                getAxois(url, "GET", {}).then(function (response) {
                    var product = response.data.Data;
                    that.product = product;
                    //console.log(JSON.stringify(product));
                    that.form.productImageLinks = [];
                    $.map(product.Pictures, function (item) {
                        that.form.productImageLinks.push({
                            pictureUrl: item.PictureUrl,
                            thumbnailUrl: item.ThumbnailUrl
                        });
                    });
                    //数字产品
                    if(product.Download){
                        that.form.productLink = product.Download.DownloadUrl;
                        that.digitalFileName = product.Download.FileName;
                        that.form.priceReferenceLink = "a";
                    }
                    // 视频
                    if (product.SampleDownload) {
                        Video = {
                            DownloadUrl: product.SampleDownload.DownloadUrl,
                            ThumbnailUrl: product.SampleDownload.ThumbnailUrl,
                            DurationSeconds: product.SampleDownload.DurationSeconds
                        };
                        renderVideo(product.SampleDownload.ThumbnailUrl);
                    }

                    that.form.productCategories = [];
                    $.map(product.Categories, function (item) {
                        that.form.productCategories.unshift(item.Id);
                    });
                    that.form.productTags = [];
                    $.map(product.ProductTags, function (item) {
                        that.form.productTags.push(item.Name);
                    });
                    that.form.productName = product.Name;
                    that.form.productDescription = product.FullDescription;
                    that.form.sellingPrice = product.TweebuckPrice;
                    that.form.shippingFee = product.ShippingFee || 0;
                    that.form.sku = product.Sku || '';
                }).catch(function (error) {
                    console.error(JSON.stringify(error));
                });
            },
            submit: function() {
                var that = this;
                var params = {};

                if (Video && Video[0] && Video[0].MediaFileUrl) {
                    this.form.productVideoInfos = [
                        {
                            downloadUrl: Video[0].MediaFileUrl,
                            thumbnailUrl: Video[0].ThumbnailUrl,
                            durationSeconds: Video[0].DurationSeconds
                        }
                    ];
                } else {
                    this.form.productVideoInfos = [
                        {
                            downloadUrl:'',
                            thumbnailUrl: '',
                            durationSeconds: ''
                        }
                    ];
                }

                if (this.product) {
                    params.productId = this.product.Id;
                    if (this.currentType === 'DIGITAL') {
                        if (this.product.Download) {
                            params.productLink = this.product.Download.DownloadUrl;
                        }
                    }
                } else {
                    // 图片
                    if (uploading || imgUploading) {
                        api.toast({
                            msg: MSG.tips.uploadDataTips,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }

                    var pictures = [];
                    $("#uploadImgBox").find('img').each(function (index) {
                        var pic = $(this).data('picture');
                        pic.DisplayOrder = index;
                        pictures.push({
                            "pictureUrl": pic.DownloadUrl,
                            "thumbnailUrl": pic.ThumbnailUrl
                        });
                    });
                    if (pictures.length === 0) {
                        messages(MSG.tips.noPicError, 'error', 'top', 3);
                        return;
                    }
                    this.form.productImageLinks = pictures;

                    // 名字
                    if (!$.trim(this.form.productName)) {
                        messages(MSG.tips.productNameEmpty, 'error', 'top', 3);
                        return;
                    }

                    if (this.form.productName.length > 80) {
                        api.toast({
                            msg: MSG.tips.productNameTooLong,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }

                    // 描述
                    var description = $.trim($('#description').html());
                    if (!description) {
                        messages(MSG.tips.descriptionEmpty, 'error', 'top', 3);
                        return;
                    } else {
                        this.form.productDescription = description;
                    }

                    // 价格
                    if (!this.form.sellingPrice) {
                        messages(MSG.tips.productPriceEmpty, 'error', 'top', 3);
                        return;
                    }
                    if (+this.form.sellingPrice < 1) {
                        messages(MSG.tips.productPriceMin, 'error', 'top', 3);
                        return;
                    }

                    // 预售价格
                    if (!this.form.presalePrice) {
                        messages(MSG.tips.pPresalePrice, 'error', 'top', 3);
                        return;
                    }
                    if (+this.form.presalePrice < 1) {
                        messages(MSG.tips.productPriceMin, 'error', 'top', 3);
                        return;
                    }

                    if (this.currentType === 'PHYSICAL') {

                        // 运费
                        if (this.form.shippingFee === '') {
                            messages(MSG.suggestion.pShippingFee, 'error', 'top', 3);
                            return;
                        }

                        if (+this.form.shippingFee < 0) {
                            messages(MSG.suggestion.pcShippingFee, 'error', 'top', 3);
                            return;
                        }

                    }

                    // 预售数量
                    if (this.form.presaleTargetCount === '') {
                        messages(MSG.suggestion.pPresaleTargetCount, 'error', 'top', 3);
                        return;
                    }

                    // 预售天数
                    if (this.form.presaleValidityDays === '') {
                        messages(MSG.suggestion.pPresaleValidityDays, 'error', 'top', 3);
                        return;
                    }

                    // 预售开始时间
                    // if (this.form.planedStartTime === '') {
                    //     messages(MSG.suggestion.pStartTime, 'error', 'top', 3);
                    //     return;
                    // }

                    // 预售发货天数
                    if (this.form.presaleDaysShipStart === '') {
                        messages(MSG.suggestion.pPresaleDaysShipStart, 'error', 'top', 3);
                        return;
                    }

                    // 类别
                    if (this.form.productCategories && this.form.productCategories.length === 0) {
                        api.toast({
                            msg: MSG.tips.categoryEmpty,
                            duration: 2000,
                            location: 'middle'
                        });
                        return false;
                    }

                    // 标签
                    if (this.form.productTags && this.form.productTags.length === 0) {
                        api.toast({
                            msg: MSG.tips.tag2,
                            duration: 2000,
                            location: 'middle'
                        });
                        return false;
                    }

                }

                // Income
                if (!this.form.myIncome) {
                    messages(MSG.tips.myIncomeEmpty, 'error', 'top', 3);
                    return;
                }

                if (this.currentType === 'DIGITAL') {
                    if (!this.form.productLink) {
                        api.toast({
                            msg: MSG.tips.noProductError,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }
                }

                // var reg = /^http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/;
                // if (/^http(s)/.test(this.form.priceReferenceLink) === false) {
                //     messages(MSG.suggestion.productLinkRight, 'error', 'top', 3);
                // }

                // // AS_SUPPLIER, WITHOUT_SUPPLIER, WITH_SUPPLIER
                //                 supplierType: 'WITHOUT_SUPPLIER',
                if (this.form.supplierType === 'WITH_SUPPLIER' || this.form.supplierType === 'AS_SUPPLIER') {

                    /*
                    supplierName: '',
                    supplierContactName: '',
                    supplierContactEmail: '',
                    supplierContactPhone: '',
                     */
                    // if (!this.form.supplierName) {
                    //     messages(MSG.suggestion.pSupplierName, 'error', 'top', 3);
                    //     return;
                    // }
                    if (!this.form.supplierContactName) {
                        messages(MSG.suggestion.pSupplierContactName, 'error', 'top', 3);
                        return;
                    }
                    if (!this.form.supplierContactEmail) {
                        messages(MSG.suggestion.pSupplierContactEmail, 'error', 'top', 3);
                        return;
                    }
                    if (isEmail(this.form.supplierContactEmail) === false) {
                        messages(MSG.suggestion.pcSupplierContactEmail, 'error', 'top', 3);
                        return;
                    }
                }

                // if (this.form.supplierType === 'AS_SUPPLIER') {
                //     // if (!this.form.sku) {
                //     //     messages(MSG.suggestion.pSku, 'error', 'top', 3);
                //     //     return;
                //     // }
                //     if (!this.form.supplierContactPhone) {
                //         messages(MSG.suggestion.pSupplierContactPhone, 'error', 'top', 3);
                //         return;
                //     }
                //     if (!this.form.supplierWebsiteLink) {
                //         messages(MSG.suggestion.pSupplierWebsiteLink, 'error', 'top', 3);
                //         return;
                //     }
                // }

                // 格式化参数

                params = $.extend({}, params, that.form);

                params.stockQuantity = params.presaleTargetCount;

                if (params.shippingFee === '') {
                    params.shippingFee = 0;
                }

                // 处理可发送的国家
                if ($.isArray(params.shipToCountries) === true) {

                } else if (typeof params.shipToCountries === 'string') {
                    params.shipToCountries = params.shipToCountries.split(',');
                }  else {
                    params.shipToCountries = [];
                }

                if (params.planedStartTime) {
                    params.planedStartTime = moment(params.planedStartTime).format('YYYY-MM-DD HH:mm:ss');
                }

                //console.log('form: ' + JSON.stringify(params));

                that.isRequesting = true;
                loading('show');
                // 发布
                if (this.isEdit === true) {
                    apiPresale.edit("/presales", params).done(function (rep) {
                        //console.log(JSON.stringify(rep));
                        that.isRequesting = false;
                        loading('hide');
                        if (rep.code === 0) {
                            doSuccess();
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                } else {
                    apiPresale.post("/presales", params).done(function (rep) {
                        //console.log(JSON.stringify(rep));
                        that.isRequesting = false;
                        loading('hide');
                        if (rep.code === 0) {
                            doSuccess();
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                }

                function doSuccess() {
                    alert(MSG.tips.enabletoPresaleSuccess, function () {
                        back();
                    });

                    api.closeWin({
                        name: 'selectMyProduct'
                    });

                    api.sendEvent({
                        name: 'productListReload',
                    });

                    api.sendEvent({
                        name: 'myPresaleProductsList',
                    });

                    delete presaleProductDraft[that.currentType];
                    kv.setObject({
                        key: 'presaleProductDraft',
                        value: presaleProductDraft
                    });
                }

            },
            _setFileLabel: function(name) {
                if (name.length > 30) {
                    name = name.substring(0, 30) + '...';
                }
                this.digitalFileName = name;
            },
            openUploadFile: function () { //上传产品
                var that = this;
                api.actionSheet({
                    cancelTitle:  MSG.products.cancel,
                    buttons: [MSG.products.enterLink, MSG.products.UploadFile]
                }, function (ret, err) {
                    var index = ret.buttonIndex;
                    if (index === 1) {
                        api.prompt({
                            buttons: [MSG.general.ok, MSG.general.cancel],
                            text:"https://",
                            type:"url"
                        }, function(ret, err) {
                            var index = ret.buttonIndex;
                            if(index === 1 ){
                                var text = ret.text;
                                if(text && text.indexOf("http") !== -1){
                                    that.form.productLink = text;
                                    that._setFileLabel(MSG.products.linkLabel + ' ' + text);
                                }else{
                                    alert(MSG.products.linkError);
                                }
                            }

                        });
                    } else if (index === 2) {
                        openTabLayout('productUploadPage','','widget://html/products/upload-download.html',{
                            url: {
                                DownloadUrl: that.form.productLink
                            },
                            page: 'add'
                        })
                    } else {
                        return false;
                    }
                });
            },
            openCategoryPage:function () { //分类
                if (this.currentType === 'DIGITAL') {
                    openTabLayout('categoryDigital', '', 'widget://html/products/category-digital.html');
                } else {
                    openTabLayout('categoryPhysical','','widget://html/products/category-physical.html');
                }
            },
            openProductTags:function () { // 打开tag输入
                openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
                    tags:tags?tags.join(','):null
                })
            },
            selectSupplier: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.suggestion.withoutSupplier,
                        callback: function () {
                            that.form.supplierType = 'WITHOUT_SUPPLIER';
                        }
                    },
                    {
                        text: MSG.suggestion.withASupplier,
                        callback: function () {
                            that.form.supplierType = 'WITH_SUPPLIER';
                        }
                    },
                    {
                        text: MSG.suggestion.asASupplier,
                        callback: function () {
                            that.form.supplierType = 'AS_SUPPLIER';
                        }
                    }
                ]);
            },
            openProdDetail: function(){
                var param = {
                    prodId: this.product.Id,
                    userInfo: JSON.stringify(this.product.Owner),
                    tweebaaTag: ''
                };
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            closeWin: function () {
                back();
            },
            editProduct: function () {
                switch (this.product.ProductType) {
                    case 1:
                        openTabLayout('editProduct', this.message.tycoonplace.editProduct, "widget://html/products/form-physical.html", {
                            productId: this.product.Id
                        });
                        break;
                    case 2:
                        openTabLayout('editProduct', this.message.tycoonplace.editProduct, 'widget://html/products/form-digital-new.html', {
                            productId: this.product.Id
                        });
                        break;
                }
            },
            openCountries: function () {
                console.log(this.form.shipToCountries);
                openTabLayout('countries', '', 'widget://html/products/select-countries.html', {
                    countries: this.form.shipToCountries
                });
            }
        }
    });

};

function isEmail(email) {
    var regEmail = /^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/;
    return regEmail.test(email);
}

