
var videoURL,tags,ToTweebaa,AdvisoryReason,ContactEmail,Download;
var uploading = false;
var pictures = [];
var sending = false;
var tagProject = [];
var selectedCategory = [];
var step = "step1";
var prodTitle;
var description;
var tweebucksPrice;
var fileName;

autosize(document.querySelectorAll('textarea'));

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#media [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    //写入文字信息
    $(".replace-text").each(function () {
        $(this).text(MSG.products[$(this).attr('id')]);
    });

    $(".replace-placeholder").each(function () {
        $(this).attr("placeholder",MSG.products[$(this).attr('id')]);
    });

    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false,
    });

    //改变导航右侧按钮
    var nextBtn = MSG.general.next;
    var postBtn = MSG.products.post;
    setRightBtn(nextBtn);
    function setRightBtn(text){
        api.setNavBarAttr({
            rightButtons: [{
                text: text,
                color:'#4578F3',
                fontSize:'15'
            }]
        });
    }

    function validateStep1() {
        prodTitle = $('#title').val();
        description = $('#description').html();

        if(imgUploading || uploading){
            api.toast({
                msg:MSG.tips.uploadDataTips2,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if($("#uploadImgBox").find('img').length === 0){
            api.toast({
                msg: MSG.tips.noPicError,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!prodTitle) {
            api.toast({
                msg: MSG.tips.productNameEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(prodTitle.length>80) {
            api.toast({
                msg: MSG.tips.productNameTooLong,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!tweebucksPrice || tweebucksPrice ==0){
            api.toast({
                msg: MSG.tips.productPriceEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!description || description === '<br>') {
            api.toast({
                msg: MSG.tips.descriptionEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!selectedCategory){
            api.toast({
                msg: MSG.tips.categoryEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!tags){
            api.toast({
                msg: MSG.tips.tag2,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }

        $("#addDigital").removeClass().addClass("step2");
        setRightBtn(postBtn);
        step = "step2"
    }

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {

        if(ret.type ==='right'){
            if(step === "step1"){
                validateStep1();
            }else if(step === "step2"){
                submitEdit()
            }
        }else{
            if(step === "step2"){
                $("#addDigital").removeClass().addClass("step1");
                setRightBtn(nextBtn);
                step = "step1"
            }else{
                confirm(MSG.products.wantExit, function () {
                    back();
                });
            }

        }
    });

    api.addEventListener({
        name: 'uploadedDigitalFile'
    }, function(ret, err) {
        Btns.enterDownload(ret.value.productURL, ret.value.fileName);
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew,#videoBtn,#showVideo').height(imgW);

    //写入分类
    api.addEventListener({
        name: 'category'
    }, function(ret, err) {
        selectedCategory = JSON.parse(ret.value.c);
        //console.log(JSON.stringify(selectedCategory));
    });

    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        // 分类处理
        $('#categoryName').html(ret.value.list.join(', '));
    });

    //写入showroom信息
    api.addEventListener({
        name: 'showroom'
    }, function(ret, err) {
        if(ret.value.toTweebaa){
            ToTweebaa = ret.value.toTweebaa;
            console.log(JSON.stringify(ToTweebaa));
        }
    });

    //写入tag信息
    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tagProject = [];
            tags = ret.value.tags.split(',');
            $('#productTags').empty();
            for(i=0;i<tags.length;i++){
                tagProject.push({"name":tags[i]});
                $('#productTags').append("<span class='product-tags'>"+ tags[i] +"</span>");
            }
            //console.log(JSON.stringify(tagProject));
        }
    });

    var userId = localStorage.getItem('userId');
    var url = getBaseUrl() + "api/users/" + userId + "/products/" + api.pageParam.productId +"?ProductToTweebaaDetailRequired=true&needProductType=true&LanguageCode="+lan;
    loading('show');
    getAxois(url, "GET", {}).then(function (response) {
        //console.log(JSON.stringify(response.data));
        loading('hide');
        var data = response.data;
        tagProject =  data.ProductTags;          // 写入tags
        if(tagProject && tagProject.length>0){
            tags =[];
            for(i=0;i<tagProject.length;i++){
                $('#productTags').append("<span class='product-tags'>"+ tagProject[i].Name +"</span>");
                tags.push(tagProject[i].Name);
            }
            //console.log(JSON.stringify(tags));
        }
        if (data.Categories) {
            console.log(JSON.stringify(data.Categories));
            var categoryNames = [];
            for (var u = 0; u < data.Categories.length; u++) {
                selectedCategory.push(
                    {'Id':data.Categories[u].Id,"L":u+1}
                );
                categoryNames.push(data.Categories[u].Name);
            }
            // 分类处理
            $('#categoryName').html(categoryNames.join(', '));
        }
        ContactEmail = data.ContactEmail;
        AdvisoryReason = data.AdvisoryReason;

        $('#title').val(data.Name);
        // $('#description').val(data.FullDescription);

        $('#description').editor({
            placeholder: MSG.products.description,
            content: data.FullDescription
        });

        $('#price').val(data.TweebuckPrice);
        new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
            console.log('tweebuckValue: ' + tweebuckValue);
            if (tweebuckValue) {
                tweebucksPrice = tweebuckValue.toFixed(4);
            } else {
                tweebucksPrice = '';
            }
        });

        var pic = data.Pictures.reverse();
        var len = pic.length;

        remaining = remaining - len;

        for(i=0; i<len; i++){
            var picData =  {
                "MediaType" : "Picture",
                "FileName" : "testimage.png",
                "MediaFileUrl" : pic[i].MediaFileUrl || pic[i].DownloadUrl,
                "DownloadUrl":pic[i].DownloadUrl,
                "ThumbnailUrl" : pic[i].ThumbnailUrl || pic[i].DownloadUrl
            };
            // var img = '<img data-picture="'+ picData +'" id ="p' + i + '" src=' + pic[i].DownloadUrl + ' alt="image"  style="object-fit: cover;width: 100%; height: 100%;">';
            // $('#uploadImgBox').prepend('<li class="ui-col ui-col-33 img-li" style="height: ' + liWith + 'px"><i class="icon iconfont icon-tuodong drag-handle" ></i><i class="icon icon-tweebaa icon-trash-solid" style="color: #dadada !important;" ></i><div class="media-box">' + img + '</div></div></li>');

            $('#uploadImgBox').prepend(
                getPhotoItem(i, liWith, pic[i].DownloadUrl, false)
            );

            $("#p" + i).data("picture", picData);
        }

        Download = data.Download;  //数字产品
        var productURL = Download.DownloadUrl;
        setFileLabel(Download.DownloadUrl);

        videoURL = data.SampleDownload;//产品展示视频
        if(videoURL){
            $('#videoBtn').addClass('d-none');
            $('#showVideo').removeClass('d-none').find('.media-btn').css("background-image","url("+ videoURL.ThumbnailUrl +")");
            $('.ui-progress').css('opacity',0);
            $('#progress').css('width',0);
        }

        Sortable.create(document.getElementById('uploadImgBox'),
            {
                animation: 150, onEnd: function (e) {
                    picArray = [];
                    $("#uploadImgBox").find('img').each(function () {
                        var pic = $(this).attr('src').split(",")[1];
                        var picJson = {
                            'PictureBinaryBase64': pic,
                            'FileName': 'picture.jpg',
                            'SeoFileName': 'picture.jpg',
                            'MediaType': 'Picture'
                        };
                        picArray.push(picJson);
                    });
                    // console.log(picArray);
                },
                ghostClass:'.img-li',
                handle:'.drag-handle'
            });
    }).catch(function (error) {
        loading('hide');
        console.log(JSON.stringify(error));
    });

};

function setFileLabel(name) {
    if (name.length > 30) {
        name = name.substring(0, 30) + '...';
    }
    $('#digitalFileLabel').text(name);
}

var Btns = {
    openCategoryPage:function () { //分类
        openTabLayout('categoryDigital','','widget://html/products/category-digital.html')
    },
    openProductTags:function () { // 打开tag输入
        openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
            tags:tags?tags.join(','):null
        })
    },
    openUploadProdPage:function () {// 打开上传产品选项
        var U = Download.DownloadUrl ||  "https://";
        api.actionSheet({
            cancelTitle:  MSG.general.cancel,
            buttons: [MSG.products.enterLink, MSG.products.UploadFile]
        }, function (ret, err) {
            var index = ret.buttonIndex;
            if (index === 1) {
                api.prompt({
                    buttons: [MSG.general.ok, MSG.general.cancel],
                    text:U ,
                    type:"url"
                }, function(ret, err) {
                    var index = ret.buttonIndex;
                    if(index === 1 ){
                        var text = ret.text;
                        if(text && text.indexOf("http") !== -1){
                            Download = {
                                "DownloadUrl" : text
                            };
                            setFileLabel(MSG.products.linkLabel + ' ' + text);
                        }else{
                            alert(MSG.products.linkError);
                        }
                    }

                });
            } else if (index === 2) {
                openTabLayout('productUploadPage','','widget://html/products/upload-download.html',{
                    fileName: fileName,
                    url: Download
                })
            } else {
                return false;
            }
        });
    },
    openPrepareShowroomPage:function(){
        openTabLayout('prepareShowroomPage','','widget://html/products/prepare-showroom.html',{
            price:Number($('#price').val()),
            profit:ToTweebaa ? ToTweebaa.TargetTweebuckProfit : null,
            productType:2
        })
    },
    enterDownload:function (url, name) {// 写入产品地址

        if(url ==="null" || url ==="undefined" ){
            Download = '';
        }else{
            Download = {
                "DownloadUrl" : url
            };
        }

        if (name) {
            setFileLabel(name);
        }

        fileName = name;

        console.log(JSON.stringify(Download));
    }

};

//预览上传的视频
function playProdVideo(){
    // api.openWin({
    //     name: 'videoPlayer',
    //     url: 'widget://html/frame/video-player.html',
    //     bounces:false,
    //     bgColor:'#000000',
    //     hideHomeIndicator:true,
    //     slidBackEnabled:false,
    //     animation:{
    //         type:"none",
    //     },
    //     pageParam: {
    //         url: videoURL.DownloadUrl,
    //         pic: videoURL.ThumbnailUrl,
    //         isCache:false
    //     }
    // });
    playVideo(videoURL.DownloadUrl);

}

function submitEdit() {

    if(sending){
        return false;
    }

    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.DisplayOrder = index;
        pictures.push(pic);
    });

    setTimeout(function () {
        var shippingFee = Number($('#shippingFee').val()) ;
        var prodObj = {
            "ProductType":2,
            "Name": prodTitle,
            "En" : {
                "Name" : prodTitle,
                "ShortDescription" : '',
                "FullDescription" : description,
                "AdvisoryReason" : AdvisoryReason
            },
            "Cn" : {
                "Name" : prodTitle,
                "ShortDescription" : '',
                "FullDescription" : description,
                "AdvisoryReason" : AdvisoryReason
            },
            "Quantity": Number($('#quantity').val()),
            "TweebuckPrice": tweebucksPrice,
            "DisplayOrder": 0,
            "OrderMinimumQuantity":  1,
            "ProductTags": tagProject,
            "FullDescription": description,
            "Categories": selectedCategory,
            "ShowOnHomePage": true,
            "Pictures": pictures,
            "CurrencyCode":null,
            "SampleDownload": videoURL,
            "Download" :Download,
            "ContactEmail" :ContactEmail
        };
        sending = true;
        var url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId')+"&productId=" + api.pageParam.productId;
        // console.log(JSON.stringify(prodObj));
        // console.log(JSON.stringify(url));
        loading('show');
        getAxois(url, "PUT", prodObj).then(function (response) {
            // console.log(JSON.stringify(response));
            loading('hide');
            if(response.data.Success){

                api.toast({
                    msg: MSG.tips.updated,
                    duration: 2000,
                    location: 'middle'
                });
                api.sendEvent({
                    name: 'productListReload',
                });
                api.sendEvent({
                    name: 'productInfoReload',
                });
                api.sendEvent({
                    name: 'indexProductListReload',
                });
                api.sendEvent({
                    name: 'workplaceReload',
                    extra: {
                        type: 'product'
                    }
                });
                setTimeout(function () {
                    back();
                },2000);
            }else{
                sending = false;
            }

        }).catch(function (error) {
            api.toast({
                msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                duration: 2000,
                location: 'middle'
            });
            loading('hide');
            sending = false;
        });
    });
}
