apiready = function () {
//进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName:'个人产品详情'});
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var prodId = api.pageParam.prodId;
    var username = localStorage.getItem('userName');

    // $('.shopping.addShopping-bar').css({"height" :55 + api.safeArea.bottom + "px"});
    $('.layout-form .form-btns').css({"padding-bottom": (0.8 + getSafeHeight()) + "rem"});
    /*
    var noData ='    <div class="text-center"  style="margin-top:-4rem;position: relative;">\n' +
        '        <p class="text-center text-dark-gray text-title" style="position: absolute;font-size: 1.8rem; top:30%;left: 5%">'+ $.i18n.prop('productGone') +'</p>\n' +
        '        <img src="../../image/404.png" class="img-fluid mt-3" style="width: 90%;" alt="">\n' +
        '        <p class="text-blue mt-4" onclick="back()">'+ $.i18n.prop('clickMeToBack') +'</p>\n' +
        '    </div>';
    if(!prodId){
        $('body').append(noData);
        return
    }
     */

    // console.log('prodId: ' + prodId);

    api.setTabLayoutAttr({
        hideNavigationBar: true
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        //console.log(JSON.stringify(ret));
        if(ret.type ==='right'){
            productDetail.preShare();
        }else{
            productDetail.setAnalyticsInfo();
        }
    });


    // $('.addShopping-bar').height((api.safeArea.bottom + 40) + 'px');

    var kv = api.require('snKVStorage');
    var hasCache = kv.has({
        key: 'userProdDetail'
    });
    var USERPORDDETAIL = {};
    var cacheProductData;
    if(hasCache){
        USERPORDDETAIL = kv.getObject({
            key: 'userProdDetail',
        });
        cacheProductData = USERPORDDETAIL['userpd' + prodId];
    }

    // 1. hasCache = null; cacheProductData = null;
    // hasCache = null;
    // cacheProductData = null;
    // 2. hasCache != null; cacheProductData = null;
    // cacheProductData = null;
    // 3. hasCache != null; cacheProductData != null;

    api.addEventListener({
        name: 'changeShippingAddress'
    }, function (ret, err) {
        productDetail.selectedAddress = ret.value.address
    });

    api.addEventListener({
        name: 'reloadAddressList'
    }, function(ret, err) {
        productDetail.getAddressList();
    });

    api.addEventListener({
        name: 'reCheckCondition'
    }, function(ret, err) {
        productDetail.checkFreeCondition();
    });

    api.setWinAttr({
        name: 'productDetail',
        bounces: false
    });

    var time = 0;
    function setTime() {
        // console.log(time);
        setTimeout(function () {
            time++;
            setTime();
        },1000)
    }
    setTime();

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var productDetail = new Vue({
        el: '#productDetail',
        data: {
            appleCheck: appleCheck,
            userInfo: JSON.parse(api.pageParam.userInfo) || {},
            productData: cacheProductData ? cacheProductData : '',
            switchImg: true,
            shoppingCartCount: 0,
            myID: localStorage.getItem('userId'),
            viewerId:localStorage.getItem('userId'),
            sampleType:'',
            downloadProductType:'',
            viewTime:0,
            thisCurrencyCode:'',
            exPrice:'',
            defaultCurrency: localStorage.getItem('primaryCurrencyCode'),
            tweebaaTag:api.pageParam.tweebaaTag,
            totalTweebucks:0,
            buyQuantity:1,
            addressData:[],
            selectedAddress: null,    // 选中的地址
            needPayTweebucks:0,
            needPayTweebucksText: 0,
            totalOfProducts:0,
            Address:'',
            isTranslate:false,
            shortDescriptionText:'',
            fullDescriptionText:'',
            imageShow:false,
            pics:[],
            clientWidth: document.body.clientWidth || document.documentElement.clientWidth,
            clientHeight: document.body.clientHeight || document.documentElement.clientHeight,
            scrollTop: -1,
            showCenterTabs: false,
            detailScrollTop: 0,     // 详情分界线
            activeClass: 'overview',
            /*
            {
                "ProductToTweebaaId": 11,
                "ProductToTweebaaGuid": null,
                "ProdStoreOwnerCmt": "我加个文字描述",
                "ProdStoreCmt_Pictures": null,
                "ProdStoreCmt_Video": {
                    "Id": 9,
                    "Guid": "87e409dd-8bb8-4808-92e7-713485056d3d",
                    "CreatedOnUtc": "2020-04-17T09:15:52.207",
                    "DisplayOrder": 0,
                    "MediaType": "Video",
                    "FileName": "showcaseVideo",
                    "MediaFileUrl": null,
                    "DownloadUrl": null,
                    "ThumbnailUrl": null
                }
            }
             */
            showcaseData: null,
            isShowVideoThumbnail: true,   // 是否显示视频缩略图
            assessData: null,
            presaleStatus:'',
            shipToCountries:'',
            now: null,
            endTime: null,
            countDownTimeId: null,
            checkedCondition:'', //当前用户完成的条件信息
            leftTime: '', //免费产品剩余购买时间
            progressConditions: '', //达成的条件数量显示 （分数）
            canBeFree:false,   //是否可以免费购买，判断条件达成以及时间和可购买的数量
            isCompletedCondition:false, //免费调整是否达成
            message:MSG,
        },
        watch:{
            buyQuantity:function () {
                this._doTotal(this.productData);
            },
            now: function(newVal, oldVal) {
                if (newVal && this.endTime) {
                    var m1 = newVal;
                    var m2 = this.endTime;

                    var DIFF = m2.diff(m1, 'seconds');

                    var du = moment.duration(DIFF, 'seconds'),
                        day = m2.diff(m1, 'days'),
                        hours = prefixInteger(du.get('hours'),2),
                        mins = prefixInteger(du.get('minutes'),2),
                        ss = prefixInteger(du.get('seconds'),2);
                    if (day<=0 && hours<=0 && mins<=0 && ss<=0) {
                        this.canBeFree = false;
                        this.productData.BusinessType = 0;
                        window.clearInterval(this.countDownTimeId);
                        //this.getProductDetail(this.prodId);
                    }else {

                        var span = '<span class="p-2 bk-white text-red" style="border-radius: 2px">';
                        this.leftTime = span + day + '</span>' +
                            '<span class="p-2"> ' + MSG.freeProduct.day +'</span>' + span + hours + '</span>:' + span + mins + '</span>:'+ span + ss +'</span>';
                    }
                }
                function prefixInteger(num, n) {
                    return (Array(n).join('0') + num).slice(-n);
                }
            },
            scrollTop: function(newVal, oldVal) {
                if (newVal < this.detailScrollTop) {
                    this.activeClass = 'overview';
                } else {
                    this.activeClass = 'detail';
                }
            }
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            fixed1:function (value) {
                return Number(value).toFixed(1);
            },
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
            presaleDate:function (value) {
                return moment.utc(value).local().format('MM-DD');
            },
            presaleTime:function (value) {
                return moment.utc(value).local().format('HH:mm');
            },
            shipToCountries:function (value) {
                var shipToCountries = '';
                for(i = 0; i < callingCode.length; i++){
                    if(value.indexOf(callingCode[i].code) !== -1){
                        shipToCountries = shipToCountries + " ";
                    }
                }
                return shipToCountries;
            }
        },
        mounted: function () {
            this.getProductDetail(prodId);
            //this.getShoppingCartCount();
            this.getAddressList();
            this.getViewTime();
            this.getTweebucks();
            this.getProductAssess();
            this._initCache();
            this.sendTime();
        },
        methods: {
            sendTime: function(){

                setTimeout(function (){
                    apiFree.post("/v1/product/free/log/time", {
                        prodId: prodId,
                        userId: localStorage.getItem('userId')
                    }).done(function (rep) {
                        api.sendEvent({
                            name: 'reCheckCondition',
                        });

                    });
                }.bind(this), 30000)
            },
            checkFreeCondition:function(){
                var that = this;
                var params ={
                    "buyerId":this.myID,
                    "buyerName":localStorage.getItem('userName'),
                    "prodId":prodId,
                    "sellerId":this.productData.Owner.Id
                };
                //console.log(JSON.stringify(params));
                apiFree.get("/v1/product/free/check", params).done(function (rep) {
                    console.log(JSON.stringify(rep));

                    that.isCompletedCondition = rep.data.status;
                    that.checkedCondition = rep.data;
                    var buyerCondition = rep.data.buyerCondition.split('');
                    var sellerCondition = rep.data.sellerCondition.split('');

                    var info = that.productData.FreeSaleInfo;
                    if(rep.data.status && (info.FreeSaleQuantityLimit === -1 || info.FreeSaleQuantityLimit > info.FreeSaleEndQuantity)){
                        that.canBeFree = true;
                    }
                    if(!rep.data.status){
                        var needCondition = 0;
                        var completeCondition = 0;
                        sellerCondition.forEach(function(condition, index) {
                            if(condition === '1' ){
                                needCondition ++;
                                if(buyerCondition[index] === '1'){
                                    completeCondition ++;
                                }
                            }
                        });

                        that.progressConditions = completeCondition + '/' + needCondition;
                    }


                });
            },
            playPicture: function(innerIndex, pictures) {
                var pics = [];
                $.map(pictures, function (item, index) {
                    pics.push(item.DownloadUrl);
                });
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: innerIndex,
                    zoomEnabled: true,
                    gestureClose: true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            playVideo: function(url) {
                playVideo(url);
            },
            toTranslate: function(item) {
                if (item.isTranslate === false) {
                    loading('show');
                    item.isTranslate = true;
                    translate(item.comment, function (result) {
                        loading('hide');
                        item.commentText = result;
                    });
                } else {
                    item.isTranslate = false;
                    item.commentText = item.comment;
                }
            },
            _formatList: function(list) {
                $.map(list, function (item, index) {
                    item.isTranslate = false;
                    item.commentText = item.comment;
                });
                return list;
            },
            getProductAssess: function() {
                apiAssess.get('/v1/api/evaluate/get/' + prodId).done(function (rep) {
                    if (rep.code === 0) {
                        var assessData = rep.data;
                        assessData.list = this._formatList(assessData.list);
                        this.assessData = assessData;
                    } else {
                        api.toast({
                            msg: rep.responseJSON.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            toLikeAssess: function(assess) {
                var param = {
                    "evaluateId": assess.evaluateId,
                    "productId": prodId,
                    "userId": this.myID
                };
                loading('show');
                apiAssess.post('/v1/api/evaluate/like', param).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        assess.likeNum++;
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        loading('hide');
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            goAssessList: function () {
                openTabLayout('product-assess-list', MSG.assess.title, 'widget://html/products/product-assess-list.html', {
                    prodId: prodId,
                    average: this.assessData.average,
                    totalCount: this.assessData.totalCount
                });
            },
            _doTotal: function(productData) {
                this.totalOfProducts = (this.buyQuantity * productData.TweebuckPrice ).toFixed(2);
                if (productData.ShippingFee) {
                    this.needPayTweebucks = (this.buyQuantity * (productData.TweebuckPrice +  productData.ShippingFee)).toFixed(2);
                } else {
                    this.needPayTweebucks = (this.buyQuantity * productData.TweebuckPrice).toFixed(2);
                }
                this.needPayTweebucksText = getExchangeText(this.needPayTweebucks);
            },
            _initCache: function() {
                var that = this;

                // 如果缓存有数据，那么直接绑定scroll事件
                if (cacheProductData) {

                    this._doTotal(cacheProductData);

                    // 初始化轮播
                    setTimeout(function () {
                        initialize();
                    }, 0);

                    // 如果是限时免费产品，那么启动倒计时
                    if (cacheProductData.BusinessType === 2 && cacheProductData.FreeSaleInfo.FreeSaleStopUtc) {
                        that.endTime = moment.utc(cacheProductData.FreeSaleInfo.FreeSaleStopUtc);
                        that._doRemainingTime();
                    }

                    // showcase
                    if (cacheProductData.ProductType === 1 && cacheProductData.LatestProductToTweebaa) {
                        this.getOwnerCommentDetails(cacheProductData.LatestProductToTweebaa.ProductToTweebaaId, function () {
                            setTimeout(function () {
                                that._initScroll();
                            }, 0);
                        });
                    } else {
                        setTimeout(function () {
                            that._initScroll();
                        }, 0);
                    }


                }
            },
            _initScroll: function() {
                var that = this;
                this.detailScrollTop = $(this.$refs.detail).offset().top;
                // console.log('this.detailScrollTop: ' + this.detailScrollTop);
                // console.log('this.clientHeight: ' + this.clientHeight);
                if ($(this.$refs.detail).height() >= this.clientHeight) {
                    this.showCenterTabs = true;
                    // console.log('this.showCenterTabs: ' + this.showCenterTabs);
                }
                // scroll监听
                var $document = $(document);
                $document.unbind('scroll').bind('scroll', function() {
                    var t1 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t1 ===== ' + t1);
                    that.scrollTop = t1;
                });
            },

            toScrollPage: function(key) {
                var result = 0;
                if (key === 'detail') {
                    result = this.detailScrollTop;
                }
                $('html, body').animate({
                    'scrollTop': result
                }, 400);
            },
            /**
             * 展示更多相关
             */
            toggleShowMoreRalated: function() {
                this.isShowOthers = !this.isShowOthers;
            },
            // 针对有截止时间的活动，需要计算剩余时间
            _doRemainingTime: function() {
                var that = this;
                var nowDate = moment().utc();
                if (nowDate >= this.endTime) {
                    return;
                }
                this.now = moment().utc();

                //定时更新当前时间
                this.countDownTimeId = window.setInterval(function() {
                    that.now = moment.utc();
                },1000);
            },
            ctrlQuantity:function (type) {
                if(type ==='add' && this.productData.ProductType !==2){
                    this.buyQuantity ++;
                }else{
                    if(this.buyQuantity >= 2){
                        this.buyQuantity --;
                    }
                }
            },
            /**
             * 获取自己Tycoon空间 某产品库产品 的comment 和相关图片视频链接
             */
            getOwnerCommentDetails: function (productToTweebaaId, callback) {
                var that = this;
                var url = getBaseUrl() + 'api/v2/tweebaa-product/tycoon/OwnerCommentDetails?UserId=' + this.userInfo.Id + '&ProductToTweebaaId=' + productToTweebaaId;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    var data = response.data;
                    if (data.ProdStoreCmt_Pictures && data.ProdStoreCmt_Pictures.length > 0) {
                        data.picUrls = [];
                        data.ProdStoreCmt_Pictures.map(function (item, index) {
                            data.picUrls.push(item.DownloadUrl);
                        });
                    }
                    data.ProdStoreOwnerCmtText = '';    // 翻译后的内容
                    that.showcaseData = data;
                    callback();
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            getTweebucks:function () {
                var that = this;
                var url = getBaseUrl() + "api/tweebucks/v1/balance?UserId=" + this.myID;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.totalTweebucks = response.data.Data.CompletedSubtotal;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getProductDetail: function (prodId) {
                var that = this;
                // var url = getBaseUrl() + "api/users/" + that.viewerId + "/products/" + prodId + "?ProductToTweebaaDetailRequired=true&needProductType=true&LanguageCode="+lan;
                var url = getBaseUrl() + "api/v6/product?viewerId="+ that.viewerId + "&productId=" + prodId +"&LanguageCode=" + lan ;

                if(that.productData){
                    setTimeout(function () {
                        initialize();
                    },100);
                }
                getAxois(url, "GET", {}).then(function (response) {
                    var newRep = response.data.Data;
                     //console.log(JSON.stringify(response));

                    that.productData = newRep;
                    // console.log(JSON.stringify(that.productData));
                    // 判断预售状态
                    var info = that.productData.PreSaleInfo;
                    if(info){
                        var startTime = moment(info.PreSaleStartUtc ).local().format('YYYY-MM-DD HH:mm:ss');
                        var endTime = moment(info.PreSaleStopUtc ).local().format('YYYY-MM-DD HH:mm:ss');
                        var now = moment().format('YYYY-MM-DD HH:mm:ss');
                        if(moment(now).isBefore(endTime, 'second') && moment(now).isAfter(startTime, 'second')){
                            that.presaleStatus = 'doing'
                        }
                        else if(moment(now).isAfter(endTime, 'second') && info.PreSaleEndQuantity >= info.PreSaleTargetQuantity ){
                            that.presaleStatus = 'pass'
                        }else if(moment(now).isAfter(endTime, 'second') && info.PreSaleEndQuantity < info.PreSaleTargetQuantity ){
                            that.presaleStatus =  'fail'
                        }

                        //输出发货国家
                        for(l = 0; l < callingCode.length; l++){
                            if(info.CountryList.indexOf(callingCode[l].code) !== -1){
                                that.shipToCountries = that.shipToCountries + " " + callingCode[l][lan];
                            }
                        }

                    }

                    var Pics = that.productData.Pictures;
                    for(i=0;i<Pics.length;i++){
                        that.pics.push(Pics[i].PictureUrl || Pics[i].ThumbnailUrl);
                    }
                    // that.thisCurrencyCode = response.data.CurrencyCode;
                    if(newRep.Download){
                        var videos = ['mp4','mpg','mov','wmv','m3u8'];
                        var pics = ['jpg','jpeg','raw','png','bmp'];
                        var audios =['amr','wav','mp3','m4a'];
                        var text =['txt','doc','docx','xlsx','xls','pdf'];

                        var key = newRep.Download.DownloadUrl.lastIndexOf(".");
                        var xName = (newRep.Download.DownloadUrl.substr(key+1)).toLowerCase();

                        if (videos.indexOf(xName) !== -1) {
                            that.downloadProductType = 'video'
                        } else if (pics.indexOf(xName) !== -1) {
                            that.downloadProductType = 'image'
                        } else if (audios.indexOf(xName) !== -1) {
                            that.downloadProductType = 'audios'
                        } else if (text.indexOf(xName) !== -1) {
                            that.downloadProductType = 'text';
                        }else {
                            that.downloadProductType = 'other'
                        }
                    }

                    var datas = {};
                    if(hasCache){
                        datas = kv.getObject({
                            key: 'userProdDetail',
                        });
                    }
                    datas['userpd'+prodId] = that.productData;
                    var USERPORDDETAILS = kv.setObject({
                        key: 'userProdDetail',
                        value:datas
                    });

                    cacheProductData = newRep;
                    that._initCache();

                    if(that.productData.BusinessType === 2 && (that.productData.Owner.Id != that.viewerId)){
                        that.checkFreeCondition();//检查免费条件
                    }

                }).catch(function (error) {

                    console.log(JSON.stringify(error));
                    // $('body').append(noData);
                });
            },
            getAddressList:function(){
                var that = this;
                var userId =  localStorage.getItem('userId');
                var url = getBaseUrl() + "api/users/"+ userId +"/addresses";
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    if(response.data.length>0){
                        that.addressData = response.data;
                        for(i=0; i<that.addressData.length;i++){
                            if(that.addressData[i].IsPrimaryShipping){
                                that.selectedAddress = that.addressData[i];
                            }
                        }
                        // 如果没有默认地址，选择第一个地址作为默认地址
                        if ($.isEmptyObject(that.selectedAddress) === true) {
                            that.selectedAddress = that.addressData[0];
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            selectAddressBtn:function(){
                if(this.addressData.length !==0){
                    openTabLayout('addressList','','widget://html/business/address-list.html',{
                        selectedAddress:true
                    });
                }else{
                    openTabLayout('addAddress','','widget://html/business/add-address.html', {
                        addressData: {}
                    });
                }

            },
            openPicture:function(index){
                var that = this;
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: that.pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            // changeCurrency:function () {
            //     var token = localStorage.getItem('access_token');
            //     if (token) {
            //         var that =  this;
            //         var url = getBaseUrl() + "/api/exchange/get-rate?from="+ that.thisCurrencyCode +"&to="+ localStorage.getItem('primaryCurrencyCode');
            //         //console.log(url);
            //         getAxois(url, "GET", {}).then(function (response) {
            //             //console.log(JSON.stringify(response.data));
            //             that.exPrice =  (that.productData.Price * response.data).toFixed(2);
            //         }).catch(function (error) {
            //         });
            //     }
            // },
            getViewTime:function(){
                var that = this;
                var url = getBaseUrl() + "api/data-analytics/get-basic-data/"+ this.userInfo.Id +"/product/" + prodId;
                getAxois(url, "GET", {}).then(function (response) {
                    if(response.data.Success){
                        that.viewTime = response.data.DataAnalytics.ViewCount;
                    }
                }).catch(function (error) {
                    loading('hide');

                });
            },
            switchImgVideo: function (type) {
                this.switchImg = type === 'img';
                setTimeout(function () {
                    initialize();
                }, 0);
            },
            preShare: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBar();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    }
                ]);
            },
            toRepostChatPage: function() {
                var content = this.productData.Name.replace(REG_SHARE_FILTER," ");
                var title   = (this.userInfo.StoreName || this.userInfo.Name) + MSG.chat.productInChat;
                var thumbnail = this.productData.Pictures && this.productData.Pictures[0]
                    && (this.productData.Pictures[0].ThumbnailUrl || this.productData.Pictures[0].PictureUrl);
                openShareToChats({
                    title: title,
                    description: content,
                    imageUrl: thumbnail,
                    extra: {
                        textType: 'product-tycoonplace',
                        prodId: api.pageParam.prodId,
                        userInfo: api.pageParam.userInfo,
                        countryCode: api.pageParam.countryCode,
                        userId: this.productData.Owner.Id,
                        userPortrait: this.productData.Owner.ThumbnailAvatarUrl,
                        storeName: this.productData.Owner.StoreName
                    }
                });
            },
            openShareBar:function(){
                var content = this.productData.Name.replace(REG_SHARE_FILTER," ");
                var title   = (this.userInfo.StoreName || this.userInfo.Name) + MSG.chat.productInChat;
                // if(title && title.length>50){
                //     title = title.slice(0,50) + '...';
                // }

                var ShareUrl = shareH5Host + '/html/porduct.html?prodid=' + this.productData.Id
                    + '&userid=' + this.productData.Owner.Id
                    + "&shareid="+localStorage.getItem('userName')
                    + '&page=pd';
                // console.log(ShareUrl);
                // console.log(JSON.stringify(this.userInfo));

                new OpenShareBox(ShareUrl,title,content,this.userInfo.UserName,this.productData.ProductGuid,'prod',this.productData.Owner.ThumbnailAvatarUrl,this.productData.ProductGuid);
            },
            showTranslation:function(){
                var that = this;
                if(that.productData.Store){
                    that.isTranslate = true;
                    return;
                }
                loading('show');
                var url = getBaseUrl() + '/api/v2/translation';

                // 翻译摘要
                // var paramStr = {
                //     "q":  $('#shortDescription').text(),
                //     "LanguageCode": lan,
                // };
                // getAxois(url, "POST", paramStr).then(function (response) {
                //     that.shortDescriptionText = response.data.TranslatedText;
                // }).catch(function (error) {
                //     console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                // });



                if (this.showcaseData && this.showcaseData.ProdStoreOwnerCmt) {
                    var paramStr2 = {
                        "q": this.showcaseData.ProdStoreOwnerCmt,
                        "LanguageCode": lan,
                    };
                    getAxois(url, "POST", paramStr2).then(function (response) {
                        that.showcaseData.ProdStoreOwnerCmtText = response.data.TranslatedText;
                        loading('hide');
                    }).catch(function (error) {
                        console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                    });
                }else{
                    //翻译详情

                    var paramStr1 = {
                        "q": that.productData.FullDescription,
                        "LanguageCode": lan,
                    };
                    getAxois(url, "POST", paramStr1).then(function (response) {
                        that.fullDescriptionText = response.data.TranslatedText;
                        loading('hide');
                        that.isTranslate = true;
                    }).catch(function (error) {
                        console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                    });
                }
            },
            originalText:function(){
                this.isTranslate = false;
            },
            openDigitalProduct:function(){
                var that= this;
                var downloadManager = api.require('downloadManager');
                var url = that.productData.Download.DownloadUrl;
                //console.log(url);
                var fileType;
                var prod = that.productData;
                var prodName = prod.Name;
                var prodId = prod.Id;
                var pic = prod.FeaturedPicture.ThumbnailUrl;
                if(url){
                    var videos = ['mp4','mpg','mov','wmv','m3u8'];
                    var pics = ['jpg','jpeg','raw','png','bmp'];
                    var audios =['amr','wav','mp3','m4a'];
                    var text =['txt','doc','docx','xlsx','xls','pdf'];
                    var links = ['com', 'cn', 'io', 'pro'];

                    var key = url.lastIndexOf(".");
                    var xName = (url.substr(key+1)).toLowerCase();

                    if (videos.indexOf(xName) !== -1) {
                        fileType = 'video'
                    } else if (pics.indexOf(xName) !== -1) {
                        fileType = 'image'
                    } else if (audios.indexOf(xName) !== -1) {
                        fileType = 'audios'
                    } else if (text.indexOf(xName) !== -1) {
                        fileType= 'text';
                    }else {
                        fileType = 'other'
                    }
                }

                if(fileType ==='audios'){

                    downloadManager.query({
                    }, function(ret, err) {
                        if (ret) {
                            var hasDownload,downloadData;
                            console.log(JSON.stringify(ret));
                            if(!ret.data){
                                downloadData = [];
                            }else{
                                downloadData = ret.data;
                            }

                            for(var i = 0; i < downloadData.length; i++){
                                if(downloadData[i].title.split('##')[1] == prodId){
                                    hasDownload = downloadData[i];
                                    break;
                                }
                            }

                            setTimeout(function () {
                                if(hasDownload){
                                    openDigitalProd(hasDownload.savePath,fileType,prodName,prodId,pic);
                                }else{
                                    dialog({
                                        title: '',
                                        content: MSG.tips.needDownload,
                                        primaryText: MSG.general.download,
                                        asideText: '',
                                        onClose: "show",
                                        onWarning: function() {
                                        },
                                        onPrimary: function () {
                                            downloadProdManager(url,prodName,prodId,xName,pic,fileType,true);
                                        }
                                    });

                                }
                            })
                        }
                    });
                }else if(fileType ==='video'){
                    openDigitalProd(url,fileType,prodName,prodId,pic);
                }else if(fileType ==='text'){
                    if(xName === 'pdf'){
                        openDigitalProd(url,'pdf',prodName,prodId,pic);
                    }else{
                        openDigitalProd(url,'other',prodName,prodId,pic,xName);
                    }
                }else if(fileType ==='image'){
                    openDigitalProd(url,fileType,prodName,prodId,pic);
                }else{
                    api.openApp({
                        iosUrl: url,
                        androidPkg: 'android.intent.action.VIEW',
                        mimeType: 'text/html',
                        uri: url
                    });
                }

            },
            // openSample:function(){
            //     var url= this.productData.DigitalSampleDownload.DownloadUrl;
            //     var fileType;
            //     if(this.productData.DigitalSampleDownload){
            //         var videos = ['.mp4','.mpg','.mov','.wmv','.m3u8'];
            //         var pics = ['.jpg','.jpeg','.raw','.png','bmp'];
            //         var audios =['.amr','.wav','.mp3','.m4a'];
            //         var text =['.txt','.doc','.docx','.xlsx','.xls','.pdf'];
            //
            //         var xName = (this.productData.DigitalSampleDownload.ContentType).toLowerCase();
            //         if (videos.indexOf(xName) !== -1) {
            //             fileType = 'video'
            //         } else if (pics.indexOf(xName) !== -1) {
            //             fileType = 'image'
            //         } else if (audios.indexOf(xName) !== -1) {
            //             fileType = 'audios'
            //         } else if (text.indexOf(xName) !== -1) {
            //             fileType = 'text';
            //         }else {
            //             fileType = 'other'
            //         }
            //     }
            //
            //     if(fileType ==='image'){
            //         productDetail.imageShow = true;
            //         var UIPhotoViewer = api.require('UIPhotoViewer');
            //         UIPhotoViewer.open({
            //             images: [url],
            //             placeholderImg: 'widget://images/lost-img.jpg',
            //             bgColor: '#000',
            //             zoomEnabled:true,
            //             gestureClose:true
            //         },function (ret,err) {
            //             if (ret.eventType === 'click' ) {
            //                 UIPhotoViewer.close();
            //                 productDetail.imageShow = false;
            //             }
            //         });
            //     }else if(fileType ==='video' || fileType ==='audios'){
            //         openMedia(url,fileType);
            //     }else {
            //         loading('show');
            //         api.download({
            //             url: url,
            //             report: true,
            //             cache: true,
            //             allowResume: true
            //         }, function(ret, err) {
            //             if (ret.state == 1) {
            //                 loading('hide');
            //                 var docInteraction = api.require('docInteraction');
            //                 docInteraction.open({
            //                     path: ret.savePath
            //                 }, function(ret, err) {
            //
            //                 });
            //             }
            //         });
            //     }
            // },
            // copyDownloadLink:function(){
            //     var clipBoard = api.require('clipBoard');
            //     clipBoard.set({
            //         value: this.productData.Download.DownloadUrl
            //     }, function (ret, err) {
            //         if (ret) {
            //             api.toast({
            //                 msg: $.i18n.prop('copied'),
            //                 duration: 2000,
            //                 location: 'middle'
            //             });
            //         }
            //     });
            // },
            /**
             * 购买成功的回调
             * @private
             */
            _doBuySuccess: function(orderId) {
                var that = this;
                alert(MSG.payment.paymentSuccess, function () {
                    openTabLayout('purchasesList', that.message.productDetail.purchases, 'widget://html/business/purchases-list.html');
                    // 重新获取产品详情
                    that.getProductDetail(prodId);
                    // 重新获取余额
                    that.getTweebucks();
                });

                // 给卖家发送消息
                var userName = this.userInfo.UserName;
                postNotify(userName, MSG_TYPE_ORDER, {
                    Type: 'orderSelled',
                    AvatarUrl: localStorage.getItem('thumbnail'),
                    StoreName: localStorage.getItem('storename'),
                    UserId: localStorage.getItem('userId'),
                    OrderId: orderId,
                    ProductPrice: this.productData.TweebuckPrice,
                    ProductName: this.productData.Name,
                    ProductThumbnailUrl: this.productData.FeaturedPicture.ThumbnailUrl || this.productData.FeaturedPicture.PictureUrl
                });
            },
            goOrderPage: function(){
                var product = this.productData;
                var param = {
                    id: product.Id,
                    price: product.TweebuckPrice,
                    shippingFee: product.ShippingFee,
                    type: product.ProductType,
                    name: product.Name,
                    thumbnailUrl: product.FeaturedPicture.ThumbnailUrl || product.FeaturedPicture.PictureUrl
                };

                // 如果发布者是tweebaa，那么传toTweebaaId
                if (product.Owner.Id === 1) {
                    param.toTweebaaId = product.LatestProductToTweebaa.ProductToTweebaaId;
                } else {
                    param.seller = this.userInfo;
                    param.toTweebaaId = null;
                }

                openTabLayout("buyNow", this.message.productDetail.yourOrder, 'widget://html/tproducts/buynow.html', param);
            },
            freeGet:function(){
                var that = this;
                if(this.canBeFree){
                    var params ={
                        "buyerId":parseInt(this.myID),
                        "buyerName":localStorage.getItem('userName'),
                        "sellerId":this.productData.Owner.Id,
                        "prodId":prodId
                    };
                    loading("show");
                    apiFree.post("/v1/product/free/purchase", params).done(function (rep) {
                        loading("hide");
                        if (rep.code === 0) {
                            that._doBuySuccess(rep.data);
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                }else{
                    confirmBox(that.message.freeProduct.cannotFree, MSG.general.cancel,  MSG.general.ok,'error');
                    $('.dialog-box').find('button').on('click',function (e) {
                        $('.dialog-box').remove();

                        var index = $(this).attr('id');
                        if (index === 'btn-2') {
                            that.buyNowBtn();
                        }
                    });
                }


            },
            buyNowBtn:function(){
                var that = this;

                if(this.appleCheck){ //only for check
                    var paypal = api.require('paypal');

                    paypal.pay({
                        currency: 'USD',
                        price: that.needPayTweebucks,
                        description: this.productData.Name + ' '+ MSG.general.quantity +':' + that.buyQuantity + ' ID:' + that.myID ,
                        mode: 'production'
                    }, function(ret) {
                        that.loading = false;
                        if (ret.state === 'success') {
                            that._doBuySuccess(that.productData.Id);
                        }else{
                            alert(MSG.payment.paymentError);
                        }
                    });

                    return;
                }

                if(this.myID){

                    // 如果推主是tweebaa，那么直接进入直接下单页
                    if (this.userInfo.Id === 1) {
                        this.goOrderPage();
                        return;
                    }

                    $('.ui-actionsheet').addClass('show');

                }else{
                    openLogin();
                }

            },
            buyNow:function(){
                var that = this;
                if(this.needPayTweebucks > this.totalTweebucks){
                    api.toast({
                        msg: MSG.tweebucks.YourBalanceNotEnough,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                // 如果是实体产品，需要判断是否有收货地址
                if (this.productData.ProductType === 1 && !this.selectedAddress) {
                    api.toast({
                        msg: this.message.productDetail.emptyAddAdress,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                // 二次确认
                confirmBox(this.message.productDetail.confirmBuy, this.message.general.cancel, this.message.general.ok);
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    //console.log(index);
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        that.cancelBtn();
                        loading('show');
                        var paramStr = {
                            "AddressId": that.selectedAddress ? that.selectedAddress.Id : '',
                            "BuyerId": that.myID,
                            "Guid": localStorage.getItem('userGuid'),
                            "ProductId": prodId,
                            "Quantity": that.buyQuantity,
                            "SellerId": that.userInfo.Id,
                        };
                        var url = getBaseUrl() + "api/tweebucks/v1/order";
                        getAxois(url, "POST", paramStr).then(function (response) {
                            //console.log(JSON.stringify(response));
                            loading('hide');
                            if(response.data.Code === 0){
                                // location.reload();
                                that._doBuySuccess(response.data.Data.Orderid);
                            }else if(response.data.Code === 50002){
                                messages("T豆冻结", 'error', 'top', 3);
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                        });
                    }
                });
            },
            cancelBtn:function(){
                $('.ui-actionsheet').removeClass('show');
            },
            addShoppingCart: function () {
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                var that = this;
                if (token) {
                    var userId = localStorage.getItem('userId');
                    var storeId = this.userInfo.StoreId;
                    var productId = this.productData.Id;
                    var paramStr = {"buyerId" : userId,"StoreId": storeId, "ProductId": productId, "Quantity": 1};
                    var url = getBaseUrl() + "api/v2/shopping-cart";
                    $('.ui-loading').removeClass('invisible');
                    getAxois(url, "POST", paramStr).then(function (response) {
                        //console.log(JSON.stringify(response));
                        $('.ui-loading').addClass('invisible');
                        that.getShoppingCartCount();
                    }).catch(function (error) {
                        console.log(JSON.stringify(error));
                    });
                } else {
                    openLogin();
                }
            },
            getShoppingCartCount: function () {
                var that = this;
                var userId = localStorage.getItem('userId');
                var url = getBaseUrl() + "api/users/" + userId + "/shopping-cart/count";
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                if (token) {
                    getAxois(url, "GET", {}).then(function (response) {
                        that.shoppingCartCount = response.data;
                        loading('hide');
                    }).catch(function (error) {
                    });
                }
            },
            chatToUser: function () {
                var chatID = localStorage.getItem('chatID');
                if (chatID) {
                    var userinfo = this.userInfo;
                    var userId = userinfo.UserName + '@new';
                    var content = this.productData.Name.replace(REG_SHARE_FILTER," ");
                    var title   = (this.userInfo.StoreName || this.userInfo.Name) + MSG.chat.productInChat;
                    var thumbnail = this.productData.Pictures && this.productData.Pictures[0]
                        && (this.productData.Pictures[0].ThumbnailUrl || this.productData.Pictures[0].PictureUrl);
                    openChatPage({
                        targetId: userId,
                        userId: userinfo.Id,
                        userName: userinfo.StoreName,
                        userPortrait: userinfo.ThumbnailAvatarUrl,
                        conversationType: 'PRIVATE',
                        isTop: false,
                        product: {
                            title: title,
                            description: content,
                            imageUrl: thumbnail,
                            extra: {
                                textType: 'product-tycoonplace',
                                prodId: api.pageParam.prodId,
                                userInfo: api.pageParam.userInfo,
                                countryCode: api.pageParam.countryCode,
                                userId: this.productData.Owner.Id,
                                userPortrait: this.productData.Owner.ThumbnailAvatarUrl,
                                storeName: this.productData.Owner.StoreName,

                                sendUserId: this.myID,
                                sendName: localStorage.getItem('storename'),
                                sendPortrait: localStorage.getItem('thumbnail'),

                                receiveName: this.userInfo.StoreName,
                                receivePortrait: this.userInfo.ThumbnailAvatarUrl,
                                chatUserId: this.userInfo.Id,
                                chatName: this.userInfo.StoreName,
                                chatPortrait: this.userInfo.ThumbnailAvatarUrl
                            }
                        }
                    });
                } else {
                    openLogin();
                }
            },
            // favorite:function(){
            //     var token = api.getPrefs({
            //         sync: true,
            //         key: 'accessToken'
            //     });
            //     if (token) {
            //         var that = this;
            //         var userId = this.userInfo.Id;
            //         var prodImg = this.productData.Pictures[0].DownloadUrl;
            //         var prodName = this.productData.Name;
            //         var icon = $('#favoriteIcon');
            //         var Info = that.userInfo;
            //         var UserInfo ={
            //             "Id":Info.Id,
            //             "UserName":Info.UserName,
            //             "CustomerGuid":Info.CustomerGuid,
            //             "StoreId":Info.StoreId,
            //             "StoreName":Info.StoreName,
            //             "AvatarUrl":Info.AvatarUrl,
            //             "RegisterCountryCode":Info.RegisterCountryCode,
            //         };
            //         if(icon.hasClass('active')){
            //             icon.removeClass('active');
            //             var cleanKey = db.selectSqlSync({
            //                 name: username,
            //                 sql: 'DELETE FROM favorite WHERE prodId ='+prodId
            //             });
            //             //console.log(JSON.stringify(cleanKey) +'db 删除数据');
            //         }else{
            //             icon.addClass('active');
            //             var insertData = db.executeSqlSync({
            //                 name: localStorage.getItem('userName'),
            //                 sql: "INSERT INTO favorite(prodId,userId,prodImg,prodName,userInfo) VALUES("+ prodId +","+ userId+",'"+ prodImg +"','"+ prodName +"','"+ JSON.stringify(UserInfo)+"')"
            //             });
            //             //console.log(JSON.stringify(insertData) +'db 插入数据');
            //         }
            //     }else{
            //         openLogin();
            //     }
            //
            // },
            // getFavorite:function () {
            //     if(username){
            //         var showFavorite = db.selectSqlSync({
            //             name: localStorage.getItem('userName'),
            //             sql: 'SELECT * FROM favorite'
            //         });
            //         //console.log(JSON.stringify(showFavorite) +'db 读取记录');
            //         if(showFavorite.status){
            //             var f = showFavorite.data;
            //             var len =f.length;
            //             for(i = 0; i<len ; i++){
            //                 if(prodId == f[i].prodId){
            //                     $('#favoriteIcon').addClass('active');
            //                 }
            //             }
            //         }else{
            //             var createTable = db.executeSqlSync({
            //                 name: username,
            //                 sql: "CREATE TABLE favorite(prodId INT PRIMARY KEY,userId INT,prodImg text,prodName text,userInfo text);"
            //             });
            //             //console.log(JSON.stringify(createTable) +'db 创建数据表')
            //         }
            //     }
            //     //console.log(JSON.stringify(showFavorite));
            // },
            setAnalyticsInfo:function () {
                if(time > 15){
                    api.sendEvent({
                        name: 'analytics',
                        extra: {
                            AnalyticsItemTypeId: 2,
                            AnalyticsActionTypeId:1,
                            ProductId: prodId,
                            CountryCode: localStorage.getItem('countryCode'),
                            StaySeconds: time
                        }
                    });
                }
                //退出页面统计点
                td.onPageEnd({pageName:'个人产品详情'});
                setTimeout(function () {
                    back();
                })
            },
            toTycoonplace:function(){
                var that = this;
                openUserTycoonPlace(that.productData.Owner.Id,that.productData.Owner.StoreName,that.productData.Owner.ThumbnailAvatarUrl);
            },
            closePage:function () {
                api.closeWin();
            },

            showImages:function(event, Index){
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: this.showcaseData.picUrls,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:Index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    } else if(Ret.eventType === 'longPress'){
                        actionSheet([
                            {
                                text: MSG.general.save,
                                callback: function () {
                                    api.download({
                                        url: picUrls[Ret.index],
                                        report: true,
                                        cache: true,
                                        allowResume: true
                                    }, function (ret, err) {
                                        if (ret.state === 1) {
                                            var Url= ret.savePath;
                                            api.saveMediaToAlbum({
                                                path: Url,
                                                groupName:"Tweebaa"
                                            }, function(ret, err) {
                                                if (ret && ret.status) {
                                                    alert(MSG.tips.saved);
                                                }
                                            });

                                        }
                                    });
                                }
                            }
                        ]);
                    }
                });
            },
            openWarn: function(key, $event) { //免费产品提示
                // alert(MSG.suggestion[key]);
                $event && $event.stopPropagation();
                dialog({
                    title: MSG.tips.title,
                    content: MSG.freeProduct[key],
                    primaryText: MSG.tips.gotit,
                    asideText: '',
                    onClose: "show",
                    textAlign: 'left',
                    onWarning: function() {
                    },
                    onPrimary: function () {

                    }
                });
            },
            openFreeConditions:function (){  //免费产品条件页面
                var that = this;
                api.openFrame({
                    name: 'freeConditions',
                    url: 'free-conditions.html',
                    bgColor:'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation:{
                        type:"movein",
                        subType:"from_bottom",
                        duration:300
                    },
                    pageParam: {
                        checked: that.checkedCondition,
                        progress:that.progressConditions,
                        conditionsInfo:that.productData.FreeSaleInfo,
                        sellerInfo:that.productData.Owner,
                        prodId:prodId,
                        sellerId:that.productData.Owner.Id
                    }
                });
            },
            playShowcaseVedio: function() {
                this.isShowVideoThumbnail = false;
                var videoDom = this.$refs.showcaseVideo;
                $(videoDom).removeClass('invisible');
                videoDom.play();
            }
        }
    });

};
//使用内置数据库来存储搜藏信息
//初始化图片显示
function initialize() {
    var mySwiper = new Swiper('.swiper-container', {
        direction: 'horizontal',
        loop: false,
        initialSlide: 0,
        pagination: {
            el: '.swiper-pagination',
            type: 'fraction'
        }
    });
    var winWidth = api.winWidth;
    $('#proDetailPhoto').height(winWidth);
    $('.videoDisplay').height(winWidth - 36);
}

// 深度比对两个对象是否相等
function isObjectValueEqual(a, b) {
    var aProps = Object.getOwnPropertyNames(a);
    var bProps = Object.getOwnPropertyNames(b);
    if (aProps.length != bProps.length) {
        return false;
    }
    for (var i = 0; i < aProps.length; i++) {
        var propName = aProps[i];

        var propA = a[propName];
        var propB = b[propName];
        if ((typeof (propA) === 'object')) {
            if (this.isObjectValueEqual(propA, propB)) {
                return true
            } else {
                return false
            }
        } else if (propA !== propB) {
            return false
        } else { }
    }
    return true
}
