
var uploading = false;
var sending = false;
var pictures = [];
var Video = {};
var token ='';

// autosize(document.querySelectorAll('textarea'));

// PHYSICAL, DIGITAL, INVENTION

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#media [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    backListener();

    api.setWinAttr({
        bounces: false
    });

    var postBtn = lan === "zh" ? "发布" : "Post";
    api.setNavBarAttr({
        rightButtons: [{
            text: postBtn,
            color:'#4578F3',
            fontSize:'15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            if (SuggestProduct.isRequesting === false) {
                SuggestProduct.submit();
            }
        } else {
            if (SuggestProduct.isEdit === false) {
                SuggestProduct.beforeBack();
            } else {
                back();
            }
        }
    });

    api.addEventListener({
        name: 'keyback'
    }, function (ret, err) {
        if (SuggestProduct.isEdit === false) {
            SuggestProduct.beforeBack();
        } else {
            back();
        }
    });

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew, #videoBtn, #showVideo').height(imgW);

    api.addEventListener({   //写入分类
        name: 'category'
    }, function(ret, err) {
        var categorys = JSON.parse(ret.value.c);
        var ids = [];
        $.each(categorys, function (index, item) {
            ids.push(item.Id);
        });
        SuggestProduct.form.productCategories = ids;
    });

    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        SuggestProduct.currentCategoryName = ret.value.list.join(', ');
    });

    api.addEventListener({
        name: 'selectedCountries'
    }, function(ret, err) {
        debugger
        SuggestProduct.form.shipToCountries = ret.value.countries;
        SuggestProduct.displayShipToCountries = ret.value.displayCountries;
    });

    api.addEventListener({
        name: 'productInfoReload'
    }, function(ret, err) {
        SuggestProduct.getProductDetail(SuggestProduct.product.Id);
    });

    var tags = [];
    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tags = ret.value.tags.split(',');
            SuggestProduct.form.productTags = tags;
        }
    });

    api.addEventListener({
        name: 'uploadedDigitalFile'
    }, function(ret, err) {
        SuggestProduct.form.productLink = ret.value.productURL;
        SuggestProduct.digitalFileName = ret.value.fileName;
    });

    if (api.pageParam.product) {
        $('#upload').hide();
    }

    var kv = api.require('snKVStorage');
    var hasSuggestProductDraft = kv.has({
        key: 'suggestProductDraft'
    });
    var suggestProductDraft = {};
    if (hasSuggestProductDraft) {
        suggestProductDraft = kv.getObject({
            key: 'suggestProductDraft'
        });
    }

    /**
     * 1. 建议已有产品
     * 2. 建议新的产品：包含：数字产品、实体产品
     */
    var SuggestProduct = new Vue({
        el: '#SuggestProduct',
        filters: {
            filterSuppliers: function (value) {
                var result;
                switch (value) {
                    case 'WITHOUT_SUPPLIER':
                        result = MSG.suggestion.withoutSupplier;
                        break;
                    case 'WITH_SUPPLIER':
                        result = MSG.suggestion.withASupplier;
                        break;
                    case 'AS_SUPPLIER':
                        result = MSG.suggestion.asASupplier;
                        break;
                    default:
                        result = MSG.suggestion.withoutSupplier;
                }
                return result;
            }
        },
        computed: {

        },
        mounted: function() {
            if (this.isEdit === false) {
                this._initDom();
            }
        },
        created: function() {

            // 从产品中选择
            if (this.product) {
                this.getProductDetail(this.product.Id);
            }

            if (api.pageParam.isEdit === true) {
                this.isEdit = true;
                this.getSuggestDetail();
            } else {
                // 判断是否有草稿
                var form = suggestProductDraft[this.currentType];
                if (form) {
                    this.form = form;

                    if (this.form.productImageLinks && this.form.productImageLinks.length > 0) {
                        this._setImageHtml(this.form.productImageLinks);
                    }

                    // 视频
                    if (this.form.productVideoInfos) {
                        var video = this.form.productVideoInfos[0];
                        Video = {
                            DownloadUrl: video.downloadUrl,
                            ThumbnailUrl: video.thumbnailUrl,
                            DurationSeconds: video.durationSeconds
                        };
                        renderVideo(video.thumbnailUrl);
                    }

                    // 类别
                    if (this.form.productCategories && this.form.productCategories.length > 0) {
                        this._setCategoryName(this.form.productCategories);
                    }

                    // 数字产品的上传产品部分
                    if (this.form.productLink) {
                        this._setFileLabel(this.form.productLink);
                    }
                }
            }
        },
        data: {
            isEdit: false,

            product: api.pageParam.product,

            currentType: api.pageParam.type,
            currentCategoryName: '',

            digitalFileName: '',

            isRequesting: false,
            form: {
                type: api.pageParam.type,

                productVideoInfos: [],
                productImageLinks: [],  // 必填

                productName: '',
                productDescription: '',
                sellingPrice: '',
                // shippingFee: '',
                whyChooseMe: '',
                hasStock: true,
                sku: '',
                productCategories: [],
                productTags: [],
                // myIncome: '',
                tycoonComment: '',
                productPitch: '',   // 推荐理由

                productLink: '',    // 数字产品链接

                // AS_SUPPLIER, WITHOUT_SUPPLIER, WITH_SUPPLIER
                supplierType: 'WITHOUT_SUPPLIER',

                // WITHOUT_SUPPLIER
                priceReferenceLink: '',
                supplierName: '',
                supplierContactName: '',
                supplierContactEmail: '',
                supplierContactPhone: '',
                supplierWebsiteLink: '',
                shipToCountries: '',    //
            },
            displayShipToCountries: '',
            message: MSG,
        },
        methods: {
            openStock: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.suggestion.hasQuantity,
                        callback: function () {
                            that.form.hasStock = true;
                        }
                    },
                    {
                        text: MSG.suggestion.noQuantity,
                        callback: function () {
                            that.form.hasStock = false;
                        }
                    }
                ]);
            },
            _initDom: function() {
                var that = this;

                $('#description').editor({
                    placeholder: MSG.suggestion.pDescription,
                    content: this.form.productDescription
                });

                $('#price').val(this.form.sellingPrice);
                new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
                    // console.log('tweebuckValue: ' + tweebuckValue);
                    if (tweebuckValue) {
                        that.form.sellingPrice = tweebuckValue;
                    } else {
                        that.form.sellingPrice = '';
                    }
                });

                // $('#shippingFee').val(this.form.shippingFee);
                // new CurrencySelector(document.getElementById('shippingFee'), function (tweebuckValue) {
                //     // console.log('tweebuckValue: ' + tweebuckValue);
                //     if (tweebuckValue !== '') {
                //         that.form.shippingFee = tweebuckValue;
                //     } else {
                //         that.form.shippingFee = '';
                //     }
                // });

                // $('#myIncome').val(this.form.myIncome);
                // new CurrencySelector(document.getElementById('myIncome'), function (tweebuckValue) {
                //     console.log('tweebuckValue: ' + tweebuckValue);
                //     if (tweebuckValue) {
                //         that.form.myIncome = tweebuckValue.toFixed(4);
                //     } else {
                //         that.form.myIncome = '';
                //     }
                // });
            },
            saveDraft: function() {

                // 描述
                var description = $.trim($('#description').html());
                if (description && description !== '<br>') {
                    this.form.productDescription = description;
                } else {
                    this.form.productDescription = '';
                }

                // 图片
                var pictures = [];
                $("#uploadImgBox").find('img').each(function (index) {
                    var pic = $(this).data('picture');
                    pic.DisplayOrder = index;
                    pictures.push({
                        "pictureUrl": pic.DownloadUrl,
                        "thumbnailUrl": pic.ThumbnailUrl
                    });
                });
                this.form.productImageLinks = pictures;

                // 视频
                if (Video) {
                    this.form.productVideoInfos = [
                        {
                            downloadUrl: Video.DownloadUrl,
                            thumbnailUrl: Video.ThumbnailUrl,
                            durationSeconds: Video.DurationSeconds
                        }
                    ];
                }

                suggestProductDraft[this.currentType] = $.extend({}, this.form);
                kv.setObject({
                    key: 'suggestProductDraft',
                    value: suggestProductDraft
                });
                setTimeout(function () {
                    back();
                }, 100)
            },
            beforeBack: function() {
                var that = this;
                confirm(MSG.suggestion.beforeBackTip, [
                    {
                        text: MSG.moment.saveDraft,
                        callback: function () {
                            that.saveDraft();
                        }
                    },
                    {
                        text: MSG.moment.exitDirectly,
                        callback: function () {
                            delete suggestProductDraft[that.currentType];
                            kv.setObject({
                                key: 'suggestProductDraft',
                                value: suggestProductDraft
                            });
                            setTimeout(function () {
                                back();
                            }, 100);
                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            openWarn: function(key, $event) {
                // alert(MSG.suggestion[key]);
                $event && $event.stopPropagation();
                dialog({
                    title: MSG.tips.title,
                    content: MSG.suggestion[key],
                    primaryText: MSG.tips.gotit,
                    asideText: '',
                    onClose: "show",
                    textAlign: 'left',
                    onWarning: function() {
                    },
                    onPrimary: function () {

                    }
                });
            },
            getLangKey: function() {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            _setCategoryName: function(productCategories) {
                var categoryNames = getCategoryNameByIds(productCategories, lan);
                this.currentCategoryName = categoryNames.join(', ');
            },
            _setImageHtml: function(productImageLinks) {
                id = id + productImageLinks.length;
                $.map(productImageLinks, function (item, index) {
                    var picData =  {
                        "MediaType": "Picture",
                        "FileName": "testimage.png",
                        "MediaFileUrl": item.pictureUrl,
                        "DownloadUrl": item.pictureUrl,
                        "ThumbnailUrl" : item.thumbnailUrl
                    };
                    $('#uploadImgBox').prepend(
                        getPhotoItem(index, liWith, item.pictureUrl, false)
                    );
                    $("#p" + index).data("picture", picData);

                    Sortable.create(document.getElementById('uploadImgBox'),
                        {
                            animation: 150,
                            onEnd: function (e) {
                            },
                            ghostClass:'.img-li',
                            handle:'.drag-handle'
                        });
                });
            },
            getSuggestDetail: function() {
                var that = this;
                apiSuggest.get("/api-product/suggest/details", {
                    id: api.pageParam.suggestId
                }).done(function (rep) {
                    loading('hide');
                    that.isLoading = false;
                    if (rep.code === 0) {
                        console.log(JSON.stringify(rep));
                        var product = rep.data;
                        var langKey = that.getLangKey();
                        // 呈现
                        // 1. 上传图片+视频
                        if (product.productImageLinks) {
                            that._setImageHtml(product.productImageLinks);
                        }

                        that.form.productVideoInfos = product.productVideoInfos;
                        var video = product.productVideoInfos[0];
                        if (video.downloadUrl) {
                            Video = {
                                DownloadUrl: video.downloadUrl,
                                ThumbnailUrl: video.thumbnailUrl,
                                DurationSeconds: video.durationSeconds
                            };
                            renderVideo(video.thumbnailUrl);
                        }

                        that.form.productImageLinks = product.productImageLinks;
                        that.form.productName = product.i18nProductName[langKey];
                        that.form.productDescription = product.i18nProductDescription[langKey];
                        that.form.sellingPrice = product.sellingPrice;
                        // that.form.shippingFee = product.shippingFee;
                        that.form.whyChooseMe = product.whyChooseMe;
                        that.form.sku = product.sku;

                        // 2. 分类
                        that.form.productCategories = product.productCategories;
                        that._setCategoryName(product.productCategories);

                        // 3. Tags
                        that.form.productTags = product.productTags;

                        // that.form.myIncome = product.myIncome;
                        that.form.tycoonComment = product.i18nTycoonComment[langKey];
                        that.form.productPitch = product.i18nProductPitch[langKey];
                        that.form.supplierType = product.supplierType;
                        that.form.priceReferenceLink = product.priceReferenceLink;
                        that.form.supplierName = product.supplierName;
                        that.form.supplierContactName = product.supplierContactName;
                        that.form.supplierContactEmail = product.supplierContactEmail;
                        that.form.supplierContactPhone = product.supplierContactPhone;
                        that.form.supplierWebsiteLink = product.supplierWebsiteLink;
                        that.form.shipToCountries = product.shipToCountries.join(',');

                        //数字产品
                        that.form.productLink = product.productLink;

                        that._initDom();

                    } else {
                        api.toast({
                            msg: rep.responseJSON.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error(JSON.stringify(err));
                });
            },
            getProductDetail: function (prodId) {
                var that = this;
                var param = {
                    viewerId: localStorage.getItem('userId'),
                    productId: prodId,
                    LanguageCode: lan
                };

                var url = getBaseUrl() + "api/v6/product?" + $.param(param);
                getAxois(url, "GET", {}).then(function (response) {
                    var product = response.data.Data;
                    that.product = product;
                    //console.log(JSON.stringify(product));
                    that.form.productImageLinks = [];
                    $.map(product.Pictures, function (item) {
                        that.form.productImageLinks.push({
                            pictureUrl: item.PictureUrl,
                            thumbnailUrl: item.ThumbnailUrl
                        });
                    });
                    //数字产品
                    if(product.Download){
                        that.form.productLink = product.Download.DownloadUrl;
                        that.digitalFileName = product.Download.FileName;
                        that.form.priceReferenceLink = "a";
                    }
                    // 视频
                    if (product.SampleDownload) {
                        Video = {
                            DownloadUrl: product.SampleDownload.DownloadUrl,
                            ThumbnailUrl: product.SampleDownload.ThumbnailUrl,
                            DurationSeconds: product.SampleDownload.DurationSeconds
                        };
                        renderVideo(product.SampleDownload.ThumbnailUrl);
                    }

                    that.form.productCategories = [];
                    $.map(product.Categories, function (item) {
                        that.form.productCategories.unshift(item.Id);
                    });
                    that.form.productTags = [];
                    $.map(product.ProductTags, function (item) {
                        that.form.productTags.push(item.Name);
                    });
                    that.form.productName = product.Name;
                    that.form.productDescription = product.FullDescription;
                    that.form.sellingPrice = product.TweebuckPrice;
                    // that.form.shippingFee = product.ShippingFee || 0;
                    that.form.hasStock = product.Quantity > 0;
                    that.form.sku = product.Sku || '';
                }).catch(function (error) {
                    console.error(JSON.stringify(error));
                });
            },
            submit: function() {
                var that = this;
                var params = {};

                if (Video && Video[0] && Video[0].MediaFileUrl) {
                    this.form.productVideoInfos = [
                        {
                            downloadUrl: Video[0].MediaFileUrl,
                            thumbnailUrl: Video[0].ThumbnailUrl,
                            durationSeconds: Video[0].DurationSeconds
                        }
                    ];
                } else {
                    this.form.productVideoInfos = [
                        {
                            downloadUrl:'',
                            thumbnailUrl: '',
                            durationSeconds: ''
                        }
                    ];
                }

                if (this.product) {
                    params.productId = this.product.Id;
                    if (this.currentType === 'DIGITAL') {
                        if (this.product.Download) {
                            params.productLink = this.product.Download.DownloadUrl;
                        }
                    }
                } else {
                    // 图片
                    if (uploading || imgUploading) {
                        api.toast({
                            msg: MSG.tips.uploadDataTips,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }

                    var pictures = [];
                    $("#uploadImgBox").find('img').each(function (index) {
                        var pic = $(this).data('picture');
                        pic.DisplayOrder = index;
                        pictures.push({
                            "pictureUrl": pic.DownloadUrl,
                            "thumbnailUrl": pic.ThumbnailUrl
                        });
                    });
                    if (pictures.length === 0) {
                        messages(MSG.tips.noPicError, 'error', 'top', 3);
                        return;
                    }
                    this.form.productImageLinks = pictures;

                    // 名字
                    if (!$.trim(this.form.productName)) {
                        messages(MSG.tips.productNameEmpty, 'error', 'top', 3);
                        return;
                    }

                    if (this.form.productName.length > 80) {
                        api.toast({
                            msg: MSG.tips.productNameTooLong,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }

                    // 描述
                    var description = $.trim($('#description').html());
                    if (!description) {
                        messages(MSG.tips.descriptionEmpty, 'error', 'top', 3);
                        return;
                    } else {
                        this.form.productDescription = description;
                    }

                    // 价格
                    if (!this.form.sellingPrice) {
                        messages(MSG.tips.productPriceEmpty, 'error', 'top', 3);
                        return;
                    }
                    if (+this.form.sellingPrice < 1) {
                        messages(MSG.tips.productPriceMin, 'error', 'top', 3);
                        return;
                    }

                    if (this.currentType === 'PHYSICAL') {

                        // 运费
                        // if (this.form.shippingFee === '') {
                        //     messages(MSG.suggestion.pShippingFee, 'error', 'top', 3);
                        //     return;
                        // }
                        //
                        // if (+this.form.shippingFee < 0) {
                        //     messages(MSG.suggestion.pcShippingFee, 'error', 'top', 3);
                        //     return;
                        // }

                        // 库存
                        // if (!this.form.stockQuantity) {
                        //     messages(MSG.suggestion.pStockQuantity, 'error', 'top', 3);
                        //     return;
                        // }
                        //
                        // if (+this.form.stockQuantity <= 0) {
                        //     messages(MSG.suggestion.pcStockQuantity, 'error', 'top', 3);
                        //     return;
                        // }
                    }

                    // 类别
                    if (this.form.productCategories && this.form.productCategories.length === 0) {
                        api.toast({
                            msg: MSG.tips.categoryEmpty,
                            duration: 2000,
                            location: 'middle'
                        });
                        return false;
                    }

                    // 标签
                    if (this.form.productTags && this.form.productTags.length === 0) {
                        api.toast({
                            msg: MSG.tips.tag2,
                            duration: 2000,
                            location: 'middle'
                        });
                        return false;
                    }

                }

                // Income
                // if (!this.form.myIncome) {
                //     messages(MSG.tips.myIncomeEmpty, 'error', 'top', 3);
                //     return;
                // }

                if (this.currentType === 'DIGITAL') {
                    if (!this.form.productLink) {
                        api.toast({
                            msg: MSG.tips.noProductError,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }
                }

                if (!this.form.priceReferenceLink) {
                    messages(MSG.tips.referenceEmpty, 'error', 'top', 3);
                    return;
                }

                // var reg = /^http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/;
                // if (/^http(s)/.test(this.form.priceReferenceLink) === false) {
                //     messages(MSG.suggestion.productLinkRight, 'error', 'top', 3);
                // }

                // // AS_SUPPLIER, WITHOUT_SUPPLIER, WITH_SUPPLIER
                //                 supplierType: 'WITHOUT_SUPPLIER',
                if (this.form.supplierType === 'WITH_SUPPLIER' || this.form.supplierType === 'AS_SUPPLIER') {

                    /*
                    supplierName: '',
                    supplierContactName: '',
                    supplierContactEmail: '',
                    supplierContactPhone: '',
                     */
                    if (!this.form.supplierName) {
                        messages(MSG.suggestion.pSupplierName, 'error', 'top', 3);
                        return;
                    }
                    if (!this.form.supplierContactName) {
                        messages(MSG.suggestion.pSupplierContactName, 'error', 'top', 3);
                        return;
                    }
                    if (!this.form.supplierContactEmail) {
                        messages(MSG.suggestion.pSupplierContactEmail, 'error', 'top', 3);
                        return;
                    }
                    if (isEmail(this.form.supplierContactEmail) === false) {
                        messages(MSG.suggestion.pcSupplierContactEmail, 'error', 'top', 3);
                        return;
                    }
                }

                if (this.form.supplierType === 'AS_SUPPLIER') {
                    // if (!this.form.sku) {
                    //     messages(MSG.suggestion.pSku, 'error', 'top', 3);
                    //     return;
                    // }
                    if (!this.form.supplierContactPhone) {
                        messages(MSG.suggestion.pSupplierContactPhone, 'error', 'top', 3);
                        return;
                    }
                    if (!this.form.supplierWebsiteLink) {
                        messages(MSG.suggestion.pSupplierWebsiteLink, 'error', 'top', 3);
                        return;
                    }
                }


                that.isRequesting = true;
                loading('show');
                params = $.extend({}, params, that.form);

                // if (params.shippingFee === '') {
                //     params.shippingFee = 0;
                // }

                // 处理可发送的国家
                if ($.isArray(params.shipToCountries) === true) {

                } else if (typeof params.shipToCountries === 'string') {
                    params.shipToCountries = params.shipToCountries.split(',');
                }  else {
                    params.shipToCountries = [];
                }

                //console.log('form: ' + JSON.stringify(params));
                if (this.isEdit === false) {
                    apiSuggest.post("/api-product/suggest/new", params).done(function (rep) {
                        //console.log(JSON.stringify(rep));
                        that.isRequesting = false;
                        loading('hide');
                        if (rep.code === 0) {
                            doSuccess();
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                } else {
                    apiSuggest.edit("/api-product/suggest/" + api.pageParam.suggestId, params).done(function (rep) {
                        that.isRequesting = false;
                        loading('hide');
                        if (rep.code === 0) {
                            doSuccess();
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                }

                function doSuccess() {
                    alert(MSG.tips.enabletoTweebaaSuccess, function () {
                        back();
                    });

                    api.closeWin({
                        name: 'selectMyProduct'
                    });

                    api.sendEvent({
                        name: 'productListReload',
                    });

                    api.sendEvent({
                        name: 'mySuggestProductsListReload',
                    });

                    delete suggestProductDraft[that.currentType];
                    kv.setObject({
                        key: 'suggestProductDraft',
                        value: suggestProductDraft
                    });
                }

                // setTimeout(function () {
                    // var url = getBaseUrl() + "api/suggest-products?ApplicantId=" + userId;

                    // api.ajax({
                    //     url: url,
                    //     method: 'post',
                    //     headers: {
                    //         'Content-Type': 'application/json;charset=utf-8',
                    //         'userId': '123456789',
                    //         'userName': 'King'
                    //     },
                    //     data: {
                    //         body: that.form
                    //     }
                    // }, function(ret, err) {
                    //     if (ret) {
                    //         loading('hide');
                    //
                    //         api.alert({
                    //             msg: MSG.tips.enabletoTweebaaSuccess,
                    //         }, function(ret, err) {
                    //             back()
                    //         });
                    //
                    //         api.sendEvent({
                    //             name: 'productListReload',
                    //         });
                    //
                    //         api.sendEvent({
                    //             name: 'mySuggestProductsListReload',
                    //         });
                    //
                    //     } else {
                    //         console.error(JSON.stringify(err));
                    //     }
                    // });


                    // $.when(postApi(url, method, prodObj, token, contentTypeStr)).done(function (data) {
                    //     //console.log(JSON.stringify(data));
                    //     that.isRequesting = false;
                    //     loading('hide');
                    // });

                // });
            },
            _setFileLabel: function(name) {
                if (name.length > 30) {
                    name = name.substring(0, 30) + '...';
                }
                this.digitalFileName = name;
            },
            openUploadFile: function () { //上传产品
                var that = this;
                api.actionSheet({
                    cancelTitle:  MSG.products.cancel,
                    buttons: [MSG.products.enterLink, MSG.products.UploadFile]
                }, function (ret, err) {
                    var index = ret.buttonIndex;
                    if (index === 1) {
                        api.prompt({
                            buttons: [MSG.general.ok, MSG.general.cancel],
                            text:"https://",
                            type:"url"
                        }, function(ret, err) {
                            var index = ret.buttonIndex;
                            if(index === 1 ){
                                var text = ret.text;
                                if(text && text.indexOf("http") !== -1){
                                    that.form.productLink = text;
                                    that._setFileLabel(MSG.products.linkLabel + ' ' + text);
                                }else{
                                    alert(MSG.products.linkError);
                                }
                            }

                        });
                    } else if (index === 2) {
                        openTabLayout('productUploadPage','','widget://html/products/upload-download.html',{
                            url: {
                                DownloadUrl: that.form.productLink
                            },
                            page: 'add'
                        })
                    } else {
                        return false;
                    }
                });
            },
            openCategoryPage:function () { //分类
                if (this.currentType === 'DIGITAL') {
                    openTabLayout('categoryDigital', '', 'widget://html/products/category-digital.html');
                } else {
                    openTabLayout('categoryPhysical','','widget://html/products/category-physical.html');
                }
            },
            openProductTags:function () { // 打开tag输入
                openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
                    tags:tags?tags.join(','):null
                })
            },
            selectSupplier: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.suggestion.withoutSupplier,
                        callback: function () {
                            that.form.supplierType = 'WITHOUT_SUPPLIER';
                        }
                    },
                    {
                        text: MSG.suggestion.withASupplier,
                        callback: function () {
                            that.form.supplierType = 'WITH_SUPPLIER';
                        }
                    },
                    {
                        text: MSG.suggestion.asASupplier,
                        callback: function () {
                            that.form.supplierType = 'AS_SUPPLIER';
                        }
                    }
                ]);
            },
            openProdDetail: function(){
                var param = {
                    prodId: this.product.Id,
                    userInfo: JSON.stringify(this.product.Owner),
                    tweebaaTag: ''
                };
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            closeWin: function () {
                back();
            },
            editProduct: function () {
                switch (this.product.ProductType) {
                    case 1:
                        openTabLayout('editProduct', this.message.tycoonplace.editProduct, "widget://html/products/form-physical.html", {
                            productId: this.product.Id
                        });
                        break;
                    case 2:
                        openTabLayout('editProduct', this.message.tycoonplace.editProduct, 'widget://html/products/form-digital-new.html', {
                            productId: this.product.Id
                        });
                        break;
                }
            },
            openCountries: function () {
                openTabLayout('countries', '', 'widget://html/products/select-countries.html', {
                    countries: this.form.shipToCountries
                });
            }
        }
    });

};

function isEmail(email) {
    var regEmail = /^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/;
    return regEmail.test(email);
}

