var productURL;
var uploadingProd = false;
var fileName;

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#uploadProduct').text(MSG.upload.uploadProduct);
    $('#uploading').text(MSG.upload.uploading);
    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false
    });

    var postBtn = MSG.general.save;
    api.setNavBarAttr({
        rightButtons: [{
            text: postBtn,
            color:'#4578F3',
            fontSize:'15'
        }]
    });

    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        if(!uploadingProd){
            back();
        }
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            if(!uploadingProd){
                saveUpload()
            }
        }else{
            back();
        }
    });

    if (api.pageParam.url) {
        productURL = api.pageParam.url.DownloadUrl;

        if (!productURL) {
            return;
        }

        productURL = productURL.split('/playlist.m3u8')[0];

        var index= productURL.lastIndexOf(".");
        var ext = productURL.substr(index+1).toUpperCase();
        if (ext === 'COM') {
            return;
        }

        $(".show-upload-box").toggleClass('d-none');
        $('#progress').css('width','100%');
        $('#uploading').text(MSG.upload.done);

        if (api.pageParam.fileName) {
            $("#prodName").text(api.pageParam.fileName);
        } else {
            $("#prodName").text('[ '+ ext+' ]' + MSG.upload.file);
        }
    }
};


function saveUpload() {
    var name = api.pageParam.page === 'add' ? "addDigital" : "editProduct";
    // api.execScript({
    //     name: name,
    //     script: 'Btns.enterDownload("'+ productURL +'", "' + productName + '");'
    // });
    api.sendEvent({
        name: 'uploadedDigitalFile',
        extra: {
            productURL: productURL,
            fileName: fileName
        }
    });
    setTimeout(function () {
        back();
    });
}

//添加产品和小样
$("#getProduct").on('change', function () {

    var fileName = $(this).val();
    if (fileName == "") {
        return false;
    }
    // var objUrl = showVideo(this.files[0]);
    //showDisplay('prod',fileName,objUrl);
    if(this.files[0].size > 209715200){
        alert( MSG.upload.uploadTips);
        return
    }
    uploadProduct();
});


// var CancelToken = axios.CancelToken;
// var source = CancelToken.source();
function uploadProduct() {
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var formData = new FormData();
    var productFile = $('#getProduct').get(0).files[0];
    if(productFile){
        formData.append('file', productFile, 'TWEEBAA-ORIGIN-'+ productFile.name);
    }
    //获取后缀名
    var index= productFile.name.lastIndexOf(".");
    var ext = productFile.name.substr(index+1).toUpperCase();

    var url = 'https://media.tweebaa.';
    if (localStorage.getItem('server') === 'cn') {
        url = url + 'cn';
    } else {
        url = url + 'com';
    }
    url = url + '/api/v1/uploader/products/' + localStorage.getItem('userGuid');
    uploadingProd = true;
    $(".show-upload-box").toggleClass('d-none');
    fileName = '[ '+ ext+' ]' + MSG.upload.file;
    $("#prodName").text(fileName);
    //console.log(url);
    axios.post(url, formData, {
        headers: {
            "apikey":token,
            'Content-Type':'application/x-www-form-urlencoded;charset=utf-8'
        },
        //cancelToken:source.token,
        onUploadProgress: function (e){

            var completeProgress = ((e.loaded / e.total * 100) | 0);
            $('#progress').css('width',completeProgress+'%');

            if(completeProgress === 100){
                loading('show');
            }
        }
    }).then(function(res){
        loading('hide');
        $('#uploading').text(MSG.upload.done);
        productURL = res.data.Files[0].DownloadUrl;
        uploadingProd = false;
    }).catch(function(error){
        console.log(JSON.stringify(error));
    });

}

//删除产品
function deleteUpload() {
    confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error');
    $('.dialog-box').find('button').on('click',function (e) {
        $('.dialog-box').remove();
        var index = $(this).attr('id');
        if (index === 'btn-2') {
            productURL = null;
            $('#progress').css('width',0);
            $('#uploading').text(MSG.upload.uploading);
            $(".show-upload-box").toggleClass('d-none');
            //source.cancel('取消');
        }
    });

}
