var Video, videoSize, prodData, uploading, content, textLink, momentTag, prod,lon,lat,address;
var PublicMoment = true;
var Location = true;
var sending = false;
var pictures = [];
var taskService;

apiready = function () {
    api.setWinAttr({
        name: 'addMoment',
        bounces: false,
        slidBackEnabled: false
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.general.post,
            color: '#4578F3',
            fontSize: '15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            saveNewMoment();
        } else {
            closeAddPage();
        }
    });

    api.addEventListener({
        name: 'momentTag'
    }, function (ret, err) {
        if (ret.value.tags) {
            momentTag = [];
            $('#tagBox').empty();
            for (t = 0; t < ret.value.tags.length; t++) {
                var temp = '<span onclick="tagSelector()" style="display: inline-block" class="bk-light-blue m-3 ui-border-radius-5 pt-2 pb-2 pl-5 pr-5">' + ret.value.tags[t][lan] + '</span>';
                $('#tagBox').append(temp);
                momentTag.push({"id": ret.value.tags[t].Id});
            }
        }
    });

    taskService = new TaskService(TASK_CODE.GROUP_PERSON_PROFILE, true, function () {
        back();
    });

    api.addEventListener({
        name: 'taskReload'
    }, function (ret, err) {
        taskService.refresh();
    });

    $('#getPhotosNew, #videoBtn').click(function () {
        var UIInput = api.require('UIInput');
        UIInput.closeKeyboard({
            id: 0
        });
    });


    setTimeout(function () {
        openInput();
    });

    if (!checkPermission('photos')) {
        requestPermission("photos");
    }

    if (!checkPermission('location')) {
        requestPermission("location");
    }

    var systemType = api.systemType;
    var map = api.require('bMap');   //载入百度地图获取当前位置

    // map.getLocationServices(function(ret, err) {
    //     if (ret.enable) {
    //         alert(JSON.stringify(ret));
    //     } else {
    //         alert("未开启定位功能！");
    //     }
    // });

    if(systemType ==="ios"){
        map.initMapSDK(function(ret) {
            if (ret.status) {
                getLocation();
            }
        });
    }else{
        getLocation()
    }

    function getLocation() {
        map.getLocation({
            accuracy: '100m',
            autoStop: true,
            filter: 1
        }, function(ret, err) {
            if (ret.status) {
                lon = ret.lon;
                lat = ret.lat;
                map.getNameFromCoords({
                    lon: ret.lon,
                    lat: ret.lat
                }, function(ret, err) {
                    if (ret.status) {
                        address = ret.country + " " + ret.city;
                        console.log(JSON.stringify(ret));
                    }
                });
            }
        });
    }

    //写入转发信息
    if (api.pageParam.repostInfo) {
        var repostInfo = api.pageParam.repostInfo;
        renderRepost(repostInfo);
    }

    //如果是编辑时获取post详情
    if (api.pageParam.postId) {
        getPost(api.pageParam.postId);
        $('#saveProductBtn span').text(MSG.moment.edit);
    } else {
        $('#saveProductBtn span').text(MSG.moment.post);
    }

    function openInput() {
        var UIInput = api.require('UIInput');
        UIInput.open({
            rect: {
                x: 15,
                y: 30,
                w: api.winWidth - 30,
                h: 90
            },
            styles: {
                bgColor: '#fff',
                size: 16,
                color: '#000',
                placeholder: {
                    color: '#BDBDBD',
                    size: 16
                }
            },
            autoFocus: false,
            maxRows: 4,
            placeholder: MSG.moment.saySomething,
            fixedOn: api.frameName,
            fixed: false
        }, function (ret, err) {
            if (ret.eventType == 'change') {
                UIInput.value(function (ret) {
                    if (ret) {
                        content = ret.msg;
                    }
                });
            }
        });

        var safeBottom = api.safeArea.bottom;
        $('#uploadBtns').css({
            paddingBottom: (1.5 + safeBottom / 10) + 'rem'
        });
        UIInput.addEventListener({
            name: 'becomeFirstResponder'
        }, function (ret) {
            $('#uploadBtns').css({'bottom': ret.keyboardHeight + 'px', paddingBottom: '1.5rem'});
            // $('#uploadBtns').css({paddingBottom: '1.5rem'});
        });
        UIInput.addEventListener({
            name: 'resignFirstResponder'
        }, function (ret) {
            $('#uploadBtns').css('bottom', 0);
            $('#uploadBtns').css({
                paddingBottom: (1.5 + safeBottom / 10) + 'rem'
            });
            UIInput.value(function (ret) {
                if (ret) {
                    content = ret.msg;
                }
            });
        });


    }

    var imgW = $('#width').width();
    var imgW2 = imgW - 5;
    $('#uploadImgBox .img-li').height(imgW);
    $('#uploadImgBox #getPhotosNew,#uploadImgBox #videoBtn,#uploadImgBox #replaceVideo, #uploadImgBox #showVideo').height(imgW2);
    $('#includedProd').on('touchstart', function () {
        if (!prodData) {
            loadProdsList();
        } else if (prodData.length > 0) {
            openWindows('selectProds', 'select-pords.html', {
                prodsData: JSON.stringify(prodData)
            });
        }
    });


    // $('#addTag').on('touchstart',function () {
    //     if (this.isScrolling === true) {
    //         return;
    //     }
    //     setTimeout(function() {
    //         openTabLayout('addPostTag',MSG.moment.addTag,'widget://html/users/add-moment-tag.html',{
    //             tags:momentTag
    //         })
    //     });
    //     // openWindows("momentLink",'widget://html/users/add-moment-link.html')
    // });


    $('#addLinkBtn').on('touchstart', function () {
        if (this.isScrolling === true) {
            return;
        }
        setTimeout(function () {
            api.openFrame({
                name: 'momentLink',
                url: 'widget://html/users/add-moment-link.html',
                fixedOn: 'ui_layout',
                bgColor: 'rgba(0,0,0,0.15)',
                bounces: false,
                allowEdit: true,
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto',
                }
            });
        });
        // openWindows("momentLink",'widget://html/users/add-moment-link.html')
    });

    api.addEventListener({
        name: 'selectedProd'
    }, function (ret, err) {
        prod = JSON.parse(ret.value.selectedProd);
        var description = ret.value.description;
        $('#productBox').removeClass('d-none');
        $('#productDescription').text(description);
        $('#productName').text(prod.Name);
        $('#productImg').attr("src", prod.FeaturedPicture.DownloadUrl);
        $('#productId').val(prod.Id);
        $('#productPrice').val(prod.TweebuckPrice);
        $('#includedProd i').addClass('text-blue');
    });

    api.addEventListener({
        name: 'addMomentLink'
    }, function (ret, err) {
        var title = ret.value.title;
        var externalPostUrl = ret.value.link;
        if (externalPostUrl) {
            var preText = title || externalPostUrl;
            textLink = externalPostUrl.indexOf("http") !== -1 ? externalPostUrl : "http://" + externalPostUrl;
            $('#linkBox').removeClass('d-none').addClass("flex");
            $('#linkTitle').text(preText);
            $('#inputLink').text(textLink);
            $('#addLinkBtn i').addClass('text-blue');
        }
    });
    //获取草稿
    setTimeout(function () {
        var kv = api.require('snKVStorage');
        var result = kv.getObject({
            key: 'postDraft'
        });
        // console.log(JSON.stringify(result));
        if (result && result !== -1) {
            prod = result;
            // console.log(JSON.stringify(result));
            if (result.content) {
                var UIInput = api.require('UIInput');
                UIInput.insertValue({
                    msg: result.content
                });
                content = result.content;
            }
            if (result.externalPostUrl) {
                $('#linkBox').removeClass('d-none').addClass("flex");
                $('#inputLink').val(result.externalPostUrl);
                $('#linkTitle').text(result.externalPostText);
                $('#addLinkBtn i').addClass('text-blue');
            }
            if (result.videos) {
                Video = result.videos;
                renderVideo(result.videos[0].ThumbnailUrl)
            }
            if (result.attachments && result.attachments.length > 0) {
                var pic = result.attachments.reverse();
                var len = pic.length;
                remaining = remaining - len;
                for (var i = 0; i < len; i++) {
                    var picData = {
                        "MediaType": "Picture",
                        "FileName": "testimage.png",
                        "MediaFileUrl": pic[i].mediaFileUrl,
                        "DownloadUrl": pic[i].downloadUrl || pic[i].mediaFileUrl,
                        "ThumbnailUrl": pic[i].thumbnailUrl
                    };
                    $('#uploadImgBox').prepend(
                        getPhotoItem(i + 'D', liWith, pic[i].mediaFileUrl, false)
                    );
                    $("#p" + i + 'D').data("picture", picData);

                }
                Sortable.create(document.getElementById('uploadImgBox'),
                    {
                        animation: 150, onEnd: function (e) {

                        },
                        ignore: 'a',
                        ghostClass: '.img-li',
                        handle: '.drag-handle'
                    });
            }
            if (result.momentProduct) {
                $('#productBox').removeClass('d-none');
                $('#productDescription').text(result.momentProduct.description);
                $('#productName').text(result.momentProduct.productName);
                $('#productImg').attr("src", result.momentProduct.productImageUrl);
                $('#productPrice').val(result.momentProduct.productPrice);
                $('#productId').val(result.momentProduct.productId);
                $('#includedProd i').addClass('text-blue');
            }

        }

    });


};

function renderRepost(INFO) {
    $('#repostBox').removeClass('d-none');
    var name, repostContent, img;

    if (INFO.rePost) {
        name = INFO.rePost.owner.storeName;
        repostContent = INFO.rePost.content;
        if (INFO.rePost.pictures.length > 0) {
            img = INFO.rePost.pictures[0].thumbnailUrl;
        } else if (INFO.rePost.videos.length > 0) {
            img = INFO.rePost.videos[0].thumbnailUrl;
        } else {
            img = "../../image/no-image.png"
        }
    } else {
        name = INFO.owner.storeName;
        repostContent = INFO.content;
        if (INFO.pictures.length > 0) {
            img = INFO.pictures[0].thumbnailUrl;
        } else if (INFO.videos.length > 0) {
            img = INFO.videos[0].thumbnailUrl;
        } else {
            img = "../../image/no-image.png"
        }
    }
    $('#repostName').text(name);
    $('#repostImg').attr("src", img);
    if (repostContent) {
        $('#repostContent').text(repostContent);
    }
}

//获取post详情
function getPost(postId) {
    loading("show");
    apiMoment.get('/api/v1/blog_posts/detail/' + postId).done(function (rep) {

        loading('hide');

        if (rep.code !== 0) {
            api.toast({
                msg: rep.message,
                duration: 2000,
                location: 'middle'
            });
            return;
        }

        var result = rep.data;

        if (result.content) {
            var UIInput = api.require('UIInput');
            UIInput.insertValue({
                msg: result.content
            });
            content = result.content;
        }
        if (!result.showOnHomePage) {
            $('#publicBtn').attr("checked", result.showOnHomePage);
            $('.private,.public').toggle();
            PublicMoment = result.showOnHomePage;
        }
        if (result.externalPostUrl) {
            $('#linkBox').removeClass('d-none').addClass("flex");
            $('#linkTitle').text(result.externalPostText);
            $('#addLinkBtn i').addClass('text-blue');
            $('#inputLink').val(result.externalPostUrl);
            textLink = result.externalPostUrl;
        }

        //转发信息
        if (result.rePost) {
            renderRepost(result);
        }
        // console.log(JSON.stringify(result));

        if (result.pictures && result.pictures.length > 0) {
            var pic = result.pictures.reverse();
            var len = pic.length;

            remaining = remaining - len;

            for (i = 0; i < len; i++) {
                var picData = {
                    "MediaType": "Picture",
                    "FileName": "testimage.png",
                    "MediaFileUrl": pic[i].mediaFileUrl,
                    "DownloadUrl": pic[i].mediaFileUrl,
                    "ThumbnailUrl": pic[i].thumbnailUrl
                };
                $('#uploadImgBox').prepend(
                    getPhotoItem(i + 'E', liWith, pic[i].mediaFileUrl, false)
                );
                $("#p" + i + 'E').data("picture", picData);

            }
            Sortable.create(document.getElementById('uploadImgBox'),
                {
                    animation: 150, onEnd: function (e) {

                    },
                    ignore: 'a',
                    ghostClass: '.img-li',
                    handle: '.drag-handle'
                });
        }

        if (result.momentProduct) {
            if (result.momentProduct.description) {
                $('#productDescription').text(result.momentProduct.description);
            }
            $('#productBox').removeClass('d-none');
            $('#productName').text(result.momentProduct.productName);
            $('#productImg').attr("src", result.momentProduct.productImageUrl);
            $('#productPrice').val(result.momentProduct.productPrice);
            $('#productId').val(result.momentProduct.productId);
            $('#includedProd i').addClass('text-blue');
        }

        if (result.tags) {
            momentTag = [];
            $('#tagBox').empty();
            for (t = 0; t < result.tags.length; t++) {
                var temp = '<span onclick="tagSelector()" style="display: inline-block" class="bk-light-blue m-3 ui-border-radius-5 pt-2 pb-2 pl-5 pr-5">' + getTagById(result.tags[t])[lan] + '</span>';
                $('#tagBox').append(temp);
                momentTag.push({"id": result.tags[t]});
            }

        }

        if (result.videos.length > 0) {
            Video = [
                {
                    "MediaType": "Video",
                    "MediaFileUrl": result.videos[0].mediaFileUrl,
                    "ThumbnailUrl": result.videos[0].thumbnailUrl,
                    "DurationSeconds": result.videos[0].duration,
                    "FileSize": result.videos[0].fileSize,
                    "FileName": "Name"
                }
            ];
            renderVideo(result.videos[0].thumbnailUrl);
            $('#videoBtn').addClass('d-none');

        }

        if (!result.location) {
            $('#locationBtn').attr("checked", false);
            $('.location-btn-text').removeClass("text-blue");
        }
        Location = $(this).prop("checked");

    }).fail(function (error) {

        console.log(JSON.stringify(error));
    });
}

$('#publicBtn').on("change", function (e) {
    PublicMoment = $(this).prop("checked");
    $('.private,.public').toggle();
});

$('#locationBtn').on("change", function (e) {
    Location = $(this).prop("checked");
    $('.location-btn-text').toggleClass("text-blue");
});

function saveNewMoment() {

    taskService.check(function () {

        var UIInput = api.require('UIInput');
        UIInput.closeKeyboard({
            id: 0
        });
        if (sending) {
            return false;
        }

        if (uploading || imgUploading) {
            api.toast({
                msg: MSG.tips.uploadDataTips,
                duration: 2000,
                location: 'middle'
            });
            return false;
        } else {
            pictures = [];
            $("#uploadImgBox").find('img').each(function (index) {
                var pic = $(this).data('picture');
                pic.displayOrder = index;
                pictures.push({
                    "mediaType": pic.MediaType,
                    "fileName": pic.FileName,
                    "mediaFileUrl": pic.MediaFileUrl,
                    "downloadUrl": pic.DownloadUrl,
                    "thumbnailUrl": pic.ThumbnailUrl
                });
            });
            sending = true;
            setTimeout(function () {
                var userId = localStorage.getItem('userId');
                var title = $('#title').val();
                var productId = $('#productId').val();
                var productPrice = $('#productPrice').val();
                var productName = $('#productName').text();
                var productImg = $('#productImg').attr("src");
                var description = $('#productDescription').val();
                var products = productId ? {
                    'productId': parseInt(productId),
                    "description": description,
                    "productName": productName,
                    "productImageUrl": productImg,
                    "productPrice": productPrice
                } : null;
                var showH = PublicMoment;
                var preText = $('#linkTitle').text();
                // content = $.trim(content);
                var TZ = Intl.DateTimeFormat().resolvedOptions().timeZone;
                var LT = moment().format('YYYY-MM-DDThh:mm:ss');

                var videos;
                if (Video && Video.length > 0) {
                    videos = [
                        {
                            "mediaType" : "video",
                            "mediaFileUrl" : Video[0].MediaFileUrl,
                            "thumbnailUrl" : Video[0].ThumbnailUrl,
                            "durationSeconds" : Video[0].DurationSeconds,
                            "fileSize" : Video[0].FileSize,
                            "fileName" : Video[0].FileName
                        }
                    ];
                }

                var paramStr = {
                    "content": content,
                    "attachments": pictures,
                    "videos": videos,
                    "showOnHomePage": showH,
                    "momentProducts": products,
                    "title": title,
                    "externalPostUrl": textLink,
                    "externalPostText": preText,
                    "tz": TZ,   // timezone 时区 字符
                    "tl": LT, // timelocal  APP本地时间
                    "tags": momentTag
                };

                if (!content) {
                    sending = false;
                    api.toast({
                        msg: MSG.tips.postEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                if (!momentTag || momentTag.length === 0) {
                    sending = false;
                    api.toast({
                        msg: MSG.tips.momentTagEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                if (Location && lon) {    //如果选择了显示位置则写入定位信息
                    paramStr.latitude = lat;
                    paramStr.longitude = lon;
                    paramStr.address = address;
                }

                /*
                 * 1. 未设置头像时，给予提示
                 * 2. 当仅仅上传图片<=1张时，文字<6个字符，给予提示
                 */
                var thumbnail = localStorage.getItem('thumbnail');
                if (thumbnail.indexOf('default-avatar.png') > 0) {
                    confirm(MSG.moment.portraitDefault, [
                        {
                            text: MSG.moment.settingPortrait,
                            callback: function () {
                                sending = false;
                                openProfile();
                            }
                        },
                        {
                            text: MSG.moment.continue,
                            callback: function () {
                                start();
                            }
                        }
                    ]);
                    return;
                }

                start();

                function start() {
                    var url;

                    // 转发
                    var repostInfo = api.pageParam.repostInfo;
                    if (repostInfo) {
                        var momentGuid;
                        if (repostInfo.rePost) {
                            momentGuid = repostInfo.rePost.momentGuid;
                        } else {
                            momentGuid = repostInfo.momentGuid;
                        }
                        url = '/api/v1/blog_posts/' + momentGuid + '/forwarding';
                    } else if (api.pageParam.postGuid) {    // // 编辑
                        url = '/api/v1/blog_posts/' + api.pageParam.postGuid + '/update';
                    } else {
                        url = '/api/v1/blog_posts';
                    }
                    $('#saveProductBtn').addClass('opacity-5 no-touch');
                    loading('show');
                    apiMoment.post(url, paramStr).done(function (rep) {
                        loading('hide');
                        if (rep.code === 0) {
                            var kv = api.require('snKVStorage');
                            var result = kv.removeKey({
                                key: 'postDraft'
                            });
                            api.sendEvent({
                                name: 'reloadHome',
                            });
                            api.sendEvent({
                                name: 'reloadMyPost',
                            });
                            api.sendEvent({
                                name: 'reloadMomentDetail',
                            });
                            api.sendEvent({
                                name: 'workplaceReload',
                                extra: {
                                    type: 'moment'
                                }
                            });
                            if (repostInfo) {
                                var targetUserName;
                                if (repostInfo.rePost) {
                                    targetUserName = repostInfo.rePost.owner.userName;
                                } else {
                                    targetUserName = repostInfo.owner.userName;
                                }
                                // 通知
                                postNotify(targetUserName, MSG_TYPE_OTHER, {
                                    Type: 'repost',
                                    AvatarUrl: localStorage.getItem('thumbnail'),
                                    StoreName: localStorage.getItem('storename'),
                                    UserId: localStorage.getItem('userId'),
                                    PostId: rep.data,
                                });
                            }
                            if (!api.pageParam.postId) {
                                showTiV(false);
                            } else {
                                back();
                            }

                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }

                    });
                }

                // 设置头像
                function openProfile() {
                    openTabLayout('myProfile', MSG.mine.editProfile, 'widget://html/users/my-profile.html');
                }


            }, 500)
        }


    });

}


//获取产品列表
function loadProdsList() {
    loading('show');
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var userId = localStorage.getItem('userId');
    var paramStr = {'userId': userId, 'currentPage': 0, "itemsperpage": 999};
    var url = getBaseUrl() + "api/users/" + userId + "/products";
    var method = "GET";
    $.when(postApi(url, method, paramStr, token, null)).done(function (data) {
        loading('hide');
        //console.log(JSON.stringify(data));
        var obj = prodData = data.Data;
        if (obj.length > 0) {
            openTabLayout('selectProds', MSG.moment.selectProduct, 'widget://html/users/select-pords.html', {
                prodsData: JSON.stringify(obj)
            });
            setTimeout(function () {
                $('#selectBtn').css('display', 'flex');
                $('#PordDescriptionBox').removeClass('d-none');
            }, 2000);
            $('#prodName').on('touchstart', function () {
                openTabLayout('selectProds', MSG.moment.selectProduct, 'widget://html/users/select-pords.html', {
                    prodsData: JSON.stringify(obj)
                });
            });
        } else {
            dialog({
                title: MSG.tips.noProduct,
                content: '',
                primaryText: MSG.tweebucks.gotit,
                asideText: '',
                onClose: "show",
                onWarning: function () {
                },
                onPrimary: function () {
                    api.closeFrame();
                }
            });
        }

    });
}


function showVideo(file) {
    var url = null;
    if (window.createObjectURL != undefined) { // basic
        url = window.createObjectURL(file);
    } else if (window.URL != undefined) { // mozilla(firefox)
        url = window.URL.createObjectURL(file);
    } else if (window.webkitURL != undefined) { // webkit or chrome
        url = window.webkitURL.createObjectURL(file);
    }
    console.log("url " + url);
    return url;
}

function openPostProduct() {
    if (!prod.Owner) {
        return;
    }
    openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', {
        prodId: $('#productId').val(),
        userInfo: JSON.stringify(prod.Owner)
    });
}

function openPostLink() {
    console.log("opening");
    var link = $('#inputLink').text();
    var title = $('#linkTitle').text();
    console.log("logging link: " + link);
    console.log("logging title: " + title);
    openBrowser(this, link, title);
}

function deleteLink() {
    $('#linkBox').removeClass('flex').addClass("d-none");
    $('#inputLink').val('');
    $('#linkTitle').text('');
    $('#addLinkBtn i').removeClass('text-blue');
    textLink = null;
}

function deletePostProduct() {
    $('#productBox').addClass('d-none');
    $('#productDescription').text('');
    $('#productName').text('');
    $('#productImg').attr("src", '');
    $('#productId').val('');
    $('#includedProd i').removeClass('text-blue');
}

function deletePostVideo() {
    $('#videoBtn').removeClass('d-none');
    $('#replaceVideo').addClass('d-none');
    Video = [];
}


function closeAddPage() {

    confirm(MSG.moment.exitPostNow, [
        {
            text: MSG.moment.saveDraft,
            callback: function () {
                saveDraft();
            }
        },
        {
            text: MSG.moment.exitDirectly,
            callback: function () {
                var kv = api.require('snKVStorage');
                var result = kv.removeKey({
                    key: 'postDraft'
                });
                setTimeout(function () {
                    confirmBack();
                }, 100)
            }
        },
        {
            text: MSG.general.cancel,
            callback: function () {

            }
        }
    ]);

}

function tagSelector() {
    if (this.isScrolling === true) {
        return;
    }
    setTimeout(function () {
        openTabLayout('addPostTag', MSG.moment.addTag, 'widget://html/users/add-moment-tag.html', {
            tags: momentTag
        })
    });
}

function saveDraft() {
    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.displayOrder = index;
        pictures.push({
            "mediaType": pic.MediaType,
            "fileName": pic.FileName,
            "mediaFileUrl": pic.MediaFileUrl,
            "downloadUrl": pic.DownloadUrl,
            "thumbnailUrl": pic.ThumbnailUrl
        });
    });
    var productId = $('#productId').val();
    var productPrice = $('#productPrice').val();
    var productName = $('#productName').text();
    var productImg = $('#productImg').attr("src");
    var description = $('#productDescription').val() || '';
    var products = productId ? {
        'productId': parseInt(productId),
        "description": description,
        "productName": productName,
        "productImageUrl": productImg,
        "productPrice": productPrice
    } : null;
    var showH = PublicMoment;
    var preText = $('#linkTitle').text();
    var textLink = $('#inputLink').val();
    var paramStr = {
        "content": content,
        "attachments": pictures,
        "videos": Video,
        "showOnHomePage": showH,
        "momentProduct": products,
        "externalPostUrl": textLink,
        "externalPostText": preText,
        "tags": momentTag
    };
    //console.log(JSON.stringify(paramStr));
    var kv = api.require('snKVStorage');
    var result = kv.setObject({
        key: 'postDraft',
        value: paramStr
    });
    //console.log(result);
    api.closeWin();
}

function confirmBack() {
    api.closeWin();
}
