var currencyCode =[
    {"country":"UNITED ARAB EMIRATES (THE)","code":"AED"},
    {"country":"AFGHANISTAN","code":"AFN"},
    {"country":"ALBANIA","code":"ALL"},
    {"country":"CURAÇAO","code":"ANG"},
    {"country":"ANGOLA","code":"AOA"},
    {"country":"ARGENTINA","code":"ARS"},
    {"country":"AUSTRALIA","code":"AUD"},
    {"country":"ARUBA","code":"AWG"},
    {"country":"AZERBAIJAN","code":"AZN"},
    {"country":"BOSNIA AND HERZEGOVINA","code":"BAM"},
    {"country":"BARBADOS","code":"BBD"},
    {"country":"BANGLADESH","code":"BDT"},
    {"country":"BULGARIA","code":"BGN"},
    {"country":"BAHRAIN","code":"BHD"},
    {"country":"BURUNDI","code":"BIF"},
    {"country":"BERMUDA","code":"BMD"},
    {"country":"BRUNEI DARUSSALAM","code":"BND"},
    {"country":"BOLIVIA (PLURINATIONAL STATE OF)","code":"BOB"},
    {"country":"BRAZIL","code":"BRL"},
    {"country":"BAHAMAS (THE)","code":"BSD"},
    {"country":"BHUTAN","code":"BTN"},
    {"country":"BOTSWANA","code":"BWP"},
    {"country":"BELIZE","code":"BZD"},
    {"country":"CANADA","code":"CAD"},
    {"country":"CONGO (THE DEMOCRATIC REPUBLIC OF THE)","code":"CDF"},
    {"country":"LIECHTENSTEIN","code":"CHF"},
    {"country":"SWITZERLAND","code":"CHF"},
    {"country":"CHILE","code":"CLP"},
    {"country":"CHINA","code":"CNY"},
    {"country":"COLOMBIA","code":"COP"},
    {"country":"COSTA RICA","code":"CRC"},
    {"country":"CUBA","code":"CUC"},
    {"country":"CUBA","code":"CUP"},
    {"country":"CABO VERDE","code":"CVE"},
    {"country":"CZECH REPUBLIC (THE)","code":"CZK"},
    {"country":"DJIBOUTI","code":"DJF"},
    {"country":"DENMARK","code":"DKK"},
    {"country":"DOMINICAN REPUBLIC (THE)","code":"DOP"},
    {"country":"ALGERIA","code":"DZD"},
    {"country":"EGYPT","code":"EGP"},
    {"country":"ERITREA","code":"ERN"},
    {"country":"ETHIOPIA","code":"ETB"},
    {"country":"ANDORRA","code":"EUR"},
    {"country":"FIJI","code":"FJD"},
    {"country":"FALKLAND ISLANDS (THE) [MALVINAS]","code":"FKP"},
    {"country":"GUERNSEY","code":"GBP"},
    {"country":"ISLE OF MAN","code":"GBP"},
    {"country":"JERSEY","code":"GBP"},
    {"country":"UNITED KINGDOM OF GREAT BRITAIN AND NORTHERN IRELAND (THE)","code":"GBP"},
    {"country":"GEORGIA","code":"GEL"},
    {"country":"GHANA","code":"GHS"},
    {"country":"GIBRALTAR","code":"GIP"},
    {"country":"GAMBIA (THE)","code":"GMD"},
    {"country":"GUINEA","code":"GNF"},
    {"country":"GUATEMALA","code":"GTQ"},
    {"country":"GUYANA","code":"GYD"},
    {"country":"HONG KONG","code":"HKD"},
    {"country":"HONDURAS","code":"HNL"},
    {"country":"CROATIA","code":"HRK"},
    {"country":"HAITI","code":"HTG"},
    {"country":"HUNGARY","code":"HUF"},
    {"country":"INDONESIA","code":"IDR"},
    {"country":"ISRAEL","code":"ILS"},
    {"country":"BHUTAN","code":"INR"},
    {"country":"INDIA","code":"INR"},
    {"country":"IRAQ","code":"IQD"},
    {"country":"IRAN (ISLAMIC REPUBLIC OF)","code":"IRR"},
    {"country":"ICELAND","code":"ISK"},
    {"country":"JAMAICA","code":"JMD"},
    {"country":"JORDAN","code":"JOD"},
    {"country":"JAPAN","code":"JPY"},
    {"country":"KENYA","code":"KES"},
    {"country":"KYRGYZSTAN","code":"KGS"},
    {"country":"CAMBODIA","code":"KHR"},
    {"country":"COMOROS (THE)","code":"KMF"},
    {"country":"KOREA (THE DEMOCRATIC PEOPLE’S REPUBLIC OF)","code":"KPW"},
    {"country":"KUWAIT","code":"KWD"},
    {"country":"CAYMAN ISLANDS (THE)","code":"KYD"},
    {"country":"KAZAKHSTAN","code":"KZT"},
    {"country":"LAO PEOPLE’S DEMOCRATIC REPUBLIC (THE)","code":"LAK"},
    {"country":"LEBANON","code":"LBP"},
    {"country":"SRI LANKA","code":"LKR"},
    {"country":"LIBERIA","code":"LRD"},
    {"country":"LESOTHO","code":"LSL"},
    {"country":"LIBYA","code":"LYD"},
    {"country":"MOROCCO","code":"MAD"},
    {"country":"MOLDOVA (THE REPUBLIC OF)","code":"MDL"},
    {"country":"MADAGASCAR","code":"MGA"},
    {"country":"MACEDONIA (THE FORMER YUGOSLAV REPUBLIC OF)","code":"MKD"},
    {"country":"MYANMAR","code":"MMK"},
    {"country":"MONGOLIA","code":"MNT"},
    {"country":"MACAO","code":"MOP"},
    {"country":"MAURITANIA","code":"MRU"},
    {"country":"MAURITIUS","code":"MUR"},
    {"country":"MALDIVES","code":"MVR"},
    {"country":"MALAWI","code":"MWK"},
    {"country":"MEXICO","code":"MXN"},
    {"country":"MALAYSIA","code":"MYR"},
    {"country":"MOZAMBIQUE","code":"MZN"},
    {"country":"NAMIBIA","code":"NAD"},
    {"country":"NIGERIA","code":"NGN"},
    {"country":"NICARAGUA","code":"NIO"},
    {"country":"BOUVET ISLAND","code":"NOK"},
    {"country":"NEPAL","code":"NPR"},
    {"country":"COOK ISLANDS (THE)","code":"NZD"},
    {"country":"OMAN","code":"OMR"},
    {"country":"PANAMA","code":"PAB"},
    {"country":"PERU","code":"PEN"},
    {"country":"PAPUA NEW GUINEA","code":"PGK"},
    {"country":"PHILIPPINES (THE)","code":"PHP"},
    {"country":"PAKISTAN","code":"PKR"},
    {"country":"POLAND","code":"PLN"},
    {"country":"PARAGUAY","code":"PYG"},
    {"country":"QATAR","code":"	QAR"},
    {"country":"ROMANIA","code":"RON"},
    {"country":"SERBIA","code":"RSD"},
    {"country":"RUSSIAN FEDERATION (THE)","code":"RUB"},
    {"country":"RWANDA","code":"RWF"},
    {"country":"SAUDI ARABIA","code":"SAR"},
    {"country":"SOLOMON ISLANDS","code":"SBD"},
    {"country":"SEYCHELLES","code":"SCR"},
    {"country":"SUDAN (THE)","code":"SDG"},
    {"country":"SWEDEN","code":"SEK"},
    {"country":"SINGAPORE","code":"SGD"},
    {"country":"SAINT HELENA, ASCENSION AND TRISTAN DA CUNHA","code":"SHP"},
    {"country":"SIERRA LEONE","code":"SLL"},
    {"country":"SOMALIA","code":"SOS"},
    {"country":"SURINAME","code":"SRD"},
    {"country":"SOUTH SUDAN","code":"SSP"},
    {"country":"SAO TOME AND PRINCIPE","code":"STN"},
    {"country":"EL SALVADOR","code":"SVC"},
    {"country":"SYRIAN ARAB REPUBLIC","code":"SYP"},
    {"country":"SWAZILAND","code":"SZL"},
    {"country":"THAILAND","code":"THB"},
    {"country":"TAJIKISTAN","code":"TJS"},
    {"country":"{TURKMENISTAN","code":"TMT"},
    {"country":"TUNISIA","code":"TND"},
    {"country":"TONGA","code":"TOP"},
    {"country":"TURKEY","code":"TRY"},
    {"country":"TRINIDAD AND TOBAGO","code":"TTD"},
    {"country":" TAIWAN (PROVINCE OF CHINA)","code":"TWD"},
    {"country":" TANZANIA, UNITED REPUBLIC OF","code":"TZS"},
    {"country":" UKRAINE","code":"UAH"},
    {"country":" UGANDA","code":"UGX"},
    {"country":"AMERICAN SAMOA","code":"USD"},
    {"country":"URUGUAY","code":"UYU"},
    {"country":" UZBEKISTAN","code":"UZS"},
    {"country":"VENEZUELA (BOLIVARIAN REPUBLIC OF)","code":"VEF"},
    {"country":" VIET NAM","code":"VND"},
    {"country":"VANUATU","code":"VUV"},
    {"country":"SAMOA","code":"WST"},
    {"country":"CAMEROON","code":"XAF"},
    {"country":"ANGUILLA","code":"XCD"},
    {"country":" INTERNATIONAL MONETARY FUND (IMF)","code":"XDR"},
    {"country":"BENIN","code":"	XOF"},
    {"country":"FRENCH POLYNESIA","code":"XPF"},
    {"country":"YEMEN","code":"YER"},
    {"country":"LESOTHO	","code":"ZAR"},
    {"country":"ZAMBIA","code":"ZMW"},
    {"country":"ZIMBABWE","code":"ZWL"},
];