var taskPage;
var token;
apiready = function () {
    api.setWinAttr({
        // bounces: false
        slideBackEnabled: true,
    });

    backListener();

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        loading('show');
        taskPage.getTaskList();
    });

    api.addEventListener({
        name: 'taskReload'
    }, function(ret, err){
        // loading('show');
        taskPage.getTaskList();
    });

    // api.addEventListener({
    //     name: 'task2Completed'
    // }, function(ret, err) {
    //     console.log("task 2 completed!");
    //     // console.log("taskComplete: the task id is: " + ret.value.taskId);
    //     taskPage.completeTask(2);
    // });
    //
    // api.addEventListener({
    //     name: 'taskCompleted'
    // }, function(ret, err) {
    //     console.log("task completed!");
    //     // console.log("taskComplete: the task id is: " + ret.value.taskId);
    //     taskPage.completeTask(ret.value.taskId);
    // });

    taskPage = new Vue({
        el: '#taskPage',
        beforeCreate: function () {
            //initStatus();
            // var checkedIn = localStorage.getItem('isCheckedIn');
            // console.log("beforecreate, checked in?: " + checkedIn);
        },
        created: function() {

        },
        mounted: function () {
            this.getTaskList(true);
            // this.autoLoad();
            // console.log("mount, checked in?: " + this.isCheckedIn);
        },
        data: function () {
            return {
                timer: null,
                taskStatusMap: {},
                banner:'../../image/banners/tasks-'+ lan +'.jpg',
                defaultThumbnail:'../../image/placeholder.png',
                userId: localStorage.getItem('userId'),
                isLoading: true,
                tasksList: [],
                // isCheckedIn: (localStorage.getItem('isCheckedIn') === "true" ? true:false),
                message: MSG,
            }
        },
        filters: {
            formatTime: function (value) {
                if(value){
                    return moment.utc(value).local().format('MM.DD');
                }else{
                    return lan ==="zh"?"不限":"Unlimited";
                }
            }
        },
        destroyed: function(){
            clearTimeout(this.timer);
            this.timer = null;
        },
        methods: {
            getStatus: function(status) {
                if (status === 2 || status === 3) {
                    return true;
                } else {
                    return false;
                }
            },
            autoLoad: function (){
                clearTimeout(this.timer);
                this.timer = null;
                this.timer = setTimeout(function (){
                    this.getTaskList();
                    this.autoLoad();
                }.bind(this), 2000);
            },
            rewardText: function (reward){
                var text = this.message.tasks.totalGet + reward + this.message.tasks.TivReward;
                if (lan === 'en'){
                    text = reward + this.message.tasks.TivReward + this.message.tasks.totalGet;
                }
                return text;
            },
            sloveIconBg: function (status, lock){
                var color = '#4578F3';
                if (this.getStatus(status) === true || lock){
                    color = '#CACCCF';
                }
                return {
                    backgroundColor: color
                };
            },
            sloveIcon: function (id, lock){
                var type = id;
                if (lock){
                    type = 'lock';
                }
                return '../../image/tasks/' + type + '.png';
            },
            resloveLiClass: function(status, lock){
                var cl = '';
                if (this.getStatus(status) === true || lock){
                    cl = 'done';
                }
                return cl;
            },
            getTaskList: function (init) {
                // console.log("get task");
                var that = this;
                var url = "/api-task/usertask/main";
                var lang = (lan === "zh" ? "zh_CN" : "en_US");
                var param = {
                    "lang": lang,
                    "userId": that.userId
                };
                if (init){
                    loading('show');
                    this.isLoading = true;
                }
                apiTask.get(url, param).done(function (rep) {
                    // console.log(JSON.stringify(rep));
                    if (rep.code === 0) {
                        that.isLoading = false;
                        loading('hide');
                        that.tasksList = rep.tasks;
                        that.setLockStatus(that.tasksList.novices);
                    } else {
                        console.error({ msg: JSON.stringify(rep) });
                    }
                });
            },
            setLockStatus: function (list){
                list.forEach(function (item, inx){
                    this.taskStatusMap[item.id] = item.status;
                    if (list[inx - 1] && this.getStatus(list[inx - 1].status) === false){
                        item.lock = true;
                    }
                }.bind(this));
            },

            goTasks:function (taskId,status) {
                // console.log(taskId);
                if (this.getStatus(status) === true) {
                    return false;
                }
                var that = this;
                var type, url, name;
                switch (taskId) {
                    case TASK_CODE.GROUP_PERSON_PROFILE: // 设置个人信息
                        openTabLayout('novice','','widget://html/frame/novice.html', {
                            id: 1,
                            statusMap: this.taskStatusMap
                        });
                        openTabLayout('myProfile', this.message.setting.editProfile,'widget://html/users/my-profile.html', {
                            userId: localStorage.getItem('userId')
                        });
                        break;
                    case TASK_CODE.GROUP_ADD_SHOWCASE: // 添加产品到空间
                        openTabLayout('novice','','widget://html/frame/novice.html', {
                            id: 2,
                            statusMap: this.taskStatusMap
                        });
                        // api.execScript({
                        //     name: 'root',
                        //     script: 'switchToIndex(1,"products");'
                        // });
                        that.closeWin();
                       // openTabLayout('prepareAdd',this.message.mine.selectProductType,'widget://html/products/prepare-add.html');
                        break;
                    case TASK_CODE.GROUP_CREATE_DIGITAL: // 首次创建数字产品
                        type = 'addDigital';
                        url = 'widget://html/products/form-digital-new.html';
                        name = that.message.products.digitalProd;
                        openTabLayout(type, name, url);
                        break;
                    case TASK_CODE.FOLLOW: // 关注5个新推友
                        api.execScript({
                            name: 'root',
                            script: 'switchToIndex(0,"home");'
                        });
                        api.sendEvent({
                            name: 'guideHomeFollow'
                        });
                        that.closeWin();
                        break;
                }
            },
            completeTask: function(taskId) {
                console.log("hi, task! complete task");
            },
            closeWin: function () {
                api.closeWin({name: 'tasks'});
            }
        }
    });

};
