
var hasReceivedInit = false;
var MSG;
var rong;

function getToken() {
    var Token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token');

    if(!Token){
        return false;
    }
    var tt;
    var chatUserId = localStorage.getItem('userName')+'@new';
    var chatUserName = localStorage.getItem('storename');
    var portraitUri = localStorage.getItem('thumbnail') || IMAGE_DEFAULT_AVATAR;
    var paramStr = {
        "userId": chatUserId,
        "name": chatUserName,
        "CustomerId":localStorage.getItem('userId'),
        "portraitUri": portraitUri
    };
    var url = getBaseUrl() + '/api/im/v1/sdkregister';
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token');
    var method = "POST";
    var contentTypeStr = "application/json";
    //console.log("paramStr" + JSON.stringify(paramStr));
    $.when(postApi(url, method, paramStr, token, contentTypeStr)).done(function (data) {
        //console.log(JSON.stringify(data));
        if (data.token) {
            localStorage.setItem('chatToken', data.token);
            localStorage.setItem('chatID', data.UserId);
            api.sendEvent({
                name: 'updateMyChatId',
                extra: {
                    chatId: data.UserId
                }
            });
            initRongAndListener();
            clearTimeout(tt);
        } else {
            tt = setTimeout(function () {
                getToken();
            },15000);
            console.log("获取token失败");
        }

    });

}

function initRongAndListener() {

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    rong = api.require('rongCloud2');

    // rong.getConnectionStatus(function(ret, err) {
    //     // api.toast({ msg: ret.result.connectionStatus });
    //     console.log("[" + api.deviceName + "]" + JSON.stringify(ret.result))
    // });

    // console.log("[" + api.deviceName + "]" + 2222);

    // 断开，且不再接收 Push
    rong.disconnect({
        isReceivePush: true
    }, function(ret, err) {
        // console.log("[" + api.deviceName + "][disconnect]" + JSON.stringify(ret));
        // console.log("[" + api.deviceName + "]" + 3333);
        init();
    });



    // init();

    function init() {
        var params = {
            // "miPush":{
            //     appId:"2882303761518067720",
            //     appKey:"5711806745720"
            // },
            // "huaweiPush":true,
            // "oppoPush":{
            //     appKey:'e54bcd897de44747b842546e9f4446f2',
            //     appSecret:'59c9bce0f933472db19236cf618be596'
            // },
            // "vivoPush":true
        };
        rong.init(params, function (ret, err) {
            // console.log("[" + api.deviceName + "]" + 4444);
            if (ret.status === 'error') {
                console.error("[" + api.deviceName + "] [initRongAndListener] Error: " + JSON.stringify(err));
            } else {
                setConnectionStatusListener();
                connection();
            }
        });
        rong.configurationParameter({
            showNickname: true
        });
    }
}

function setConnectionStatusListener() {
    // console.log("[" + api.deviceName + "]" + 5555);
    rong.setConnectionStatusListener(function (ret, err) {
         //console.log(JSON.stringify(ret)+"aaaa");
        var statuMsg = "";
        var rong_statu = ret.result.connectionStatus;
        switch (rong_statu) {
            case "CONNECTED":
                statuMsg = "连接成功";
                break;
            case "CONNECTING":
                statuMsg = "连接中";
                break;
            case "DISCONNECTED":
                statuMsg = "断开连接";
                break;
            case "KICKED":
                statuMsg = "用户账户在其他设备登录，本机会被踢掉线";
                break;
            case "NETWORK_UNAVAILABLE":
                statuMsg = "网络不可用";
                break;
            case "SERVER_INVALID":
                statuMsg = "服务器异常或无法连接";
                break;
            case "TOKEN_INCORRECT":
                statuMsg = "Token 不正确";
                break;
            default:
                statuMsg = "未知错误";
                break;
        }
        if (rong_statu === "CONNECTED" || rong_statu === "CONNECTING") {
            console.info("[" + api.deviceName + "] 连接状态: " + statuMsg);
        } else {
            console.info("[" + api.deviceName + "] 连接状态: " + statuMsg);
        }
    });
}
// 连接并监听消息传入
function connection() {

    rong.connect({
        token: localStorage.getItem('chatToken')
    }, function (ret, err) {
        // console.log("连接:" + JSON.stringify(ret));

        if (ret.status === 'success') {
            console.warn("[" + api.deviceName + "] [connection] Success: " + JSON.stringify(ret));
            api.sendEvent({
                name: 'conversationListReload',
            });
        } else {
            console.error("[" + api.deviceName + "] [connection] Error: " + JSON.stringify(err));
        }
    });

    rong.setOnMessageRecalledListener(function(ret){
        console.info("[" + api.deviceName + "]"  + '消息撤回监听...' + JSON.stringify(ret));
        api.sendEvent({
            name: 'recallMessageInChatPage',
            extra: {
                messageId: ret.messageId
            }
        });
        api.sendEvent({
            name: 'recallMessageInListPage',
            extra: {
                messageId: ret.messageId
            }
        });
    });

    var isReceiving = false;
    var timeId = null;
    var calling = false;
    var callingTimer = null;

    refreshChatInitCount();

    function refreshChatInitCount() {
        clearTimeout(timeId);
        timeId = setTimeout(function () {
            isReceiving = false;
            // console.log("[" + api.deviceName + "]" + 'isReceiving........ false');
            hasReceivedInit = true;
        }, 2000);
    }

    // -------------------------- 接受消息：文本+命令 --------------------------
    rong.setOnReceiveMessageListener(function(ret, err) {
        var DataMsg = ret.result.message;
        // console.log("[" + api.deviceName + "]" + '接受消息： ' + JSON.stringify(ret));
        // console.log("[" + api.deviceName + "]" + '接受消息： ' + DataMsg.objectName);
        if (DataMsg.objectName === "RC:VCSummary") {
            console.error("[" + api.deviceName + "]$$$$$$$$$$$$$$$$$$$ RC:VCSummary");
        }
        if(DataMsg.objectName === "RC:VCSummary" || DataMsg.objectName === "RC:RcNtf"
                || (!DataMsg.content && !DataMsg.content.extra && !JSON.parse(DataMsg.content.extra).sendName)){
            rong.deleteMessages({
                messageIds: [DataMsg.messageId]
            }, function(ret, err) {
                // api.sendEvent({
                //     name: 'conversationListReload',
                // });
            });
        }else{

            // console.log(222);

            if(DataMsg.objectName ==='RC:CmdMsg'){
                console.info("[" + api.deviceName + "] [Call] " + JSON.stringify(DataMsg.content));
                // 私人：通话接收
                if (DataMsg.content.name === "PrivateAudioCall") {
                    calling = true;
                    clearTimeout(callingTimer);
                    callingTimer = null;
                    callingTimer = setTimeout(function (){
                        if (calling){
                            var data = JSON.parse(DataMsg.content.data);
                            openVCallPage(data.calledId, data.targetId, data.mediaType, data.chatName, data.chatPortrait, 'receive');
                        }
                    }, 1000);
                    return;
                }

                // 私人：通话未开始，挂断
                if (DataMsg.content.name === "vCall:hangupBefore") {
                    console.info("[" + api.deviceName + "] [hangupBefore] ");
                    api.sendEvent({
                        name: 'vCallHangupBefore',
                        extra: DataMsg.content.data
                    });
                    calling = false;

                    return;
                }

                // 私人：通话未开始，挂断：视频
                if (DataMsg.content.name === "videoCall:hangupBefore") {
                    console.info("[" + api.deviceName + "] [hangupBefore] ");
                    api.sendEvent({
                        name: 'videoCallHangupBefore',
                        extra: DataMsg.content.data
                    });
                    calling = false;

                    return;
                }

                // 私人：通话已开始，挂断
                if (DataMsg.content.name === "vCall:hangupAfter") {
                    console.info("[" + api.deviceName + "] [hangupAfter] ");
                    api.sendEvent({
                        name: 'vCallHangupAfter',
                        extra: DataMsg.content.data
                    });
                    return;
                }

                // 私人：通话已开始，挂断：视频
                if (DataMsg.content.name === "videoCall:hangupAfter") {
                    console.info("[" + api.deviceName + "] [hangupAfter] ");
                    api.sendEvent({
                        name: 'videoCallHangupAfter',
                        extra: DataMsg.content.data
                    });
                    return;
                }

                // 私聊：发起通话
                if (DataMsg.content.name === "vPrivateCall:begin") {
                    console.info("[" + api.deviceName + "] [vPrivateCall:begin] " + JSON.stringify(DataMsg));
                    var data = JSON.parse(DataMsg.content.data);
                    api.notification({
                        notify: {
                            title: data.sendName,
                            content: MSG.chat.toCall
                        }
                    });

                    return;
                }

                if (DataMsg.content.name === "vGroupCall:invite") {
                    console.info("[" + api.deviceName + "] [vGroupCall:invite] " + JSON.stringify(DataMsg));
                    // var data = JSON.parse(DataMsg.content.data);
                    setTimeout(function () {
                        api.sendEvent({
                            name: 'joinMembersIntoCall',
                            extra: {
                                newMembers: JSON.parse(DataMsg.content.data)
                            }
                        });
                    }, 300);
                    return;
                }

                // 群聊：发起通话
                // if (DataMsg.content.name === "vGroupCall:begin") {
                //     console.info("[" + api.deviceName + "] [vGroupCall:begin] " + JSON.stringify(DataMsg));
                //     var data = JSON.parse(DataMsg.content.data);
                //     api.notification({
                //         notify: {
                //             title: data.sendName,
                //             content: MSG.chat.toCall
                //         }
                //     });
                //     return;
                // }

                // 语音通话：接电话
                // if(DataMsg.content.name === "vCall" && DataMsg.content.data ==="accept"){
                //     console.info("[" + api.deviceName + "] [CallConnected] ");
                //     api.sendEvent({
                //         name: 'CallConnected',
                //     });
                //     api.notification({
                //         vibrate:[500]
                //     });
                // }
                // else if(DataMsg.content.name === "vCall" && DataMsg.content.data ==="hangup"){
                //     console.info("[" + api.deviceName + "] [hangup] ");
                //     api.sendEvent({
                //         name: 'vCallHangup',
                //     });
                // }



            }else{
                // console.log("[" + api.deviceName + "]" + '【openChatPage】：' + localStorage.getItem('openChatPage'));
                if(localStorage.getItem('openChatPage')){
                    var message = JSON.stringify(ret.result.message);
                    api.sendEvent({
                        name: 'showMessageInPage',
                        extra: {
                            message: message,
                        }
                    });

                }else{

                    // switch (DataMsg.content.text) {
                    //     case CHAT_STATUS.HANG_UP_SENDER:
                    //         // rong.configurationParameter({
                    //         //     alertTitle: MSG.chat.side + MSG.chat.cancel,
                    //         //     showNickname: false
                    //         // });
                    //         console.log("[" + api.deviceName + "]" + "1111");
                    //         break;
                    //     case CHAT_STATUS.HANG_UP_RECEIVER:
                    //         console.log("[" + api.deviceName + "]" + "2222");
                    //         break;
                    //     default:
                    //     // rong.configurationParameter({
                    //     //     alertTitle: sendName + msg,
                    //     //     showNickname: false
                    //     // });
                    // }

                    // console.warn("[" + api.deviceName + "] " + ': ' + ret.disConnectReason);
                    if (hasReceivedInit === false) {
                        if (isReceiving === true) {
                            refreshChatInitCount();
                            return;
                        }

                        isReceiving = true;
                        console.log("[" + api.deviceName + "]" + 'isReceiving........ true');
                    }

                    // console.log("[" + api.deviceName + "]" + 'start........' + moment().format());


                    // 更新聊天列表
                    api.sendEvent({
                        name: 'conversationListReload'
                    });

                    rong.getConversationNotificationStatus({
                        conversationType: DataMsg.conversationType,
                        targetId: DataMsg.targetId
                    }, function(ret, err) {
                        if (ret.result.code === 1) {
                            if (api.systemType === 'android') {

                                var obj = JSON.parse(DataMsg.content.extra);
                                if (obj && obj.sendName) {
                                    if (DataMsg.objectName === 'RC:VcMsg') {
                                        api.notification({
                                            notify: {
                                                title: obj.sendName,
                                                content: '[' + MSG.general.voiceCall + ']'
                                            }
                                        });
                                    } else if (DataMsg.objectName === 'RC:ImgMsg') {
                                        api.notification({
                                            notify: {
                                                title: obj.sendName,
                                                content: '[' + MSG.general.pictures + ']'
                                            }
                                        });
                                    } else if (DataMsg.objectName === 'RC:ImgTextMsg') {
                                        switch (obj.textType) {
                                            case ('tweebuck' || undefined):
                                                api.notification({
                                                    notify: {
                                                        title: obj.sendName,
                                                        content: MSG.chat.tweebuckMessage
                                                    }
                                                });
                                                break;
                                            case 'video':
                                                api.notification({
                                                    notify: {
                                                        title: obj.sendName,
                                                        content: MSG.chat.video
                                                    }
                                                });
                                                break;
                                            default:
                                                api.notification({
                                                    notify: {
                                                        title: obj.sendName,
                                                        content: MSG.chat[obj.textType]
                                                    }
                                                });
                                        }

                                    } else if (DataMsg.objectName === 'RC:FileMsg') {
                                        api.notification({
                                            notify: {
                                                title: obj.sendName,
                                                content: MSG.chat.file
                                            }
                                        });
                                    } else {
                                        // 格式化语音状态类的消息
                                        // var newMsg;
                                        // switch (DataMsg.content.text) {
                                        //     case CHAT_STATUS.NO_ANSWER:
                                        //         if (DataMsg.messageDirection === 'RECEIVE') {
                                        //             newMsg = MSG.chat.callCancel;
                                        //         } else {
                                        //             newMsg = MSG.chat.noAnswered;
                                        //         }
                                        //         break;
                                        //     case CHAT_STATUS.HANG_UP_SENDER:
                                        //         newMsg = MSG.chat.callName + MSG.chat.cancel;
                                        //         break;
                                        //     case CHAT_STATUS.HANG_UP_RECEIVER:
                                        //         if (DataMsg.messageDirection === 'RECEIVE') {
                                        //             newMsg = MSG.chat.side + MSG.chat.reject;
                                        //             newMsg = MSG.chat.callCancel;
                                        //         } else {
                                        //             newMsg = MSG.chat.reject;
                                        //         }
                                        //         break;
                                        //     default:
                                        //         newMsg = DataMsg.content.text;
                                        // }

                                        api.notification({
                                            notify: {
                                                title: obj.sendName,
                                                content: DataMsg.content.text
                                            }
                                        });
                                    }
                                } else {
                                    api.notification({
                                        notify: {
                                            content: DataMsg.content.text || MSG.chat.haveNewMessage
                                        }
                                    });
                                }
                            } else {
                                api.notification();
                            }

                            // notificationNow = moment().format();
                        }

                        // refreshChatInitCount();
                    });

                    // //更新聊天列表
                    // api.sendEvent({
                    //     name: 'conversationListReload',
                    // });
                    // rong.getConversationNotificationStatus({
                    //     conversationType: DataMsg.conversationType,
                    //     targetId: DataMsg.targetId
                    // }, function(ret, err) {
                    //     if (ret.result.code ===1){
                    //         if(!notificationNow || moment().diff(notificationNow, 'seconds') >30){    // 每30秒才触发一次通知避免登录时连续发出通知信息
                    //             if(api.systemType ==='android'){
                    //                 api.notification({
                    //                     notify: {
                    //                         content: MSG.chat.haveNewMessage
                    //                     }
                    //                 });
                    //             }else{
                    //                 api.notification();
                    //             }
                    //             notificationNow = moment().format();
                    //         }
                    //
                    //     }
                    //
                    // })
                }
            }

            // 获取未读消息
            // ChatFunction.getUnreadCount();

        }

    });

    // -------------------------- 接受消息：通话：拨打 --------------------------

    //监听音视频消息接入
    var callerUserId,Source;

    // rong.removeCallReceiveListener({
    //     target: 'didReceiveCall'
    // });
    console.log("[" + api.deviceName + "]" + '【addCallReceiveListener】[开始监听]');
    rong.addCallReceiveListener({
        target: 'didReceiveCall'
    },function(ret){
        console.log("[" + api.deviceName + "]" + "接到呼入信息" + JSON.stringify(ret));
        console.log("[" + api.deviceName + "]" + '【didReceiveCall】[收到来电]');

        var calledId = ret.callSession.callId;
        var targetId = ret.callSession.targetId;
        var mediaType = ret.callSession.mediaType;
        var conversationType = ret.callSession.conversationType;
        callerUserId = ret.callSession.callerUserId;
        var extraObj = JSON.parse(ret.callSession.extra);
        Source = extraObj.Source;

        if(ret.callSession.conversationType === 'PRIVATE'){

            var chatName = extraObj.sendName;
            var chatPortrait = extraObj.sendPortrait;

            // api.openFrame({
            //     name: 'vCallPage',
            //     url: 'widget://html/chat/vcall.html',
            //     rect: {
            //         x: 0,
            //         y: 0,
            //         w: 'auto',
            //         h: 'auto'
            //     },
            //     pageParam: {
            //         chatName: chatName,
            //         portrait: chatPortrait,
            //         calledId: calledId,
            //         mediaType: mediaType,
            //         targetId: targetId,
            //         direction: 'receive'
            //     },
            //     bounces: false,
            //     bgColor: 'rgba(0,0,0,0.7)',
            //     fixedOn: 'ui_layout',
            //     animation:{
            //         type: "movein",
            //         subType: "from_top",
            //         duration: 200
            //     }
            // });
            // console.log(111);
            // 聚焦到互动
            // api.setFrameGroupIndex({
            //     name: 'index',
            //     index: 2,
            // });
            // openChatPage({
            //     targetId: targetId,
            //     userName: extraObj.sendName,
            //     userPortrait: extraObj.sendPortrait,
            //     conversationType: conversationType,
            //     isTop: false,
            //     notificationStatus: 'NOTIFY',
            // }, 'fast');

            if (mediaType === 'audio') {
                openVCallPage(calledId, targetId, mediaType, chatName, chatPortrait, 'receive');
            } else {
                console.log("[" + api.deviceName + "]" + '【视频接收方】');
                openVideoCallPage(calledId, targetId, mediaType, chatName, chatPortrait, 'receive');
            }

        }else{

            api.sendEvent({
                name: 'openGroupVCallPage',
                extra: {
                    calledId: calledId,
                    targetId: targetId,
                    direction: 'receive',
                    membersInfo: extraObj.members,
                    callerUserId: callerUserId,
                    mediaType: mediaType,
                    chatName: extraObj.chatName,
                    chatPortrait: extraObj.chatPortrait
                }
            });

        }

    });

    // rong.addCallReceiveListener({
    //     target: 'didReceiveCallRemoteNotification'
    // },function(ret){
    //     console.log("[" + api.deviceName + "]" + '【didReceiveCallRemoteNotification】');
    // });
    // rong.addCallReceiveListener({
    //     target: 'didCancelCallRemoteNotification'
    // },function(ret){
    //     console.log("[" + api.deviceName + "]" + '【didCancelCallRemoteNotification】');
    // });

    // -------------------------- 接受消息：通话：通话进行 --------------------------
    rong.removeCallSessionListener({
        target: 'didConnect'
    });
    //音频通话监听状态
    //通话进行中，已接通
    rong.addCallSessionListener({
        target: 'didConnect'
    }, function(ret) {
        if (api.deviceName === 'Netease') {
            console.log("---------------------------------------- [" + api.deviceName + '] [didConnect] :' + JSON.stringify(ret) +'监听到已连接');
        } else {
            console.log("[didConnect] [" + api.deviceName + '] :' + JSON.stringify(ret) +'监听到已连接');
        }

        // 服务于发起方
        api.sendEvent({
            name: 'vCallConnected',
            extra: {
                userId: ret.userId
            }
        });

        api.notification({
            vibrate:[500]
        });
        // if(Source ==='ios'){
        //     rong.sendCommandMessage({   //由于监听状态在ios 有问题 所以使用命令消息来传递接通状态
        //         conversationType: 'PRIVATE',
        //         targetId: callerUserId,
        //         name: 'vCall',
        //         data: 'accept'
        //     }, function(ret, err) {
        //         //console.log(ret);
        //     });
        // }

    });

    // 对端用户加入了通话的事件，有用户加入
    // 发起方
    // 接受方，安卓OK
    rong.removeCallSessionListener({
        target: 'remoteUserDidJoin'
    });
    rong.addCallSessionListener({
        target: 'remoteUserDidJoin'
    }, function(ret) {
        // FIXME 被动
        if (api.deviceName === 'Netease') {
            console.log("---------------------------------------- [remoteUserDidJoin] [" + api.deviceName + "] 对端用户加入了通话的事件:" + JSON.stringify(ret));
        } else {
            console.log("[remoteUserDidJoin] [" + api.deviceName + "] 对端用户加入了通话的事件:" + JSON.stringify(ret));
        }

        // 视频通话
        if (ret.mediaType === 'video') {
            api.sendEvent({
                name: 'videoCallConnected',
                extra: {
                    userId: ret.userId
                }
            });
        }

        api.sendEvent({
            name: 'refreshGroupCallStatus',
            extra: {
                userId: ret.userId,
                type: 'accept'
            }
        });
    });

    // 对端用户挂断，有用户离开
    rong.removeCallSessionListener({
        target: 'remoteUserDidLeft'
    });
    rong.addCallSessionListener({
        target: 'remoteUserDidLeft'
    }, function(ret) {
        if (api.deviceName === 'Netease') {
            console.log("---------------------------------------- [remoteUserDidLeft] [" + api.deviceName + "] 已挂断:" + JSON.stringify(ret));
        } else {
            console.log("[remoteUserDidLeft] [" + api.deviceName + "] 已挂断:" + JSON.stringify(ret));
        }

        // doResean(ret.disConnectReason);

        // api.sendEvent({
        //     name: 'CallHangup',
        // });

        api.sendEvent({
            name: 'refreshGroupCallStatus',
            extra: {
                userId: ret.userId,
                type: 'hangup'
            }
        });

    });

    // -------------------------- 接受消息：通话：通话结束 --------------------------
    // 通话已结束
    // 无人接听
    rong.removeCallSessionListener({
        target: 'didDisconnect'
    });
    rong.addCallSessionListener({
        target: 'didDisconnect'
    }, function(ret) {

        // rong.configurationParameter({
        //     alertTitle: MSG.chat.callCancelFull,
        //     showNickname: false
        // });
        //
        // setTimeout(function () {
        //     rong.configurationParameter({
        //         showNickname: true
        //     });
        // }, 3000);

        if (api.deviceName === 'Netease') {
            console.log("---------------------------------------- [didDisconnect] [" + api.deviceName + "] 已挂断didDisconnect:" + JSON.stringify(ret));
        } else {
            console.log("[didDisconnect] [" + api.deviceName + "] 已挂断didDisconnect:" + JSON.stringify(ret));
        }

        // api.sendEvent({
        //     name: 'CallHangup',
        // });
        // FIXME
        if (ret.conversationType && ret.conversationType === 'group') {

            // 【被动】发起方取消已发出的通话请求，事件发给接收方
            // 11: 对方取消已发出的通话请求
            // 12：对方拒绝收到的通话请求
            // 13：通话过程对方挂断
            // 1：己方取消已发出的通话请求
            if (ret.disConnectReason === 1 || ret.disConnectReason === 2 || ret.disConnectReason === 3
                    || ret.disConnectReason === 11 || ret.disConnectReason === 12 || ret.disConnectReason === 13) {
                api.sendEvent({
                    name: 'refreshGroupCallStatus',
                    extra: {
                        type: 'hangup',
                        userId: ret.callerUserId,
                        disConnectReason: ret.disConnectReason
                    }
                });
            }

        } else {
            // 发起方取消已发出的通话请求，事件发给接收方
            if (ret.disConnectReason === 11) {
                // alert(11);
                api.sendEvent({
                    name: 'CallSenderCancel',
                });
                closeVCallPage();
            }

            // 对方未接听，事件给发起方
            if (ret.disConnectReason === 15) {
                // alert(15);
                api.sendEvent({
                    name: 'CallNobodyReceived',
                });
            }

            // 对方未接收，事件发给接收方
            if (ret.disConnectReason === 5) {
                // alert(5);
                api.sendEvent({
                    name: 'CallNotReceive',
                });
            }

            // 有人离开
            if (ret.disConnectReason === 13) {
                // api.sendEvent({
                //     name: 'CallSomeoneLeave',
                // });
                console.info("[" + api.deviceName + "] [hangupAfter] ");
                api.sendEvent({
                    name: 'videoCallHangupAfter'
                });
            }

            // 安卓，监听到对方正在通话中
            if (ret.disConnectReason === 14) {
                console.info("[" + api.deviceName + "] [对方正在通话中...] ");
                api.sendEvent({
                    name: 'callingIsBusy'
                });
            }
        }

        // 1:己方取消已发出的通话请求、2：己方拒绝收到的通话请求、3：己方挂断、4：己方忙碌、5：己方未接听、
        // 6：当前引擎不支持、7：己方网络出错、8：己方摄像头初始化错误，可能是没有打开使用摄像头权限、
        // 9：其他端已经接听、11：对方取消已发出的通话请求、12：对方拒绝收到的通话请求、13：通话过程对方挂断、
        // 14：对方忙碌、15：对方未接听、16：对方引擎不支持、17：对方网络错误、18：im ipc服务已断开
        // console.warn("[" + api.deviceName + "] " + 'ret.disConnectReason: ' + JSON.stringify(ret));

        // doResean(ret.disConnectReason);
    });

    api.addEventListener({
        name: 'sendMessagesEvent',
    }, function (ret, err) {
        var params = ret.value;
        ChatFunction.sendMessagesFunction(params.type, params.targetId, params.conversationType, params.msg,
            params.sendUserId, params.sendName, params.sendPortrait, params.chatUserId, params.chatName, params.chatPortrait,
            params.Source, params.groupName, params.avatar, params.duration, params.textType, params.isVoiceRead, params.mentionedInfo);
    });

    api.addEventListener({
        name: 'openVCallPage',
    }, function (ret, err) {
        var params = ret.value;
        openVCallPage(params.calledId, params.targetId, params.mediaType, params.chatName, params.chatPortrait, params.direction, params.extra);
    });

    api.addEventListener({
        name: 'openVideoCallPage',
    }, function (ret, err) {
        var params = ret.value;
        openVideoCallPage(params.calledId, params.targetId, params.mediaType, params.chatName, params.chatPortrait, params.direction, params.extra);
    });

    api.addEventListener({
        name: 'openGroupVCallPage',
    }, function (ret, err) {
        var params = ret.value;
        openGroupVCallPage(params.calledId, params.targetId, params.mediaType, params.chatName,
            params.chatPortrait, params.direction, params.callerUserId, params.membersInfo, params.membersGroup);
    });

    function doResean(disConnectReason) {
        switch (disConnectReason) {
            case 1:
            case 11:
                api.sendEvent({
                    name: 'vCallHangupBefore',
                    extra: {
                        from: 'sender'
                    }
                });
                break;
            case 2:
                api.sendEvent({
                    name: 'vCallHangupBefore',
                    extra: {
                        from: 'receiver'
                    }
                });
                break;
            default:
                api.sendEvent({
                    name: 'vCallHangupBefore',
                    extra: {

                    }
                });

        }
    }

}

var ChatFunction = {
    getUnreadCount:function (muteNum, announcementNumber) {
        // console.log("[" + api.deviceName + "]" + "muteNum: " + muteNum + ', announcementNumber: ' + announcementNumber);
        rong.getTotalUnreadCount(function(ret, err) {
            if (ret.result !== 0) {
                // console.log("[" + api.deviceName + "]" + "聊天未读初始化数量: " + ret.result);
                // console.log("[" + api.deviceName + "]" + "聊天未读初始化数量: " + +muteNum);
                // console.log("[" + api.deviceName + "]" + "聊天未读初始化数量: " + announcementNumber);
                setUnread(ret.result - +muteNum + announcementNumber);
            } else {
                // console.log("[" + api.deviceName + "]" + "聊天未读初始化数量为0...");
                setUnread(announcementNumber);
            }
        })
    },
    sendMessagesFunction: function (type,targetId,conversationType,msg,sendUserId,sendName,sendPortrait,chatUserId, chatName,chatPortrait,Source,groupName,avatar,duration,textType, isVoiceRead, mentionedInfo) {

        // switch (msg) {
        //     case CHAT_STATUS.HANG_UP_SENDER:
        //         rong.configurationParameter({
        //             alertTitle: MSG.chat.side + MSG.chat.cancel,
        //             showNickname: false
        //         });
        //         console.log("[" + api.deviceName + "]" + "1111");
        //         break;
        //     default:
        //         // rong.configurationParameter({
        //         //     alertTitle: sendName + msg,
        //         //     showNickname: false
        //         // });
        // }

        var receiveName = chatName;
        if (groupName !== 'undefined' && groupName !== undefined) {
            receiveName = groupName;
        }
        var receivePortrait = chatPortrait;
        if (avatar !== 'undefined' && avatar !== undefined) {
            receivePortrait = avatar;
        }
        var extra = {
            sendUserId: sendUserId,
            sendName: sendName,
            sendPortrait: sendPortrait,
            receiveUserId: chatUserId,
            receiveName: receiveName,
            receivePortrait: receivePortrait,
            userInfo: {nickName: sendName},
            Source: Source,
            textType: textType,  // call, 这里传递是否是语音通话的状态信息，
        };
        if (textType) {
            extra.isVoiceRead = false;
        }
        if(type ==='text'){
            var newMsg = formatLink(msg);
            var param = {
                conversationType: conversationType,
                targetId: targetId,
                text: newMsg,
                extra: JSON.stringify(extra)
            };
            if (mentionedInfo) {
                if (mentionedInfo.type === 'all') {
                    param.mentionedInfo = {
                        type: 'all'
                    }
                } else {
                    mentionedInfo.type = "part";
                    param.mentionedInfo = mentionedInfo;
                }
            }
            //console.log('param.mentionedInfo: ' + JSON.stringify(param.mentionedInfo));
            rong.sendTextMessage(param, function (ret, err) {
                // console.log(JSON.stringify(ret));
                // console.log(JSON.stringify(err));
                if(localStorage.getItem('openChatPage') && ret.status === 'prepare'){
                    var message = JSON.stringify(ret.result.message);
                    api.sendEvent({
                        name: 'showMessageInPage',
                        extra: {
                            message: message,
                        }
                    });
                }
                if(err && err.code ===30003){

                    setTimeout(function () {
                        rong.deleteMessages({
                            messageIds: [ret.result.message.messageId]
                        }, function (ret, err) {
                        });
                        rong.sendTextMessage({
                            conversationType: conversationType,
                            targetId: targetId,
                            text: newMsg,
                            extra: JSON.stringify(extra)
                        }, function (ret, err) {
                            //console.log(JSON.stringify(ret));
                        });

                    },1000)
                }
            });
        }else if(type ==='img'){
            rong.sendImageMessage({
                conversationType: conversationType,
                targetId: targetId,
                imagePath: msg,
                extra: JSON.stringify(extra)
            }, function (ret, err) {
                // console.log("[" + api.deviceName + "]" + "照片发出..." + JSON.stringify(ret));
                if(localStorage.getItem('openChatPage') && ret.status === 'prepare'){
                    var message = JSON.stringify(ret.result.message);
                    api.sendEvent({
                        name: 'showMessageInPage',
                        extra: {
                            message: message,
                        }
                    });
                }
            });
        }else if(type ==='voice'){
            rong.sendVoiceMessage({
                conversationType: conversationType,
                targetId: targetId,
                voicePath: msg,
                duration: Number(duration),
                extra: JSON.stringify(extra)
            }, function (ret, err) {
                //  console.log("语音:" +JSON.stringify(ret));
                // console.log("语音错误:" +JSON.stringify(err));
                if(localStorage.getItem('openChatPage') && ret.status === 'prepare'){
                    var message = JSON.stringify(ret.result.message);
                    api.sendEvent({
                        name: 'showMessageInPage',
                        extra: {
                            message: message,
                        }
                    });
                    api.startPlay({
                        path: 'widget://image/sand.mp3'
                    });
                    api.notification({
                        vibrate:[500]
                    });
                }
                if(err && err.code ===30003){

                    setTimeout(function () {
                        rong.deleteMessages({
                            messageIds: [ret.result.message.message]
                        }, function (ret, err) {
                            // console.log(JSON.stringify(ret) +' 删除消息');
                            // console.log(JSON.stringify(err)+' 删除消息错误');
                        });
                        $('#chatId'+ret.result.message.message).remove();
                        ChatFunction.sendVoiceAgain(type,targetId,conversationType,msg,sendName,sendPortrait,chatName,chatPortrait,Source,duration)
                    },5000);
                }
            });
        }else if(type ==='imgText'){
            if (textType === 'tweebuck') {
                // var description = {
                //     "TransferId":msg.TransferId,
                //     "HistoryId":msg.HistoryId,
                //     "CreatedAtUtc":msg.CreatedAtUtc,
                //     "Tweebuck":msg.Tweebuck,
                //     "FromGuid":msg.FromGuid,
                //     "FromId":msg.FromId,
                //     "ToGuid":msg.ToGuid,
                //     "ToId":msg.ToId,
                //     "StatementId":msg.StatementId,
                // };
                //console.log(JSON.stringify(description));
                rong.sendRichContentMessage({
                    conversationType: conversationType,
                    targetId: targetId,
                    title: duration,  //* * * * 这里使用duration 参数来传递 币的数量
                    description: msg,
                    imageUrl: Source, //* * * * 这里使用duration 参数来传递 接受状态
                    extra: JSON.stringify(extra)
                }, function (ret, err) {
                    // console.log("照片发出:" +JSON.stringify(ret));
                    if(localStorage.getItem('openChatPage') && ret.status === 'prepare'){
                        var message = JSON.stringify(ret.result.message);
                        api.sendEvent({
                            name: 'showMessageInPage',
                            extra: {
                                message: message,
                            }
                        });
                    }
                });
            }
        } else if (type === 'file') {
            rong.sendFileMessage({
                conversationType: conversationType,
                targetId: targetId,
                filePath: msg,
                extra: JSON.stringify(extra)
            }, function(ret, err) {
                console.warn("[" + api.deviceName + "]" + JSON.stringify(ret));
                if (ret.status === 'progress') {
                    api.showProgress({
                        title: MSG.general.uploading,
                        text: ret.result.progress + '%',
                        modal: false
                    });
                } else if (ret.status === 'success') {
                    api.hideProgress();
                    console.log(4444);
                    if (localStorage.getItem('openChatPage')) {
                        var message = JSON.stringify(ret.result.message);
                        api.sendEvent({
                            name: 'showMessageInPage',
                            extra: {
                                message: message,
                            }
                        });
                    }
                } else if (ret.status === 'error') {
                    if (err.code === -3) {
                        api.toast({
                            msg: '参数错误',
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                    console.log('error: ' + err.code);
                }
            });
        }

    },
    sendVoiceAgain:function (type,targetId,conversationType,msg,sendName,sendPortrait,chatName,chatPortrait,Source,duration) {
        var extra = {
            sendName: sendName,
            sendPortrait: sendPortrait,
            receiveName: chatName,
            receivePortrait: chatPortrait,
            Source: Source,
            userInfo: {nickName: sendName},
        };

        rong.sendVoiceMessage({
            conversationType: conversationType,
            targetId: targetId,
            voicePath: msg,
            duration: Number(duration),
            extra: JSON.stringify(extra)
        }, function (ret, err) {
            // console.log("语音再次错误:" +JSON.stringify(err));

            if(err && err.code ===30003){

                setTimeout(function () {
                    rong.deleteMessages({
                        messageIds: [ret.result.message.messageId]
                    }, function (ret, err) {
                    });
                    ChatFunction.sendVoiceAgain(type,targetId,conversationType,msg,sendName,sendPortrait,chatName,chatPortrait,Source,duration)
                },5000)
            }
        });
    }
};

function formatLink (text) {
    if (text) {
        return text.replace(REG_LINK, '<a href="javascript:;" data-url="$1$2" onclick="openBrowser(this)">$1$2</a>');
    }
}

function initMQ() {
    var mq = api.require('meiQia');
    Code = api.loadSecureValue({
        sync: true,
        key: 'mqkey'
    });
    var param = {
        appkey: Code
    };
    // alert("初始化Code  "+JSON.stringify(Code));
    mq.initMeiQia(param, function(ret, err) {
        if (ret) {
            localStorage.setItem('MQCliednId',ret.clientId);
            // //初始化成功
            //console.log(JSON.stringify(ret));
            // alert("初始化  "+JSON.stringify(ret));
            // alert("初始化MQCliednId "+localStorage.getItem('MQCliednId'));
        }
    });
}

/**
 * 高亮消息红点
 */
function setUnread(number) {
    // console.log('number: ' + number);
    number = parseInt(number);
    if (number > 0) {
        api.setAppIconBadge({
            badge: number
        });
        $('.ui-msg').text(number).show();
    } else {
        api.setAppIconBadge({
            badge: 0
        });
        $('.ui-msg').text('').hide();
    }
}
