
var id = 0;
var liWith;
var remaining = 9;
setTimeout(function () {
    liWith = $('#width').width();
}, 0);
// var MomentPage = $('#momentpage').val() || $('#photoWall').val() || $('#Activity').val();
// var MomentPage = $('#momentpage').val() ;
// //使用input获取照片
// var picArray = [];
var imgUploading = false;

initPicture();

initVideo();

function initPicture() {

    var $getPhotosNew = $('#getPhotosNew');

    //使用新选择器获取图片
    $getPhotosNew.on('touchstart', function () {
        if(remaining === 0){
            api.toast({
                msg: MSG.tips.picMore9,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        $('#imagesTips').remove();
        var systemType = api.systemType;

        actionSheet([
            {
                text: MSG.general.takePicture,
                callback: function () {
                    if(!checkPermission('camera')){
                        if (systemType === 'android') {
                            requestPermission("camera");
                        }else{
                            api.requestPermission({
                                list: ["camera"],
                                code: 1
                            }, function (ret, err) {
                                if (ret.list[0].granted) {
                                    useCamera();
                                }
                            });
                        }

                    }else{
                        useCamera();
                    }
                }
            },
            {
                text: MSG.general.library,
                callback: function () {
                    if(!checkPermission('photos')){
                        if (systemType === 'android') {
                            requestPermission("photos");
                        }else{
                            api.requestPermission({
                                list: ["photos"],
                                code: 1
                            }, function (ret, err) {
                                if (ret.list[0].granted) {
                                    selectImagesFromAlbum();
                                }
                            });
                        }

                    }else{
                        selectImagesFromAlbum();
                    }
                }
            }
        ]);

    });

    var $uploadImgBox = $('#uploadImgBox');

    // 拖动图片
    Sortable.create($uploadImgBox[0],
        {
            animation: 150,
            onEnd: function (e) {
                console.log(111);
                console.log(e.target);
            },
            ignore:'a',
            ghostClass:'.img-li',
            handle:'.img-li'
        });

    // 打开图片
    $uploadImgBox.on('click', '.img-li .img', function (e) {
        // var UIInput = api.require('UIInput');
        // UIInput.hide({
        //     id:1
        // });
        var dom = $(this).closest('li.img-li')[0];

        // var index = $(this).closest('li.img-li');
        //$('.swiper-container').show().find('.swiper-wrapper').empty();
        var el = $('#uploadImgBox').find('li.img-li');
        var picUrls = [];
        var index;
        for(var i = 0; i < el.length; i++) {
            picUrls.push($(el[i]).find('.img').attr('src'));
            if (el[i] === dom) {
                index = i;
            }
        }

        var UIPhotoViewer = api.require('UIPhotoViewer');
        UIPhotoViewer.open({
            images: picUrls,
            placeholderImg: 'widget://image/lost_images.jpg',
            bgColor: '#000',
            activeIndex:index,
            zoomEnabled:true,
            gestureClose:true
        }, function(Ret, err) {
            if (Ret.eventType === 'click' ) {
                UIPhotoViewer.close();
            }
        });

    });
    // 删除图片
    $uploadImgBox.on('click', '.img-li i.icon-trash-solid', function (event) {
        var li = $(this).closest('.img-li');
        li.remove();

        if($('#uploadImgBox').find('.loading').length===0){
            imgUploading = false;
        }
        remaining ++;
    });

    //打开相机照相
    function useCamera() {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'url',
            allowEdit: false,
            quality: 80,
            targetWidth: 800,
            saveToPhotoAlbum: true
        }, function (ret, err) {
            if (ret.data) {
                var pic = ret.data;

                $('#uploadImgBox').prepend(
                    getPhotoItem(id, liWith, pic, true)
                );

                uploadImagesNew(pic, 'picture.jpg.jpg', id);
                id++;
                remaining --;
            } else {
                loading('hide');
            }
        });
    }

    //在相册选取
    function selectImagesFromAlbum() {
        var UIAlbumBrowser = api.require('UIAlbumBrowser');
        UIAlbumBrowser.open({
            max: remaining,
            isOpenPreview:true,
            classify:true,
            type:'image',
            alertTitle: lan ==="zh"?"最多能选9张图片":"More then 9 pictures",
            alertBtnTitle:"OK",
            styles: {
                bg: '#FFFFFF',
                cameraImg: 'widget://res/cameraImg.png',
                mark: {
                    icon: '',
                    position: 'bottom_left',
                    size: 20
                },
                nav: {
                    bg: '#252525',
                    cancelColor: '#fff',
                    cancelSize: 16,
                    nextStepColor: '#fff',
                    nextStepSize: 16,
                    cancelText: lan === 'zh'?'取消':'Cancel',
                    finishText: 'OK',
                },
                bottomTabBar: {
                    bg: 'rgba(0,0,0,0.6)',
                    unPreviewTitleColor:'rgba(0,0,0,0.25)',
                    previewTitleColor: '#fff',
                    previewTitle:lan === 'zh'?'预览':'Preview',
                    previewTitleSize: 15,
                }
            },
        }, function (ret) {
            if (ret.eventType === 'confirm') {
                //UIAlbumBrowser.closePicker();

                var path = ret.list;

                var len = path.length;
                if (api.systemType.toLowerCase() === "ios") {
                    //console.log(JSON.stringify(path));
                    for (i = 0; i < len; i++) {
                        UIAlbumBrowser.transPath({
                            path: path[i].path
                        }, function (ret, err) {
                            setImages(ret.path, id);
                            id++;
                        });
                    }
                } else {
                    for (J = 0; J < len; J++) {
                        setImages(path[J].path, id);
                        id++;
                    }
                }

            }
        });
    }

    function setImages(path, id) {
        loading('show');
        var savePath = api.fsDir;
        var specialStr = path.substring(path.lastIndexOf('/') + 1).split(".")[0];
        var imageFilter = api.require('imageFilter');
        var pattern = new RegExp("[`/~@#$^&=|{}':;, \\[\\]<>￥…‘；：”“。，、？+]");
        var picName = "";
        for (var i = 0; i < specialStr.length; i++) {
            picName += specialStr.substr(i, 1).replace(pattern, '');
        }
        imageFilter.getAttr({
            path: path
        },function( ret, err ){
            if( ret.status ){

                var originWidth = ret.width;
                var originHeight = ret.height;
                //alert(ret.width  +"kuan");
                //alert(ret.height  +"gao");

                var maxWidth = 1080, maxHeight = 2400;
                var targetWidth = originWidth, targetHeight = originHeight;
                if (originWidth > maxWidth || originHeight > maxHeight) {
                    if (originWidth / originHeight > maxWidth / maxHeight) {
                        targetWidth = maxWidth;
                        targetHeight = Math.round(maxWidth * (originHeight / originWidth));
                    } else {
                        targetHeight = maxHeight;
                        targetWidth = Math.round(maxHeight * (originWidth / originHeight));
                    }
                }
                var S = 1;
                // if(originWidth > 3000){
                //     S = 0.35;
                // } else if(originWidth >= 1000 ){
                //     S = 0.5;
                // }else{
                //     S = 0.8;
                // }


                var Q = 1;
                // 先去掉图片的压缩，先看看线上反馈效果
                // if (ret.size > 204800) {
                //     Q = 0.6;
                // } else if (ret.size >= 102400) {
                //     Q = 0.8;
                // } else {
                //     Q = 1;
                // }

                imageFilter.compress({
                    img: path,
                    quality: Q,
                    scale:S,
                    size:{
                        w:targetWidth,
                        h:targetHeight
                    },
                    save:{
                        album: false,
                        imgPath: savePath + '/tweebaaCache/',
                        imgName: picName + '.jpg',
                    }
                },function( ret, err ){
                    if( ret.status ){

                        // imageFilter.getAttr({
                        //     path: savePath + '/tweebaaCache/' + picName + '.jpg'
                        // },function( ret, err ){
                        //     if( ret.status ){
                        //         alert( JSON.stringify( ret ) );
                        //     }else{
                        //         alert( JSON.stringify( err ) );
                        //     }
                        // });

                        var imgPath = savePath + '/tweebaaCache/' + picName + '.jpg';

                        // $('#uploadImgBox').prepend(
                        //     getPhotoItem(id, liWith, imgPath, true)
                        // );

                        $getPhotosNew.before(
                            getPhotoItem(id, liWith, imgPath, true)
                        );

                        uploadImagesNew(imgPath, picName + '.jpg', id);

                        remaining--;
                        loading('hide');
                    }else{
                        alert( JSON.stringify( err ) );
                    }
                });

            }else{
                //alert( JSON.stringify( err ) );
            }

        });


    }


    function uploadImagesNew(filepath, filename, id) {
        // type, size, name
        // var base64 = 'data:image/jpeg;base64,' + dataurl;
        // var arr = base64.split(',');
        // var mime = arr[0].match(/:(.*?);/)[1];
        // var bstr = atob(arr[1]);
        // var n = bstr.length;
        // var u8arr = new Uint8Array(n);
        //
        // while (n--) {
        //     u8arr[n] = bstr.charCodeAt(n);
        // }
        // var file = new File([u8arr], filename, {type: mime});

        // const blob = base64ToBlob(base64);
        // const file = blobToFile(blob, filename);

        // console.log("[" + api.deviceName + "]" + 'file: ' + JSON.stringify(file));

        // var form = new FormData();

        // 先支持一个
        // form.append("files", file, filename);
        // form.append("resize", "true");

        imgUploading = true;

        apiMedia.upload("/upload/images", filepath).done(function (response) {
            //console.log("[" + api.deviceName + "]" + JSON.stringify(response));

            var data = response.data[0];

            var imgURL = data.raw;
            var ThumbnailUrl = data.thumbnail;

            var pic = {
                "MediaType": "Picture",
                "FileName": "testimage.png",
                "MediaFileUrl": imgURL,
                "DownloadUrl": imgURL,
                "ThumbnailUrl": ThumbnailUrl
            };

            setTimeout(function () {
                var $uploadImgBox = $("#uploadImgBox");
                var $li = $uploadImgBox.find('li#' + id);
                $li.find('img').data("picture", pic);
                $li.find('.loading').remove();
                if($uploadImgBox.find('.loading').length === 0){
                    imgUploading = false;
                }
            });
        });

    }
}

function initVideo() {
    // 上传视频
    $('#videoBtn').on('touchstart', function () {
        var type;
        var systemType = api.systemType;
        actionSheet([
            {
                text: MSG.general.takePicture,
                callback: function () {
                    if(!checkPermission('camera')){
                        if (systemType === 'android') {
                            requestPermission("camera");
                        }else{
                            api.requestPermission({
                                list: ["camera"],
                                code: 1
                            }, function (ret, err) {
                                if (ret.list[0].granted) {
                                    type = 'camera';
                                    getVideo();
                                }
                            });
                        }

                    }else{
                        type = 'camera';
                        getVideo();
                    }
                }
            },
            {
                text: MSG.general.library,
                callback: function () {
                    if(!checkPermission('photos')){
                        if (systemType === 'android') {
                            requestPermission("photos");
                        }else{
                            api.requestPermission({
                                list: ["photos"],
                                code: 1
                            }, function (ret, err) {
                                if (ret.list[0].granted) {
                                    type = 'library';
                                    getVideo();
                                }
                            });
                        }

                    }else{
                        type = 'library';
                        getVideo();
                    }
                }
            }
        ]);


        function getVideo (){
            api.getPicture({
                sourceType: type,
                mediaValue: 'video',
                destinationType: 'url',
            }, function (ret, err) {
                if (ret.data) {
                    start(ret.data);
                } else {
                    loading('hide');
                }
            });
        }


        // return;
        // var UIAlbumBrowser = api.require('UIAlbumBrowser');
        //
        // UIAlbumBrowser.open({
        //     type: 'video',
        //     max: 1,
        //     isOpenPreview: false,
        //     classify: false,
        //     styles: {
        //         bg: '#FFFFFF',
        //         cameraImg: 'widget://res/cameraImg.png',
        //         mark: {
        //             icon: '',
        //             position: 'bottom_left',
        //             size: 20
        //         },
        //         nav: {
        //             bg: '#252525',
        //             cancelColor: '#fff',
        //             cancelSize: 16,
        //             nextStepColor: '#fff',
        //             nextStepSize: 16,
        //             cancelText: lan === 'zh'?'取消':'Cancel',
        //             finishText: 'OK',
        //         },
        //         bottomTabBar: {
        //             bg: 'rgba(0,0,0,0.6)',
        //             unPreviewTitleColor:'rgba(0,0,0,0.25)',
        //             previewTitleColor: '#fff',
        //             previewTitle:lan === 'zh'?'预览':'Preview',
        //             previewTitleSize: 15,
        //         }
        //     },
        //     rotation: true
        // }, function(ret) {
        //     if (ret.eventType === 'confirm') {
        //         // alert("[" + api.deviceName + "] [upload video] " + JSON.stringify(ret));
        //         // console.log("[" + api.deviceName + "] [upload video] " + new String(ret.size));
        //         var video = ret.list[0];
        //
        //         if (video.size > VIDEO_MAX_SIZE) {
        //             alert(MSG.tips.fileTooLarge);
        //             return
        //         }
        //
        //         if (api.systemType.toLowerCase() === "ios") {
        //             loading('show');
        //             UIAlbumBrowser.transPath({
        //                 path: video.path
        //             }, function (ret, err) {
        //                 console.log("[" + api.deviceName + "] [IOS PATH] " + ret.path);
        //                 loading('hide');
        //                 start(ret.path);
        //             });
        //         } else {
        //             console.log("[" + api.deviceName + "] [ANDROID PATH] " + video.path);
        //             start(video.path);
        //         }
        //
        //     }
        // });

        function start(path) {
            if (!path) {
                alert(MSG.tProduct.videoError);
                return;
            }
            apiMedia.uploadVideo("/upload/videos", path).done(function (response) {
                api.hideProgress();
                //console.log(JSON.stringify(response));
                var data = response.data[0];
                Video = [
                    {
                        "MediaType" : "Video",
                        "MediaFileUrl" : data.downloadUrl,
                        "ThumbnailUrl" : data.thumbnailUrl,
                        "DurationSeconds" : Math.ceil(data.duration),
                        "FileSize" : data.size,
                        "FileName" : data.name
                    }
                ];
                renderVideo(data.thumbnailUrl);
            });
        }

        // api.getPicture({
        //     sourceType: 'album',
        //     // encodingType: 'jpg',
        //     mediaValue: 'video',
        //     destinationType: 'url',
        //     allowEdit: true,
        //     saveToPhotoAlbum: true
        // }, function (ret, err) {
        //     // console.log(JSON.stringify(ret));
        //     console.info("[" + api.deviceName + "] [upload video] " + JSON.stringify(ret));
        //     if (ret && ret.data) {
        //         var path = ret.data;
        //         if (path) {
        //             // console.info("[" + api.deviceName + "] [path] " + JSON.stringify(path));
        //             var UIAlbumBrowser = api.require('UIAlbumBrowser');
        //             UIAlbumBrowser.transVideoPath({
        //                 path: path
        //             }, function (Ret, err) {
        //                 alert(JSON.stringify(Ret));
        //             });
        //
        //             // debugger;
        //             // var fs = api.require('fs');
        //             // fs.readDir({
        //             //     path: path
        //             // }, function(ret, err) {
        //             //     debugger;
        //             //     if (ret.status) {
        //             //         alert(JSON.stringify(ret));
        //             //     } else {
        //             //         alert(JSON.stringify(err));
        //             //     }
        //             // });
        //         }
        //         // apiMedia.uploadVideo("/upload/videos", ret.data).done(function (response) {
        //         //     api.hideProgress();
        //         //     //console.log(JSON.stringify(response));
        //         //     var data = response.data[0];
        //         //     Video = [
        //         //         {
        //         //             "MediaType" : "Video",
        //         //             "MediaFileUrl" : data.downloadUrl,
        //         //             "ThumbnailUrl" : data.thumbnailUrl,
        //         //             "DurationSeconds" : Math.ceil(data.duration),
        //         //             "FileSize" : data.size,
        //         //             "FileName" : data.name
        //         //         }
        //         //     ];
        //         //     renderVideo(data.thumbnailUrl);
        //         // });
        //     } else {
        //
        //     }
        // });

    });

    // 视频相关
    var $replaceVideo = $('#showVideo');
    // 播放
    $replaceVideo.on('click', '.icon-playon_fill', function () {
        var videoUrl = Video[0].MediaFileUrl || Video[0].DownloadUrl;
        playVideo(videoUrl);
    });
    // 删除
    $replaceVideo.on('click', '.icon-trash-solid', function () {
        $('#videoBtn').removeClass('d-none');
        $('#showVideo').addClass('d-none');
        Video = [];
    });
}

function renderVideo(thumbnailUrl) {
    $('#showVideo')
        .removeClass('d-none')
        .find('.media-btn')
        .css("background-image","url(" + thumbnailUrl + ")");
    $('#videoBtn').addClass('d-none');
}

function getPhotoItem(id, liWidth, imgPath, hasLoading, readOnly) {
    var loadingDom = '';
    if (hasLoading === true) {
        loadingDom = '<div class="loading"><div class="loading-bar"></div></div>';
    }
    var img = '<img class="img" id="p' + id + '" src=' + imgPath + ' alt="image" style="object-fit: cover;width: 100%; height: 100%;">';
    var dragBox = '<div class="drag-box"><i class="icon icon-tweebaa icon-drag drag-handle"></i></div>';
    var trash = '<i class="icon icon-tweebaa icon-trash-solid" style="color: #fff !important;"></i>';
    if (readOnly){
        dragBox = '';
        trash = '';
    }
    return (
        '<li id="' + id + '" class="ui-col ui-col-33 img-li" style="height: ' + liWith + 'px">' +
        dragBox +
        trash +
            '<div class="media-box">' + img + '</div>' +
            loadingDom +
        '</li>'
    );
}
