var Video, videoSize, prodData, uploading, content, textLink, videoPreUrl, momentTag, prod, RepostId;
var orderId, productId;
var PublicMoment = true;
var orderRate = 0;
var sending = false;
var pictures = [];
var taskService;
apiready = function () {
    api.setWinAttr({
        name: 'addMoment',
        bounces: false,
        slidBackEnabled: false
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    if (!api.pageParam.disabled) {
        $('#getPhotosNew').show();
        $('#videoBtn').show();
        $('#uploadImgBox').show();
    } else {
        $('#uploadImgBoxReadOnly').show();
    }

    if (!api.pageParam.disabled) {
        api.setNavBarAttr({
            rightButtons: [{
                text: MSG.general.add,
                color: '#4578F3',
                fontSize: '15'
            }]
        });
    }

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            saveNewMoment();
        } else {
            closeAddPage();
        }
    });

    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    $('#getPhotosNew, #videoBtn').click(function () {
        var UIInput = api.require('UIInput');
        UIInput.closeKeyboard({
            id: 0
        });
    });

    if (!checkPermission('photos')) {
        requestPermission("photos");
    }

    var contribution = new Vue({
            el: '#module-common',
            created: function () {
                this.getPurchaseDetail();
            },
            mounted: function () {
                if (!api.pageParam.disabled) {
                    openInput.call(this);
                    this.getDraft();
                } else {
                    this.getCommon();
                }
            },
            data: function () {
                return {
                    disabled: api.pageParam.disabled,
                    message: MSG,
                    orderId: api.pageParam.orderId,
                    productThumbnail: '',
                    productName: '',
                    tweebuckPrice: '',
                    rate: 0,
                    markText: MSG.assess.mark0,
                    inputLimit: '0',
                    comment: '',
                }
            },
            methods: {
                getCommon: function () {
                    var assessInfo = api.pageParam.assessInfo;
                    var data = {};
                    data.Content = assessInfo.comment;
                    data.Attachments = assessInfo.pictures;
                    data.rate = assessInfo.score;
                    data.Videos = assessInfo.videos;
                    this.comment = assessInfo.comment;
                    if (!data.Attachments.length && !data.Videos.length){
                        $('#uploadImgBoxReadOnly').hide();
                    }
                    this.setData(data);
                },
                setData: function (result) {
                    var rate = 0;
                    var that = this;
                    if (result.Content) {
                        var UIInput = api.require('UIInput');
                        UIInput.insertValue({
                            msg: result.Content
                        });
                        content = result.Content;
                    }
                    if (result.Videos && result.Videos.length) {
                        Video = result.Videos;
                        if (!api.pageParam.disabled) {
                            renderVideo(result.Videos[0].ThumbnailUrl);
                        } else {
                            $("#showVideoReadOnly").find('.media-btn').css("background", 'url(' + result.Videos[0].ThumbnailUrl + ')');
                            $("#showVideoReadOnly").find('.media-btn').css("background-size", '100% 100%');
                            $("#showVideoReadOnly").removeClass('d-none');
                        }
                    }
                    if (result.Attachments && result.Attachments.length > 0) {
                        var pic = result.Attachments.reverse();
                        var len = pic.length;
                        remaining = remaining - len;
                        for (i = 0; i < len; i++) {
                            var picData = {
                                "MediaType": "Picture",
                                "FileName": "testimage.png",
                                "MediaFileUrl": pic[i].MediaFileUrl || pic[i].DownloadUrl,
                                "DownloadUrl": pic[i].DownloadUrl,
                                "ThumbnailUrl": pic[i].ThumbnailUrl || pic[i].DownloadUrl
                            };
                            if (!api.pageParam.disabled) {
                                $('#videoBtn').after(
                                    getPhotoItem(i + 'D', liWith, pic[i].DownloadUrl, false)
                                );
                                $("#p" + i + 'D').data("picture", picData);
                            } else {
                                $('#showVideoReadOnly').after(
                                    getPhotoItem(i + 'D', liWith, pic[i].DownloadUrl, false, true)
                                );
                                $("#p" + i + 'D').data("picture", picData);
                            }
                        }
                        if (!api.pageParam.disabled) {
                            Sortable.create(document.getElementById('uploadImgBox'),
                                {
                                    animation: 150, onEnd: function (e) {

                                    },
                                    ignore: 'a',
                                    ghostClass: '.img-li',
                                    handle: '.drag-handle'
                                });
                        }

                    }
                    if (typeof result.rate === 'number') {
                        rate = result.rate;
                        this.getRate(result.rate);
                    }
                    new Rate({
                        dom: this.$refs.rate,
                        rate: rate,
                        callback: function (rate) {
                            that.getRate(rate);
                        },
                        isModify: !api.pageParam.disabled,
                    });
                    $('#showVideoReadOnly').click(function () {
                        var videoUrl = Video[0].MediaFileUrl || Video[0].DownloadUrl;
                        playVideo(videoUrl);
                    })
                    $('#uploadImgBoxReadOnly').on('click', '.img-li .img', function (e) {
                        // var UIInput = api.require('UIInput');
                        // UIInput.hide({
                        //     id:1
                        // });
                        var index = $(this).closest('li.img-li').index();
                        //$('.swiper-container').show().find('.swiper-wrapper').empty();
                        var el = $('#uploadImgBoxReadOnly').find('li.img-li');
                        var picUrls = [];
                        for (i = 0; i < el.length; i++) {
                            picUrls.push($('#uploadImgBoxReadOnly').find('li.img-li img:eq(' + i + ')').attr('src'));
                        }

                        var UIPhotoViewer = api.require('UIPhotoViewer');
                        UIPhotoViewer.open({
                            images: picUrls,
                            placeholderImg: 'widget://image/lost_images.jpg',
                            bgColor: '#000',
                            activeIndex: index,
                            zoomEnabled: true,
                            gestureClose: true
                        }, function (Ret, err) {
                            if (Ret.eventType === 'click') {
                                UIPhotoViewer.close();
                            }
                        });

                    });
                },
                getDraft: function () {
                    var that = this;
                    var kv = api.require('snKVStorage');
                    var result = kv.getObject({
                        key: api.pageParam.orderId + 'orderId'
                    });
                    console.log(JSON.stringify(result));
                    if (result && result !== -1) {
                        console.log(JSON.stringify(result));
                        this.setData(result)
                    } else {
                        new Rate({
                            dom: this.$refs.rate,
                            rate: 0,
                            callback: function (rate) {
                                that.getRate(rate);
                            },
                            isModify: !api.pageParam.disabled,
                        });
                    }
                },
                getRate: function (rate) {
                    this.rate = rate;
                    orderRate = rate;
                    this.markText = this.message.assess['mark' + rate];
                },
                getPurchaseDetail: function () {
                    var url = getBaseUrl() + 'api/v3/orderdetail?OrderId=' + this.orderId;
                    this.isLoading = true;
                    getAxois(url, "GET", '').then(function (response) {
                        var data = response.data;
                        var productInfo = {};
                        try {
                            productInfo = data.Items[0].Product;
                        } catch (error) {

                        }
                        this.productThumbnail = productInfo.FeaturedPicture.ThumbnailUrl;
                        this.productName = productInfo.Name;
                        this.tweebuckPrice = productInfo.TweebuckPrice;
                        productId = productInfo.Id;
                    }.bind(this)).catch(function (error) {
                        this.isLoading = false;
                        console.log(JSON.stringify(error) + ' review API 报错');
                        //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                    }.bind(this));
                }
            }
        }
        )
    ;

    function openInput() {
        var UIInput = api.require('UIInput');
        UIInput.open({
            rect: {
                x: 25,
                y: 200,
                w: api.winWidth - 50,
                h: 120
            },
            styles: {
                bgColor: '#fff',
                size: 14,
                color: '#000',
                placeholder: {
                    color: '#BDBDBD',
                    size: 16,
                    top: 0
                }
            },
            maxStringLength: 500,
            isCenterVertical: false,
            autoFocus: false,
            maxRows: 7,
            placeholder: MSG.assess.commonPlaceHolder,
            fixedOn: api.frameName,
            fixed: false
        }, function (ret, err) {
            if (ret.eventType == 'change') {
                UIInput.value(function (ret) {
                    if (ret) {
                        this.inputLimit = ret.msg.length;
                        content = ret.msg;
                    }
                }.bind(this));
            }
        }.bind(this));

        var safeBottom = api.safeArea.bottom;
        $('#uploadBtns').css({
            paddingBottom: (1.5 + safeBottom / 10) + 'rem'
        });
        UIInput.addEventListener({
            name: 'becomeFirstResponder'
        }, function (ret) {
            $('#uploadBtns').css({'bottom': ret.keyboardHeight + 'px', paddingBottom: '1.5rem'});
            // $('#uploadBtns').css({paddingBottom: '1.5rem'});
        });
        UIInput.addEventListener({
            name: 'resignFirstResponder'
        }, function (ret) {
            $('#uploadBtns').css('bottom', 0);
            $('#uploadBtns').css({
                paddingBottom: (1.5 + safeBottom / 10) + 'rem'
            });
            UIInput.value(function (ret) {
                if (ret) {
                    content = ret.msg;
                }
            });
        });


    }

    var imgW = $('#width').width();
    var imgW2 = imgW - 5;
    $('#uploadImgBox .img-li').height(imgW);
    $('#uploadImgBox #getPhotosNew,#uploadImgBox #videoBtn,#uploadImgBox #replaceVideo, #uploadImgBox #showVideo').height(imgW2);
    $('#includedProd').on('touchstart', function () {
        if (!prodData) {
            loadProdsList();
        } else if (prodData.length > 0) {
            openWindows('selectProds', 'select-pords.html', {
                prodsData: JSON.stringify(prodData)
            });
        }
    });


    api.addEventListener({
        name: 'selectedProd'
    }, function (ret, err) {
        prod = JSON.parse(ret.value.selectedProd);
        var description = ret.value.description;
        $('#productBox').removeClass('d-none');
        $('#productDescription').text(description);
        $('#productName').text(prod.Name);
        $('#productImg').attr("src", prod.FeaturedPicture.DownloadUrl);
        $('#productId').val(prod.Id);
        $('#includedProd i').addClass('text-blue');
    });

    api.addEventListener({
        name: 'addMomentLink'
    }, function (ret, err) {
        var title = ret.value.title;
        var externalPostUrl = ret.value.link;
        if (externalPostUrl) {
            var preText = title || externalPostUrl;
            textLink = externalPostUrl.indexOf("http") !== -1 ? externalPostUrl : "http://" + externalPostUrl;
            $('#linkBox').removeClass('d-none').addClass("flex");
            $('#linkTitle').text(preText);
            $('#inputLink').text(textLink);
            $('#addLinkBtn i').addClass('text-blue');
        }
    });
}
;

$('#publicBtn').on("change", function (e) {
    PublicMoment = $(this).prop("checked");
    $('.private,.public').toggle();
});

function saveNewMoment() {
    var UIInput = api.require('UIInput');
    UIInput.closeKeyboard({
        id: 0
    });
    if (sending) {
        return false;
    }

    if (orderRate === 0) {
        api.toast({
            msg: MSG.assess.addCommonTip,
            duration: 2000,
            location: 'middle'
        });
        return false;
    } else {
        if (!content) {
            confirm(MSG.assess.noCommon, [
                {
                    text: MSG.assess.no,
                    callback: function () {

                    }
                },
                {
                    text: MSG.assess.yes,
                    callback: function () {
                        saveCommon();
                    }
                }
            ]);
            return;
        }
        saveCommon();
    }
}

function saveCommon() {
    pictures = [];
    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.DisplayOrder = index;
        pictures.push(pic);
    });
    sending = true;
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var userId = localStorage.getItem('userId');
    var paramStr = {
        "userId": userId,
        "comment": content || MSG.assess.defaultCommon,
        "pictures": pictures,
        "videos": Video,
        "productId": productId,
        "orderId": api.pageParam.orderId,
        "score": orderRate
    };
    api.toast({
        msg: MSG.assess.submitting,
        duration: 5000,
        location: 'middle'
    });
    apiAssess.post('/v1/api/evaluate/add', paramStr).done(function (rep) {
        sending = false;
        if (rep.code === 0) {
            api.toast({
                msg: MSG.general.success,
                duration: 2000,
                location: 'middle'
            });
            api.sendEvent({
                name: 'updateOrderAssess'
            });
            // 评价通知卖家
            var seller = api.pageParam.seller;
            postNotify(seller.UserName, MSG_TYPE_ORDER, {
                Type: 'orderAssess',
                AvatarUrl: localStorage.getItem('thumbnail'),
                StoreName: localStorage.getItem('storename'),
                UserId: localStorage.getItem('userId'),
                OrderId: api.pageParam.orderId,
                productId: productId
            });
            setTimeout(function () {
                back();
            }, 2000);
        } else {
            api.toast({
                msg: rep.message,
                duration: 2000,
                location: 'middle'
            });
        }
    });


    // $.when(postApi(url, 'post', paramStr, token, contentTypeStr)).done(function (data) {
    //     if (typeof data.code !== 'undefined') {
    //         if (!Number(data.code)) {
    //             back();
    //             api.sendEvent({
    //                 name: 'updateOrderAssess'
    //             });
    //         }
    //     } else {
    //         if (data.status !== 200) {
    //             api.toast({
    //                 msg: MSG.tips.systemError,
    //                 duration: 2000,
    //                 location: 'middle'
    //             });
    //         }
    //     }
    //
    //     sending = false;
    // });
}


function showVideo(file) {
    var url = null;
    if (window.createObjectURL != undefined) { // basic
        url = window.createObjectURL(file);
    } else if (window.URL != undefined) { // mozilla(firefox)
        url = window.URL.createObjectURL(file);
    } else if (window.webkitURL != undefined) { // webkit or chrome
        url = window.webkitURL.createObjectURL(file);
    }
    console.log("url " + url);
    return url;
}

function deletePostVideo() {
    $('#videoBtn').removeClass('d-none');
    $('#replaceVideo').addClass('d-none');
    Video = [];
}


function closeAddPage() {
    if (!api.pageParam.disabled) {
        confirm(MSG.moment.exitPostNow, [
            {
                text: MSG.moment.saveDraft,
                callback: function () {
                    saveDraft();
                }
            },
            {
                text: MSG.moment.exitDirectly,
                callback: function () {
                    var kv = api.require('snKVStorage');
                    var result = kv.removeKey({
                        key: api.pageParam.orderId + 'orderId'
                    });
                    setTimeout(function () {
                        confirmBack();
                    }, 100);
                }
            }
        ]);
    } else {
        setTimeout(function () {
            confirmBack();
        }, 100)
    }
}

function tagSelector() {
    if (this.isScrolling === true) {
        return;
    }
    setTimeout(function () {
        openTabLayout('addPostTag', MSG.moment.addTag, 'widget://html/users/add-moment-tag.html', {
            tags: momentTag
        })
    });
}

function saveDraft() {
    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.DisplayOrder = index;
        pictures.push(pic);
    });
    setTimeout(function () {
        var paramStr = {
            "Content": content,
            "Attachments": pictures,
            "Videos": Video,
            "rate": orderRate,
        };
        //console.log(JSON.stringify(paramStr));
        console.log(paramStr)
        var kv = api.require('snKVStorage');
        var result = kv.setObject({
            key: api.pageParam.orderId + 'orderId',
            value: paramStr
        });
        //console.log(result);
        setTimeout(function () {
            confirmBack();
        }, 100)
    }, 100);

}

function confirmBack() {
    api.closeWin();
}
