
var videoURL,tags,selectedCategory,Download,ToTweebaa;
var uploading = false;
var pictures = [];
var sending = false;
var tagProject = [];
var step = "step1";
var prodTitle;
var description;
var tweebucksPrice;
var fileName;

autosize(document.querySelectorAll('textarea'));

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#media [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    //写入文字信息
    $(".replace-text").each(function () {
        $(this).text(MSG.products[$(this).attr('id')]);
    });

    $(".replace-placeholder").each(function () {
        $(this).attr("placeholder",MSG.products[$(this).attr('id')]).on('blur',function () {
            if(!$(this).val()){
                $(this).attr("placeholder",MSG.products[$(this).attr('id')]);
            }
        });
    });

    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false,
    });

    //改变导航右侧按钮
    var nextBtn = MSG.general.next;
    var postBtn = MSG.products.post;
    setRightBtn(nextBtn);
    function setRightBtn(text){
        api.setNavBarAttr({
            rightButtons: [{
                text: text,
                color:'#4578F3',
                fontSize:'15'
            }]
        });
    }

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {

        if(ret.type ==='right'){
            if(step === "step1"){
                validateStep1();
            }else if(step === "step2"){
                submitFunction()
            }
        }else{
            if(step === "step2"){
                $("#addDigital").removeClass().addClass("step1");
                setRightBtn(nextBtn);
                step = "step1"
            }else{
                confirm(MSG.products.wantExit, function () {
                    back();
                });
            }

        }
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew,#videoBtn,#showVideo').height(imgW);


    api.addEventListener({   //写入分类
        name: 'category'
    }, function(ret, err) {
        selectedCategory = JSON.parse(ret.value.c);
        //console.log(JSON.stringify(selectedCategory));
    });
    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        $('#categoryName').html(ret.value.list.join(', '));
    });

    api.addEventListener({  //写入showroom信息
        name: 'showroom'
    }, function(ret, err) {
        if(ret.value.toTweebaa){
            ToTweebaa = ret.value.toTweebaa;
            console.log(JSON.stringify(ToTweebaa));
        }
    });

    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tags = ret.value.tags.split(',');
            $('#productTags').empty();
            for(i=0;i<tags.length;i++){
                tagProject.push({"name":tags[i]});
                $('#productTags').append("<span class='product-tags'>"+ tags[i] +"</span>")
            }
        }
    });

    api.addEventListener({
        name: 'uploadedDigitalFile'
    }, function(ret, err) {
        Btns.enterDownload(ret.value.productURL, ret.value.fileName);
    });

    $('#description').editor({
        placeholder: MSG.products.description
    });

    new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
        console.log('tweebuckValue: ' + tweebuckValue);
        if (tweebuckValue) {
            tweebucksPrice = tweebuckValue.toFixed(4);
        } else {
            tweebucksPrice = '';
        }
    });

    function validateStep1() {
        if(sending){
            return false;
        }
        prodTitle = $('#title').val();
        description = $('#description').html();

        if(imgUploading || uploading){
            api.toast({
                msg: MSG.tips.uploadDataTips,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(picArray.length===0){
            api.toast({
                msg: MSG.tips.noPicError,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!prodTitle) {
            api.toast({
                msg: MSG.tips.productNameEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(prodTitle.length>80) {
            api.toast({
                msg: MSG.tips.productNameTooLong,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!tweebucksPrice || tweebucksPrice ==0){
            api.toast({
                msg: MSG.tips.productPriceEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!description || description === '<br>') {
            api.toast({
                msg: MSG.tips.descriptionEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!selectedCategory){
            api.toast({
                msg: MSG.tips.categoryEmpty,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }
        else if(!tags){
            api.toast({
                msg: MSG.tips.tag2,
                duration: 2000,
                location: 'middle'
            });
            return false;
        }

        $("#addDigital").removeClass().addClass("step2");
        setRightBtn(postBtn);
        step = "step2"

    }

};

function setFileLabel(name) {
    if (name.length > 30) {
        name = name.substring(0, 30) + '...';
    }
    $('#digitalFileLabel').text(name);
}

var Btns = {
    openCategoryPage:function () { //分类
        openTabLayout('categoryDigital','','widget://html/products/category-digital.html')
    },
    openProductTags:function () { // 打开tag输入
        openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
            tags:tags?tags.join(','):null
        })
    },
    openUploadProdPage:function () {// 打开上传产品选项
        api.actionSheet({
            cancelTitle:  MSG.products.cancel,
            buttons: [MSG.products.enterLink, MSG.products.UploadFile]
        }, function (ret, err) {
            var index = ret.buttonIndex;
            if (index === 1) {
                api.prompt({
                    buttons: [MSG.general.ok, MSG.general.cancel],
                    text:"https://",
                    type:"url"
                }, function(ret, err) {
                    var index = ret.buttonIndex;
                    if(index === 1 ){
                        var text = ret.text;
                        if(text && text.indexOf("http") !== -1){
                            Download = {
                                "DownloadUrl" : text
                            };
                            setFileLabel(MSG.products.linkLabel + ' ' + text);
                        }else{
                            alert(MSG.products.linkError);
                        }
                    }

                });
            } else if (index === 2) {
                openTabLayout('productUploadPage','','widget://html/products/upload-download.html',{
                    fileName: fileName,
                    url: Download,
                    page: 'add'
                })
            } else {
                return false;
            }
        });
    },
    openPrepareShowroomPage:function(){
        openTabLayout('prepareShowroomPage','','widget://html/products/prepare-showroom.html',{
            price:Number($('#price').val()),
            profit:ToTweebaa ? ToTweebaa.TargetTweebuckProfit : null,
            productType:2
        })
    },
    enterDownload:function (url, name) {// 写入产品地址

        if(url ==="null" || url ==="undefined" ){
            Download = '';
        }else{
            Download = {
                "DownloadUrl" : url
            };
        }

        if (name) {
            setFileLabel(name);
        }

        fileName = name;

        console.log(JSON.stringify(Download));
    }

};

//预览上传的视频
function playProdVideo(){
    // api.openWin({
    //     name: 'videoPlayer',
    //     url: 'widget://html/frame/video-player.html',
    //     bounces:false,
    //     bgColor:'#000000',
    //     hideHomeIndicator:true,
    //     slidBackEnabled:false,
    //     animation:{
    //         type:"none",
    //     },
    //     pageParam: {
    //         url: productVideoURL,
    //         pic: productVideoThumbnailURL,
    //         isCache:false
    //     }
    // });
    playVideo( productVideoURL);
}

function submitFunction() {
    if(sending){
        return false;
    }

    if(!Download){
        api.toast({
            msg: MSG.tips.noProductError,
            duration: 2000,
            location: 'middle'
        });
        return false;
    }

    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.DisplayOrder = index;
        pictures.push(pic);
    });

    setTimeout(function () {

        var prodObj = {
            "ProductType":2,
            "Name": prodTitle,
            "En" : {
                "Name" : prodTitle,
                "ShortDescription" : '',
                "FullDescription" : description,
                "AdvisoryReason" : ToTweebaa ? ToTweebaa.AdvisoryReason :null
            },
            "Cn" : {
                "Name" : prodTitle,
                "ShortDescription" : '',
                "FullDescription" : description,
                "AdvisoryReason" : ToTweebaa ? ToTweebaa.AdvisoryReason :null
            },
            "TweebuckPrice": tweebucksPrice,
            "DisplayOrder": 0,
            "ProductTags": tagProject,
            "FullDescription": description,
            "Categories": selectedCategory,
            "ShowOnHomePage": true,
            "Pictures": pictures,
            "CurrencyCode":null,
            "SampleDownload": videoURL,
            "Download" :Download,
            "ContactEmail" :ToTweebaa ? ToTweebaa.ContactEmail :null,
            "ProductToTweebaa":ToTweebaa
        };

        sending = true;

        var url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId');
        loading('show');
        getAxois(url, "POST", prodObj).then(function (response) {
            //console.log(JSON.stringify(response));
            loading('hide');
            if(response.data.Success){
                api.sendEvent({
                    name: 'productListReload',
                });
                api.closeWin({
                    name: 'prepareAdd'
                });

                if (response.data.Data && response.data.Data.TaskId) {
                    apiTask.fetchTaskStatus(response.data.Data.TaskId);
                } else {
                    api.toast({
                        msg: MSG.products.added,
                        duration: 2000,
                        location: 'middle'
                    });
                    setTimeout(function () {
                        back();
                    },2000);
                }
            }else{
                sending = false;
            }

        }).catch(function (error) {
            api.toast({
                msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                duration: 2000,
                location: 'middle'
            });
            loading('hide');
            sending = false;
        });
    });

}
