
var uploading = false;
var sending = false;
var pictures = [];
var Video = '';
var token ='';

// autosize(document.querySelectorAll('textarea'));

// PHYSICAL, DIGITAL, INVENTION

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));
    //写入文字信息
    $(".replace-text").each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.products[k]);
    });

    $(".general-text").each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.general[k]);
    });

    api.setWinAttr({
        bounces: false
    });

    //改变导航右侧按钮
    var nextBtn = MSG.general.next;
    var postBtn = MSG.products.post;

    function setRightBtn(text){
        api.setNavBarAttr({
            rightButtons: [{
                text: text,
                color: '#4578F3',
                fontSize: '15'
            }]
        });
    }

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            if (SuggestProduct.currentStep === 'step2') {
                if (!SuggestProduct.form.Download) {
                    api.toast({
                        msg: MSG.tips.noProductError,
                        duration: 2000,
                        location: 'middle'
                    });
                }else if(SuggestProduct.form.Download.DownloadUrl.indexOf('http') === -1 ){
                    api.toast({
                        msg: MSG.products.linkError,
                        duration: 2000,
                        location: 'middle'
                    });
                }else{
                    SuggestProduct._setStep('step3');
                    setRightBtn(postBtn);
                }

            }else if(SuggestProduct.currentStep === 'step3'){
                SuggestProduct.validateStep1();
            }

        } else {
            SuggestProduct.beforeBack();
        }
    });

    api.addEventListener({
        name: 'keyback'
    }, function (ret, err) {
        SuggestProduct.beforeBack();
    });

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew, #videoBtn, #showVideo').height(imgW);

    //写入分类
    api.addEventListener({
        name: 'category'
    }, function(ret, err) {
        SuggestProduct.form.Categories = JSON.parse(ret.value.c);
    });

    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        SuggestProduct.currentCategoryName = ret.value.list.join(', ');
    });

    // 写入媒体信息
    api.addEventListener({
        name: 'getMedia'
    }, function(ret, err) {
        SuggestProduct.form.Pictures = ret.value.pictures;
        pictures = ret.value.pictures;
        Video = ret.value.video;
        if (Video && Video.length>0 ) {
            SuggestProduct.form.SampleDownload = {
                "MediaType": "Video",
                "DownloadUrl": Video[0].MediaFileUrl,
                "ThumbnailUrl": Video[0].ThumbnailUrl,
                "DurationSeconds": Video[0].DurationSeconds,
                "FileSize": Video[0].FileSize,
                "FileName": Video[0].FileName
            };
        } else {
            SuggestProduct.form.SampleDownload = '';
        }
    });

    var tags = [];
    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tags = ret.value.tags.split(',');
            var results = [];
            $.map(tags, function (item, index) {
                results.push({
                    name: item
                });
            });
            SuggestProduct.form.ProductTags = results;
        }
    });

    api.addEventListener({
        name: 'uploadedDigitalFile'
    }, function(ret, err) {
        SuggestProduct.enterDownload(ret.value.productURL, ret.value.fileName);
    });

    if (api.pageParam.product) {
        $('#upload').hide();
    }

    var kv = api.require('snKVStorage');
    var hasFormProductDraft = kv.has({
        key: 'formProductDraft'
    });
    var formProductDraft = {};
    if (hasFormProductDraft) {
        formProductDraft = kv.getObject({
            key: 'formProductDraft'
        });
    }

    var SuggestProduct = new Vue({
        el: '#SuggestProduct',
        filters: {

        },
        computed: {

        },
        watch:{
            bigFileURL:function (value) {
                this.enterDownload(value,'');
            }
        },
        mounted: function() {
            if (this.isEdit === false) {
                this._initDom();
            }
        },
        created: function() {

            loading('show');

            var productId = api.pageParam.productId;
            if (productId) {
                this.isEdit = true;
                this.productId = productId;
                this.getProductDetail(productId);
            } else {
                // 判断是否有草稿
                var form = formProductDraft[this.currentType];
                if (form) {
                    this.form = form;

                    if (this.form.Pictures && this.form.Pictures.length > 0) {
                        this._setImageHtml(this.form.Pictures);
                    }

                    if (this.form.Categories && this.form.Categories.length > 0) {
                        this._setCategoryName(this.form.Categories);
                    }

                    if (this.form.SampleDownload) {
                        renderVideo(this.form.SampleDownload[0].ThumbnailUrl);
                    }

                    if (this.form.Download) {
                        this._setFileLabel(this.form.Download.DownloadUrl);
                    }
                }
            }
        },
        data: {
            currentStep: 'step1',
            digitalFileName: '',
            isLoading: true,
            currentType: 'DIGITAL',
            isEdit: false,
            productId: '',
            winWidth:api.winWidth,
            isRequesting: false,
            currentCategoryName: '',
            fileUploaded:false,
            uploadPercentage:0,
            fileType:'',
            fileName:'',
            fileSize:'',
            fileUrl:'',
            inputLink:false,
            bigFileURL:'',
            audioPlaying:false,
            form: {
                "ProductType": 2,
                "Name": '',
                "FullDescription": '',
                "Sku": '',
                "En" : {
                    "Name" : '',
                    "ShortDescription" : '',
                    "FullDescription" : '',
                    "AdvisoryReason" : null
                },
                "Cn" : {
                    "Name": '',
                    "ShortDescription" : '',
                    "FullDescription" : '',
                    "AdvisoryReason" : null
                },
                "Quantity": '',
                "TweebuckPrice": '',    // currency-selector
                "DisplayOrder": 0,
                "ProductTags": [],  // ['美食', ...]
                "Categories": [], // [{Id, L}]
                "ShowOnHomePage": true,
                "Pictures": pictures,
                "CurrencyCode": null,
                "SampleDownload": Video,
                "ContactEmail": null,
                "ProductToTweebaa": null,
                "Download": '',
            },
            message: MSG,
        },
        methods: {
            _setStep: function(currentStep) {
                this.currentStep = currentStep;
                if (currentStep === 'step2') {
                    setRightBtn(nextBtn);
                } else if (currentStep === 'step3') {
                    setRightBtn(postBtn);
                }
            },
            _setFileLabel: function(name) {
                if (name.length > 30) {
                    name = name.substring(0, 30) + '...';
                }
                this.digitalFileName = name;
            },
            enterDownload: function(url, name) {
                if (url === "null" || url === "undefined") {
                    this.form.Download = '';
                } else {
                    this.form.Download = {
                        "DownloadUrl" : url
                    };
                }

                if (name) {
                    this._setFileLabel(name);
                }
            },
            setProductType(xName){
                var that = this;
                var videos = ['mp4','mpg','mov','wmv','m3u8'];
                var pics = ['jpg','jpeg','raw','png','bmp'];
                var audios =['amr','wav','mp3','m4a'];
                var text =['txt','doc','docx','xlsx','xls','pdf'];
                var links = ['com', 'cn', 'io', 'pro','net','html','org','info','xyz'];

                if (videos.indexOf(xName) !== -1) {
                    that.fileType = 'video'
                } else if (pics.indexOf(xName) !== -1) {
                    that.fileType = 'image';
                } else if (audios.indexOf(xName) !== -1) {
                    that.fileType = 'audios'
                } else if (text.indexOf(xName) !== -1) {
                    that.fileType= 'text';
                } else if (links.indexOf(xName) !== -1) {
                    that.inputLink = true;
                }else {
                    that.fileType = 'other'
                }
            },
            //上传产品
            // openUploadFile: function () {
            //     var that = this;
            //     api.actionSheet({
            //         cancelTitle:  MSG.products.cancel,
            //         buttons: [MSG.products.enterLink, MSG.products.UploadFile]
            //     }, function (ret, err) {
            //         var index = ret.buttonIndex;
            //         if (index === 1) {
            //             api.prompt({
            //                 buttons: [MSG.general.ok, MSG.general.cancel],
            //                 text: "https://",
            //                 type: "url"
            //             }, function(ret, err) {
            //                 var index = ret.buttonIndex;
            //                 if (index === 1) {
            //                     var text = ret.text;
            //                     if(text && text.indexOf("http") !== -1){
            //                         that.form.Download = {
            //                             "DownloadUrl" : text
            //                         };
            //                         that._setFileLabel(MSG.products.linkLabel + ' ' + text);
            //                     }else{
            //                         alert(MSG.products.linkError);
            //                     }
            //                 }
            //             });
            //         } else if (index === 2) {
            //             openTabLayout('productUploadPage','','widget://html/products/upload-download.html',{
            //                 url: that.form.Download,
            //                 page: 'add'
            //             })
            //         } else {
            //             return false;
            //         }
            //     });
            // },
            _initDom: function() {
                var that = this;

                $('#description').editor({
                    placeholder: MSG.suggestion.pDescription,
                    content: this.form.FullDescription
                });

                $('#price').val(this.form.TweebuckPrice);
                new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
                    if (tweebuckValue) {
                        that.form.TweebuckPrice = tweebuckValue.toFixed(4);
                    } else {
                        that.form.TweebuckPrice = '';
                    }
                });

                loading('hide');
                $('.page-form').css({
                    opacity: 1
                });
            },
            validateStep1: function() {
                // 图片
                if (uploading) {
                    api.toast({
                        msg: MSG.tips.uploadDataTips,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                if (pictures.length === 0) {
                    messages(MSG.tips.noPicError, 'error', 'top', 3);
                    return;
                }

                this.form.Pictures = pictures;

                // 名字
                if (!$.trim(this.form.Name)) {
                    messages(MSG.tips.productNameEmpty, 'error', 'top', 3);
                    return;
                }

                if (this.form.Name.length > 80) {
                    api.toast({
                        msg: MSG.tips.productNameTooLong,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                // 描述
                var description = $.trim($('#description').html());
                if (!description) {
                    messages(MSG.tips.descriptionEmpty, 'error', 'top', 3);
                    return;
                } else {
                    this.form.FullDescription = description;
                }

                // 价格
                if (!this.form.TweebuckPrice) {
                    messages(MSG.tips.productPriceEmpty, 'error', 'top', 3);
                    return;
                }
                if (+this.form.TweebuckPrice < 1) {
                    messages(MSG.tips.productPriceMin, 'error', 'top', 3);
                    return;
                }

                // 类别
                if (this.form.Categories && this.form.Categories.length === 0) {
                    api.toast({
                        msg: MSG.tips.categoryEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                // 标签
                if (this.form.ProductTags && this.form.ProductTags.length === 0) {
                    api.toast({
                        msg: MSG.tips.tag2,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                this.submit();
            },
            submit: function() {
                var that = this;
                var params = {};

                // if (Video && Video.length>0 ) {
                //     this.form.SampleDownload = {
                //         "MediaType": "Video",
                //         "DownloadUrl": Video[0].MediaFileUrl,
                //         "ThumbnailUrl": Video[0].ThumbnailUrl,
                //         "DurationSeconds": Video[0].DurationSeconds,
                //         "FileSize": Video[0].FileSize,
                //         "FileName": Video[0].FileName
                //     };
                // } else {
                //     this.form.SampleDownload = '';
                // }

                if (!this.form.Download) {
                    api.toast({
                        msg: MSG.tips.noProductError,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                // 格式化一些参数
                that.form.Cn.Name = this.form.Name;
                that.form.Cn.FullDescription = this.form.FullDescription;
                that.form.En.Name = this.form.Name;
                that.form.En.FullDescription = this.form.FullDescription;

                that.isRequesting = true;
                loading('show');
                params = $.extend({}, params, that.form);
                //console.log('form: ' + JSON.stringify(params));

                loading('show');

                var url;
                if (this.isEdit === false) {

                    url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId');
                    getAxois(url, "POST", params).then(function (response) {
                        loading('hide');
                        var data = response.data;
                        if(data.Success){
                            api.sendEvent({
                                name: 'productListReload',
                            });
                            api.closeWin({
                                name: 'prepareAdd'
                            });
                            if (data.Data && data.Data.TaskId) {
                                apiTask.fetchTaskStatus(data.Data.TaskId, true, function () {
                                    confirm(MSG.products.added, [
                                        {
                                            text: MSG.general.next,
                                            callback: function () {
                                                that.toSuggest(data.Data.Id, data.Data.ProductGuid);
                                            }
                                        },
                                        {
                                            text: MSG.products.not,
                                            callback: function () {
                                                back();
                                            }
                                        }
                                    ]);
                                });
                            } else {
                                api.toast({
                                    msg: MSG.products.added,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                setTimeout(function () {
                                    back();
                                },2000);
                            }
                        }else{
                            that.isRequesting = false;
                            api.toast({
                                msg: response.data.ExceptionMessage || MSG.tips.systemError,
                                duration: 2000,
                                location: 'middle'
                            });
                        }

                    }).catch(function (error) {
                        api.toast({
                            msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                            duration: 2000,
                            location: 'middle'
                        });
                        loading('hide');
                        that.isRequesting = false;
                    });

                } else {
                    url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId') + "&productId=" + this.productId;
                    getAxois(url, "PUT", params).then(function (response) {
                        loading('hide');
                        if (response.data.Success) {

                            api.toast({
                                msg: MSG.tips.updated,
                                duration: 2000,
                                location: 'middle'
                            });
                            api.sendEvent({
                                name: 'productListReload',
                            });
                            api.sendEvent({
                                name: 'productInfoReload',
                            });
                            api.sendEvent({
                                name: 'indexProductListReload',
                            });
                            api.sendEvent({
                                name: 'workplaceReload',
                                extra: {
                                    type: 'product'
                                }
                            });
                            setTimeout(function () {
                                back();
                            },2000);
                        } else {
                            that.isRequesting = false;
                            api.toast({
                                msg: response.data.ExceptionMessage || MSG.tips.systemError,
                                duration: 2000,
                                location: 'middle'
                            });
                        }

                    }).catch(function (error) {
                        loading('hide');
                        that.isRequesting = false;
                        api.toast({
                            msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                            duration: 2000,
                            location: 'middle'
                        });
                    });
                }

            },
            toSuggest: function(productId, productGuid) {
                var product = $.extend({}, this.form, {
                    Id: productId,
                    ProductGuid: productGuid
                });
                openTabLayout('suggestProduct', MSG.tProduct.suggestProduct, 'widget://html/products/suggest-product.html', {
                    type: 'DIGITAL',
                    product: product
                });
                setTimeout(function () {
                    back();
                }, 2000);
            },
            saveDraft: function() {

                // 描述
                var description = $.trim($('#description').html());
                if (description && description !== '<br>') {
                    this.form.FullDescription = description;
                } else {
                    this.form.FullDescription = '';
                }

                // 图片
                // var pictures = [];
                // $("#uploadImgBox").find('img').each(function (index) {
                //     var pic = $(this).data('picture');
                //     pic.DisplayOrder = index;
                //     pictures.push(pic);
                // });
                this.form.Pictures = pictures;

                // 视频
                if(Video){
                    this.form.SampleDownload = {
                        "MediaType": "Video",
                        "DownloadUrl": Video[0].MediaFileUrl,
                        "ThumbnailUrl": Video[0].ThumbnailUrl,
                        "DurationSeconds": Video[0].DurationSeconds,
                        "FileSize": Video[0].FileSize,
                        "FileName": Video[0].FileName
                    };
                }

                formProductDraft[this.currentType] = $.extend({}, this.form);
                kv.setObject({
                    key: 'formProductDraft',
                    value: formProductDraft
                });

                setTimeout(function () {
                    back();
                }, 100)
            },
            beforeBack: function() {
                var that = this;
                confirm(MSG.suggestion.beforeBackTipAdd, [
                    {
                        text: MSG.moment.saveDraft,
                        callback: function () {
                            that.saveDraft();
                        }
                    },
                    {
                        text: MSG.moment.exitDirectly,
                        callback: function () {
                            delete formProductDraft[that.currentType];
                            kv.setObject({
                                key: 'formProductDraft',
                                value: formProductDraft
                            });
                            setTimeout(function () {
                                back();
                            }, 100);
                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            openWarn: function(key, $event) {
                // alert(MSG.suggestion[key]);
                $event && $event.stopPropagation();

                api.openFrame({
                    name: 'dialogTips',
                    url: 'widget://html/dialog/dialog-tips.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        title: MSG.tips.title,
                        content: MSG.suggestion[key],
                        primaryText:MSG.general.cancel,

                    },
                    bounces: false,
                    bgColor:'rgba(0,0,0,0)',
                    fixedOn: 'ui_layout'
                });

            },
            _setCategoryName: function(Categories) {
                var ids = [];
                $.map(Categories, function (item, index) {
                    ids.push(item.Id);
                });
                var categoryNames = getCategoryNameByIds(ids, lan);
                this.currentCategoryName = categoryNames.join(', ');
            },
            _setImageHtml: function(list) {
                id = id + list.length;
                $.map(list, function (item, index) {
                    var picData =  {
                        "MediaType": "Picture",
                        "FileName": "testimage.png",
                        "MediaFileUrl": item.MediaFileUrl || item.DownloadUrl,
                        "DownloadUrl": item.DownloadUrl,
                        "ThumbnailUrl" : item.ThumbnailUrl || item.DownloadUrl
                    };
                    $('#uploadImgBox').prepend(
                        getPhotoItem(index, liWith, item.DownloadUrl, false)
                    );
                    $("#p" + index).data("picture", picData);
                });

                Sortable.create(document.getElementById('uploadImgBox'),
                    {
                        animation: 150,
                        onEnd: function (e) {
                        },
                        ghostClass:'.img-li',
                        handle:'.drag-handle'
                    });
            },
            getProductDetail: function (prodId) {
                var that = this;
                var param = {
                    ProductToTweebaaDetailRequired: true,
                    needProductType: true,
                    LanguageCode: lan
                };
                var userId = localStorage.getItem('userId');
                var url = getBaseUrl() + "api/users/" + userId + "/products/" + prodId + '?' + $.param(param);
                getAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    var data = response.data;
                    //console.log(JSON.stringify(response));

                    // 图片
                    pictures = data.Pictures;
                    that.form.Pictures = data.Pictures;
                    // that._setImageHtml(data.Pictures.reverse());

                    // 视频
                    if( data.SampleDownload){
                        that.form.SampleDownload = {
                            "MediaType" : "Video",
                            "MediaFileUrl" : data.SampleDownload.DownloadUrl,
                            "ThumbnailUrl" : data.SampleDownload.ThumbnailUrl,
                            "DurationSeconds" : data.SampleDownload.DurationSeconds,
                            "FileSize" : data.SampleDownload.FileSize,
                            "FileName" : data.SampleDownload.FileName
                        };
                        Video = [that.form.SampleDownload]
                    }

                    that.form.Name = data.Name;
                    that.form.FullDescription = data.FullDescription;
                    that.form.TweebuckPrice = data.TweebuckPrice;

                    that.form.Categories = data.Categories;
                    that._setCategoryName(data.Categories);

                    that.form.ProductTags = data.ProductTags;

                    that.form.Download = data.Download;
                    if (that.form.Download) {
                        that._setFileLabel(that.form.Download.DownloadUrl);
                    }

                    $('.select-box, #bigFileTips').addClass('d-none');
                    $('.step.step2').addClass('active borders');
                    $('.step.step1').removeClass('active');
                    that.currentStep = 'step2';
                    var productURL = that.form.Download.DownloadUrl;
                    SuggestProduct.enterDownload(productURL,'');
                    SuggestProduct.fileUploaded = true;
                    setRightBtn(nextBtn);

                    that.fileUrl = that.form.Download.DownloadUrl;
                    that.bigFileURL = that.form.Download.DownloadUrl;

                    var index= that.form.Download.DownloadUrl.lastIndexOf(".");
                    var ext = that.form.Download.DownloadUrl.substr(index+1).toLowerCase();
                    var i = that.form.Download.DownloadUrl.lastIndexOf("/");
                    that.fileName = that.form.Download.DownloadUrl.substr(i+1);
                    that.setProductType(ext);
                    $('.img-box').height(api.winWidth);

                    that._initDom();
                }).catch(function (error) {
                    loading('hide');
                    console.error(JSON.stringify(error));
                });
            },
            openCategoryPage:function () { //分类
                if (this.currentType === 'DIGITAL') {
                    openTabLayout('categoryDigital', '', 'widget://html/products/category-digital.html');
                } else {
                    openTabLayout('categoryPhysical','','widget://html/products/category-physical.html');
                }
            },
            openImgAndVideoPage:function(){ //图片和视频
                openTabLayout('imgVideo',MSG.products.imgAndVideo,'widget://html/products/img-video.html',{
                    img:pictures,
                    video:Video
                });
            },
            openProductTags:function () { // 打开tag输入
                openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
                    tags:tags?tags.join(','):null
                })
            },
            playAudio:function(type){
                var audio = document.querySelector('#audioPlayer');
                if(!this.audioPlaying){
                    audio.play();
                    this.audioPlaying = true;
                }else{
                    audio.pause();
                    this.audioPlaying = false;
                }
            },
            deleteUpload:function(){
                var that = this;
                confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    $('.dialog-box').remove();
                    var index = $(this).attr('id');
                    if (index === 'btn-2') {
                        that.currentStep = 'step1';
                        that.fileName = '';
                        that.fileSize = '';
                        that.fileUrl = '';
                        that.fileType = '';
                        that.inputLink = false;
                        that.fileUploaded = false;
                        that.enterDownload('','');
                        $('.select-box,#bigFileTips').removeClass('d-none');
                        $('.step.step2').removeClass('active borders');
                        $('.step.step1').addClass('active');
                        setRightBtn('');
                    }
                });
            },
            closeWin: function () {
                back();
            }
        }
    });

    $('#toInputLink').on('touchstart',function () {
        $('.select-box, #bigFileTips').addClass('d-none');
        $('.step.step2').addClass('active borders');
        $('.step.step1').removeClass('active');
        SuggestProduct.currentStep = 'step2';
        SuggestProduct.inputLink = true;
        setRightBtn(nextBtn);
    });
    $('.upload-button-input').on('change',function () {
        if ($(this).val() == "") {
            return false;
        }
        var file = this.files[0];
        if(file.size > VIDEO_MAX_SIZE){
            alert( MSG.upload.uploadTips);
            return
        }
        $('.select-box, #bigFileTips').addClass('d-none');
        $('.step.step2').addClass('active borders');
        $('.step.step1').removeClass('active');
        SuggestProduct.currentStep = 'step2';
        SuggestProduct.fileName = file.name;
        SuggestProduct.fileSize = (file.size/ 1048576).toFixed(2) + ' MB';
        SuggestProduct.fileUrl = showUrl(file);

//获取后缀名
        var index= file.name.lastIndexOf(".");
        var ext = file.name.substr(index+1).toLowerCase();
        SuggestProduct.setProductType(ext);
        $('.img-box').height(api.winWidth);
        //return;
        // var objUrl = showVideo(this.files[0]);
        //showDisplay('prod',fileName,objUrl);

        uploadProduct(file);
    });

    function showUrl(file) {
        var url = null;
        if (window.createObjectURL != undefined) { // basic
            url = window.createObjectURL(file);
        } else if (window.URL != undefined) { // mozilla(firefox)
            url = window.URL.createObjectURL(file);
        } else if (window.webkitURL != undefined) { // webkit or chrome
            url = window.webkitURL.createObjectURL(file);
        }
        return url;
    }

    function uploadProduct(file) {
        var token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        });
        var formData = new FormData();
        var productFile = file;
        if(productFile){
            formData.append('file', productFile, 'TWEEBAA-ORIGIN-'+ productFile.name);
        }

        var url = 'https://media.tweebaa.';
        if (localStorage.getItem('server') === 'cn') {
            url = url + 'cn';
        } else {
            url = url + 'com';
        }
        url = url + '/api/v1/uploader/products/' + localStorage.getItem('userGuid');

        //console.log(url);
        axios.post(url, formData, {
            headers: {
                "apikey":token,
                'Content-Type':'application/x-www-form-urlencoded;charset=utf-8'
            },
            //cancelToken:source.token,
            onUploadProgress: function (e){

                var completeProgress = ((e.loaded / e.total * 100) | 0);
                SuggestProduct.uploadPercentage = completeProgress;
                $('.upload-indicator').css('width',completeProgress+'%');

                if(completeProgress === 100){
                    loading('show');
                }
            }
        }).then(function(res){
            loading('hide');
            var productURL = res.data.Files[0].DownloadUrl;
            SuggestProduct.enterDownload(productURL,'');
            SuggestProduct.fileUploaded = true;
            setRightBtn(nextBtn);
        }).catch(function(error){
            console.log(JSON.stringify(error));
        });

    }


};

// $('.upload-button-input').on('change',function () {
//     var fileName = $(this).val();
//     if (fileName == "") {
//         return false;
//     }
//     console.log(this.files[0]);
//     if(this.files[0].size > 209715200){
//         alert( MSG.upload.uploadTips);
//         return
//     }
//     $('.select-box').addClass('d-none');
//     $('.step.step2').addClass('active borders');
//     $('.step.step1').removeClass('active');
//     SuggestProduct.currentStep = 'step2';
//     alert( this.files[0].size);
//
//     return
//     // var objUrl = showVideo(this.files[0]);
//     //showDisplay('prod',fileName,objUrl);
//
//     uploadProduct();
// });
