
var uploading = false;
var sending = false;
var pictures = [];
var Video = '';
var token ='';

// autosize(document.querySelectorAll('textarea'));

// PHYSICAL, DIGITAL, INVENTION

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('#media [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.moment[k]);
    });

    backListener();

    api.setWinAttr({
        bounces: false
    });

    var postBtn = lan === "zh" ? "发布" : "Post";
    api.setNavBarAttr({
        rightButtons: [{
            text: postBtn,
            color: '#4578F3',
            fontSize: '15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            if (SuggestProduct.isRequesting === false) {
                SuggestProduct.submit();
            }
        } else {
            if (SuggestProduct.isEdit === false) {
                SuggestProduct.beforeBack();
            } else {
                back();
            }
        }
    });

    api.addEventListener({
        name: 'keyback'
    }, function (ret, err) {
        if (SuggestProduct.isEdit === false) {
            SuggestProduct.beforeBack();
        } else {
            back();
        }
    });

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });

    var imgW = $('#width').width() - 5;
    $('#getPhotosNew, #videoBtn, #showVideo').height(imgW);

    //写入分类
    api.addEventListener({
        name: 'category'
    }, function(ret, err) {
        SuggestProduct.form.Categories = JSON.parse(ret.value.c);
    });

    api.addEventListener({
        name: 'categoryName'
    }, function(ret, err) {
        SuggestProduct.currentCategoryName = ret.value.list.join(', ');
    });

    var tags = [];
    api.addEventListener({
        name: 'tags'
    }, function(ret, err) {
        if(ret.value.tags){
            tags = ret.value.tags.split(',');
            var results = [];
            $.map(tags, function (item, index) {
                results.push({
                    name: item
                });
            });
            SuggestProduct.form.ProductTags = results;
        }
    });

    if (api.pageParam.product) {
        $('#upload').hide();
    }

    var kv = api.require('snKVStorage');
    var hasFormProductDraft = kv.has({
        key: 'formProductDraft'
    });
    var formProductDraft = {};
    if (hasFormProductDraft) {
        formProductDraft = kv.getObject({
            key: 'formProductDraft'
        });
    }

    var SuggestProduct = new Vue({
        el: '#SuggestProduct',
        filters: {

        },
        computed: {

        },
        mounted: function() {
            if (this.isEdit === false) {
                this._initDom();
            }
        },
        created: function() {

            loading('show');

            var productId = api.pageParam.productId;
            if (productId) {
                this.isEdit = true;
                this.productId = productId;
                this.getProductDetail(productId);
            } else {
                // 判断是否有草稿
                var form = formProductDraft[this.currentType];
                if (form) {
                    this.form = form;

                    if (this.form.Pictures && this.form.Pictures.length > 0) {
                        this._setImageHtml(this.form.Pictures);
                    }

                    if (this.form.Categories && this.form.Categories.length > 0) {
                        this._setCategoryName(this.form.Categories);
                    }

                    if (this.form.SampleDownload) {
                        renderVideo(this.form.SampleDownload[0].ThumbnailUrl);
                    }
                }
            }
        },
        data: {
            isLoading: true,
            currentType: 'PHYSICAL',
            isEdit: false,
            productId: '',
            isRequesting: false,
            currentCategoryName: '',
            form: {
                "ProductType": 1,
                "Name": '',
                "FullDescription": '',
                "Sku": '',
                "En" : {
                    "Name" : '',
                    "ShortDescription" : '',
                    "FullDescription" : '',
                    "AdvisoryReason" : null
                },
                "Cn" : {
                    "Name": '',
                    "ShortDescription" : '',
                    "FullDescription" : '',
                    "AdvisoryReason" : null
                },
                "Quantity": '',
                "TweebuckPrice": '',    // currency-selector
                "DisplayOrder": 0,
                "OrderMinimumQuantity":  1,
                "ProductTags": [],  // ['美食', ...]
                "Categories": [], // [{Id, L}]
                "IsFreeShipping": true,
                "ShippingFee": '',      // currency-selector
                "ShowOnHomePage": true,
                "Pictures": pictures,
                "CurrencyCode": null,
                "SampleDownload": Video,
                "ContactEmail": null,
                "ProductToTweebaa": null
            },
            message: MSG,
            hasFinishShowcaseTask: true
        },
        methods: {
            _initDom: function() {
                var that = this;

                $('#description').editor({
                    placeholder: MSG.suggestion.pDescription,
                    content: this.form.FullDescription
                });

                $('#price').val(this.form.TweebuckPrice);
                new CurrencySelector(document.getElementById('price'), function (tweebuckValue) {
                    if (tweebuckValue) {
                        that.form.TweebuckPrice = tweebuckValue;
                    } else {
                        that.form.TweebuckPrice = '';
                    }
                });

                $('#shippingFee').val(this.form.ShippingFee);
                new CurrencySelector(document.getElementById('shippingFee'), function (tweebuckValue) {
                    if (tweebuckValue !== '') {
                        that.form.ShippingFee = tweebuckValue;
                    } else {
                        that.form.ShippingFee = '';
                    }
                });

                loading('hide');
                $('.page-form').css({
                    opacity: 1
                });
            },
            submit: function() {
                var that = this;
                var params = {};
                console.log(JSON.stringify(Video));
                if (Video) {
                    this.form.SampleDownload = {
                        "MediaType": "Video",
                        "DownloadUrl": Video[0].MediaFileUrl,
                        "ThumbnailUrl": Video[0].ThumbnailUrl,
                        "DurationSeconds": Video[0].DurationSeconds,
                        "FileSize": Video[0].FileSize,
                        "FileName": Video[0].FileName
                    };
                } else {
                    this.form.SampleDownload = '';
                }

                // 图片
                if (uploading || imgUploading) {
                    api.toast({
                        msg: MSG.tips.uploadDataTips,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                var pictures = [];
                $("#uploadImgBox").find('img').each(function (index) {
                    var pic = $(this).data('picture');
                    pic.DisplayOrder = index;
                    pictures.push(pic);
                });
                if (pictures.length === 0) {
                    messages(MSG.tips.noPicError, 'error', 'top', 3);
                    return;
                }
                this.form.Pictures = pictures;

                // 名字
                if (!$.trim(this.form.Name)) {
                    messages(MSG.tips.productNameEmpty, 'error', 'top', 3);
                    return;
                }

                if (this.form.Name.length > 80) {
                    api.toast({
                        msg: MSG.tips.productNameTooLong,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                // 描述
                var description = $.trim($('#description').html());
                if (!description) {
                    messages(MSG.tips.descriptionEmpty, 'error', 'top', 3);
                    return;
                } else {
                    this.form.FullDescription = description;
                }

                // 价格
                if (!this.form.TweebuckPrice) {
                    messages(MSG.tips.productPriceEmpty, 'error', 'top', 3);
                    return;
                }
                if (+this.form.TweebuckPrice < 1) {
                    messages(MSG.tips.productPriceMin, 'error', 'top', 3);
                    return;
                }

                // 类别
                if (this.form.Categories && this.form.Categories.length === 0) {
                    api.toast({
                        msg: MSG.tips.categoryEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                // 标签
                if (this.form.ProductTags && this.form.ProductTags.length === 0) {
                    api.toast({
                        msg: MSG.tips.tag2,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                // 运费
                if (this.form.ShippingFee === '') {
                    messages(MSG.suggestion.pShippingFee, 'error', 'top', 3);
                    return;
                }

                // 库存
                if (!this.form.Quantity) {
                    messages(MSG.suggestion.pStockQuantity, 'error', 'top', 3);
                    return;
                }

                if (+this.form.Quantity <= 0) {
                    messages(MSG.suggestion.pcStockQuantity, 'error', 'top', 3);
                    return;
                }

                // 格式化一些参数
                that.form.Cn.Name = this.form.Name;
                that.form.Cn.FullDescription = this.form.FullDescription;
                that.form.En.Name = this.form.Name;
                that.form.En.FullDescription = this.form.FullDescription;

                if (this.form.ShippingFee > 0) {
                    this.form.IsFreeShipping = false;
                } else {
                    this.form.IsFreeShipping = true;
                }

                that.isRequesting = true;
                loading('show');
                params = $.extend({}, params, that.form);
                console.log('form: ' + JSON.stringify(params));

                loading('show');

                var url;
                if (this.isEdit === false) {

                    url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId');
                    getAxois(url, "POST", params).then(function (response) {
                        loading('hide');
                        var data = response.data;
                        if (data.Success) {
                            // api.toast({
                            //     msg: MSG.products.added,
                            //     duration: 2000,
                            //     location: 'middle'
                            // });
                            api.sendEvent({
                                name: 'productListReload',
                            });
                            api.closeWin({
                                name: 'prepareAdd'
                            });

                            confirm(MSG.tProduct.addSuccess, [
                                {
                                    text: MSG.general.next,
                                    callback: function () {
                                        that.toSuggest(data.Data.Id, data.Data.ProductGuid);
                                    }
                                },
                                {
                                    text: MSG.products.not,
                                    callback: function () {
                                        back();
                                    }
                                }
                            ]);

                        } else {
                            that.isRequesting = false;
                            api.toast({
                                msg: response.data.ExceptionMessage || MSG.tips.systemError,
                                duration: 2000,
                                location: 'middle'
                            });
                        }

                    }).catch(function (error) {
                        api.toast({
                            msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                            duration: 2000,
                            location: 'middle'
                        });
                        loading('hide');
                        that.isRequesting = false;
                    });

                } else {
                    url = getBaseUrl() + "api/v2/products?userId=" + localStorage.getItem('userId') + "&productId=" + this.productId;
                    getAxois(url, "PUT", params).then(function (response) {
                        loading('hide');
                        if (response.data.Success) {

                            api.toast({
                                msg: MSG.tips.updated,
                                duration: 2000,
                                location: 'middle'
                            });
                            api.sendEvent({
                                name: 'productListReload',
                            });
                            api.sendEvent({
                                name: 'productInfoReload',
                            });
                            api.sendEvent({
                                name: 'indexProductListReload',
                            });
                            api.sendEvent({
                                name: 'workplaceReload',
                                extra: {
                                    type: 'product'
                                }
                            });
                            setTimeout(function () {
                                back();
                            },2000);
                        } else {
                            that.isRequesting = false;
                            api.toast({
                                msg: response.data.ExceptionMessage || MSG.tips.systemError,
                                duration: 2000,
                                location: 'middle'
                            });
                        }

                    }).catch(function (error) {
                        loading('hide');
                        that.isRequesting = false;
                        api.toast({
                            msg: MSG.moment.blockText + '"' + error.response.data.Message +'"',
                            duration: 2000,
                            location: 'middle'
                        });
                    });
                }

            },
            toSuggest: function(productId, productGuid) {
                var product = $.extend({}, this.form, {
                    Id: productId,
                    ProductGuid: productGuid
                });
                openTabLayout('suggestProduct', MSG.tProduct.suggestProduct, 'widget://html/products/suggest-product.html', {
                    type: 'PHYSICAL',
                    product: product
                });
                setTimeout(function () {
                    back();
                }, 2000);
            },
            saveDraft: function() {

                // 描述
                var description = $.trim($('#description').html());
                if (description && description !== '<br>') {
                    this.form.FullDescription = description;
                } else {
                    this.form.FullDescription = '';
                }

                // 图片
                var pictures = [];
                $("#uploadImgBox").find('img').each(function (index) {
                    var pic = $(this).data('picture');
                    pic.DisplayOrder = index;
                    pictures.push(pic);
                });
                this.form.Pictures = pictures;

                // 视频
                if(Video){
                    this.form.SampleDownload = {
                        "MediaType": "Video",
                        "DownloadUrl": Video[0].MediaFileUrl,
                        "ThumbnailUrl": Video[0].ThumbnailUrl,
                        "DurationSeconds": Video[0].DurationSeconds,
                        "FileSize": Video[0].FileSize,
                        "FileName": Video[0].FileName
                    };
                }

                formProductDraft[this.currentType] = $.extend({}, this.form);
                kv.setObject({
                    key: 'formProductDraft',
                    value: formProductDraft
                });

                setTimeout(function () {
                    back();
                }, 100)
            },
            beforeBack: function() {
                var that = this;
                confirm(MSG.suggestion.beforeBackTipAdd, [
                    {
                        text: MSG.moment.saveDraft,
                        callback: function () {
                            that.saveDraft();
                        }
                    },
                    {
                        text: MSG.moment.exitDirectly,
                        callback: function () {
                            delete formProductDraft[that.currentType];
                            kv.setObject({
                                key: 'formProductDraft',
                                value: formProductDraft
                            });
                            setTimeout(function () {
                                back();
                            }, 100);
                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            openWarn: function(key, $event) {
                // alert(MSG.suggestion[key]);
                $event && $event.stopPropagation();
                dialog({
                    title: MSG.tips.title,
                    content: MSG.suggestion[key],
                    primaryText: MSG.tips.gotit,
                    asideText: '',
                    onClose: "show",
                    textAlign: 'left',
                    onWarning: function() {
                    },
                    onPrimary: function () {

                    }
                });
            },
            _setCategoryName: function(Categories) {
                var ids = [];
                $.map(Categories, function (item, index) {
                    ids.push(item.Id);
                });
                var categoryNames = getCategoryNameByIds(ids, lan);
                this.currentCategoryName = categoryNames.join(', ');
            },
            _setImageHtml: function(list) {
                id = id + list.length;
                $.map(list, function (item, index) {
                    var picData =  {
                        "MediaType": "Picture",
                        "FileName": "testimage.png",
                        "MediaFileUrl": item.MediaFileUrl || item.DownloadUrl,
                        "DownloadUrl": item.DownloadUrl,
                        "ThumbnailUrl" : item.ThumbnailUrl || item.DownloadUrl
                    };
                    $('#uploadImgBox').prepend(
                        getPhotoItem(index, liWith, item.DownloadUrl, false)
                    );
                    $("#p" + index).data("picture", picData);
                });

                Sortable.create(document.getElementById('uploadImgBox'),
                    {
                        animation: 150,
                        onEnd: function (e) {
                        },
                        ghostClass:'.img-li',
                        handle:'.drag-handle'
                    });
            },
            getProductDetail: function (prodId) {
                var that = this;
                var param = {
                    ProductToTweebaaDetailRequired: true,
                    needProductType: true,
                    LanguageCode: lan
                };
                var userId = localStorage.getItem('userId');
                var url = getBaseUrl() + "api/users/" + userId + "/products/" + prodId + '?' + $.param(param);
                getAxois(url, "GET", {}).then(function (response) {
                    var data = response.data;
                    // 图片
                    remaining = remaining - data.Pictures.length;
                    that.form.Pictures = data.Pictures;
                    that._setImageHtml(data.Pictures.reverse());

                    // 视频
                    if(data.SampleDownload){
                        Video = [data.SampleDownload];
                        renderVideo(Video[0].ThumbnailUrl);
                    }

                    that.form.Name = data.Name;
                    that.form.FullDescription = data.FullDescription;
                    that.form.TweebuckPrice = data.TweebuckPrice;

                    that.form.Categories = data.Categories;
                    that._setCategoryName(data.Categories);

                    that.form.ProductTags = data.ProductTags;
                    that.form.Quantity = data.Quantity;
                    that.form.ShippingFee = data.ShippingFee || 0;
                    that.form.IsFreeShipping = data.IsFreeShipping;
                    that.form.Sku = data.Sku || '';

                    that._initDom();
                }).catch(function (error) {
                    console.error(JSON.stringify(error));
                });
            },
            openCategoryPage:function () { //分类
                if (this.currentType === 'DIGITAL') {
                    openTabLayout('categoryDigital', '', 'widget://html/products/category-digital.html');
                } else {
                    openTabLayout('categoryPhysical','','widget://html/products/category-physical.html');
                }
            },
            openProductTags:function () { // 打开tag输入
                openTabLayout('productTagPage','','widget://html/products/product-tags.html',{
                    tags:tags?tags.join(','):null
                })
            },
            closeWin: function () {
                back();
            },
        }
    });

};

