var productVideoURL,productVideoThumbnailURL;

//添加产品视频
$("#getProductVideo").on('change', function () {

    var fileName = $(this).val();
    if (fileName == "") {
        return false;
    }
    // var objUrl = showVideo(this.files[0]);
    //showDisplay('prod',fileName,objUrl);
    if(this.files[0].size > 209715200){
        alert(MSG.tips.fileTooLarge);
        return
    }
    uploadProduct();
});

//删除产品和小样
function deleteUpload() {
    confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error');
    $('.dialog-box').find('button').on('click',function (e) {
        $('.dialog-box').remove();
        var index = $(this).attr('id');
        if (index === 'btn-2') {
            videoURL = null;
            $('#progress').css('width',0);
            $('#videoBtn').removeClass('d-none');
            $('#showVideo').addClass('d-none').find('.media-btn').css("background-image","url('')");
        }
    });

}

function uploadProduct() {
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var formData = new FormData();
    var sampleFile = $('#getProductVideo').get(0).files[0];
    if(sampleFile){
        formData.append('file', sampleFile, 'TWEEBAA-SAMPLE-'+ sampleFile.name);
    }

    var url = 'https://media.tweebaa.';
    if (localStorage.getItem('server') === 'cn') {
        url = url + 'cn';
    } else {
        url = url + 'com';
    }
    url = url + '/api/v1/uploader/products/' + localStorage.getItem('userGuid');
    $('.ui-progress').css('opacity',1);
    axios.post(url, formData, {
        headers: {
            "apikey":token,
            'Content-Type':'application/x-www-form-urlencoded;charset=utf-8'
        },
        onUploadProgress: function (e){
            var completeProgress = ((e.loaded / e.total * 100) | 0);
            //console.log(JSON.stringify(completeProgress));
            $('#progress').css('width',completeProgress+'%');

        }
    }).then(function(res){
        //console.log(JSON.stringify(res));
        productVideoURL = res.data.Files[0].DownloadUrl;
        productVideoThumbnailURL = res.data.Files[0].ThumbnailUrl;
        videoURL = {
            "MediaType": "Video",
            "DownloadUrl": productVideoURL,
            "ThumbnailUrl": productVideoThumbnailURL,
            "DurationSeconds": Math.ceil(res.data.Files[0].Duration),
            "FileSize": res.data.Files[0].Size,
            "FileName": res.data.Files[0].Name
        };
        $('#videoBtn').addClass('d-none');
        $('#showVideo').removeClass('d-none').find('.media-btn').css("background-image","url("+ productVideoThumbnailURL +")");
        $('.ui-progress').css('opacity',0);
        $('#progress').css('width',0);

    }).catch(function(error){
        console.log(JSON.stringify(error));
    });

}

