
var workPlace;
var mPages = 0;
var pPages = 0;

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    // openWindows('editTycoonplace', 'widget://html/users/tycoonplace-edit.html');

    // openTycoonPlace();

    // openUserTycoonPlace('1892075', '麻雀', 'https://tweebaafiles.oss-cn-beijing.aliyuncs.com/upload/images/2020-10-10/a7ac0f37-e1f9-450e-b920-8da1b20f16f4.jpg');

    // openTabLayout('followList', 'follow', 'widget://html/users/follow-list.html', {
    //     type: 'follow'
    // });

    var kv = api.require('snKVStorage');

    var TIV_LEVEL = {
        "1": {
            level: 1,
            tiv: 10,
            bean: 0.88,
            img: '../../image/mine/tiv-gift1.png'
        },
        "2": {
            level: 2,
            tiv: 25,
            bean: 1.88,
            img: '../../image/mine/tiv-gift2.png'
        },
        "3": {
            level: 3,
            tiv: 45,
            bean: 2.22,
            img: '../../image/mine/tiv-gift3.png'
        },
        "4": {
            level: 4,
            tiv: 70,
            bean: 6.68,
            img: '../../image/mine/tiv-gift4.png'
        },
        "5": {
            level: 5,
            tiv: 100,
            bean: 8.88,
            img: '../../image/mine/tiv-gift5.png'
        }
    };

    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token');

    // 缓存当前用户
    var BASEINFO,USERINFO,COUNT_TIV,COUNT_TWEEBUCK,COUNT_FOLLOWER;
    if(token){

        var hasBaseInfo = kv.has({
            key: 'baseInfo'
        });

        if(hasBaseInfo){
            BASEINFO = kv.getObject({
                key: 'baseInfo'
            });
        }

        var hasUserInfo = kv.has({
            key: 'userInfo'
        });
        if(hasUserInfo){
            USERINFO = kv.getObject({
                key: 'userInfo'
            });
        }

        // 我的瞬间
        var MYPOSTDATA = [];
        var hasMyPostData = kv.has({
            key: 'myPostData'
        });
        if(hasMyPostData){
            MYPOSTDATA = kv.getArray({
                key: 'myPostData'
            });
        }

        // 我的产品
        var MY_RPODUCT_DATA = [];
        var hasMyProductData = kv.has({
            key: 'myProductData'
        });

        if(hasMyProductData){
            MY_RPODUCT_DATA = kv.getArray({
                key: 'myProductData'
            });
        }

        resetValuesFromLocal();

        //监听客服信息
        var mq = api.require("meiQia");
        mq.getUnreadMessageCount(function(ret) {
            workPlace.unreadCSMessage = ret.count
        });
        mq.addMessageListener(function(ret, err){
            if(ret){
                mq.getUnreadMessageCount(function(ret) {
                    workPlace.unreadCSMessage = ret.count
                });
            }
        });
    }

    function resetValuesFromLocal() {
        var kv = api.require('snKVStorage');
        var hasTiv = kv.has({
            key: 'tiv'
        });
        if(hasTiv) {
            COUNT_TIV = kv.getDouble({
                key: 'tiv'
            });
        }

        var hasTweebuck = kv.has({
            key: 'tweebuck'
        });
        if(hasTweebuck){
            COUNT_TWEEBUCK = kv.getDouble({
                key: 'tweebuck'
            });
        }

        var hasFollower = kv.has({
            key: 'follower'
        });
        if(hasFollower) {
            COUNT_FOLLOWER = kv.getInt({
                key: 'follower'
            });
        }
    }

    api.addEventListener({
        name: 'workplaceReload'
    }, function(ret, err){
        resetValuesFromLocal();
        if(ret.value.type ==='tweebuck'){
            workPlace.getTweebucksBalance();
        }else if(ret.value.type  === 'info'){
            workPlace.getMyDetails();
        }else if(ret.value.type  === 'tiv'){
            workPlace.getTiv();
        }else if(ret.value.type  === 'notify') {
            workPlace.getNotifyUnreads();
        } else if(ret.value.type  === 'task'){
            workPlace.getTaskList();
        } else if(ret.value.type  === 'view'){
            workPlace.getViewTime();
        }else if(!ret.value){
            location.reload();
        }
    });

    //同步详情页和列表页数据
    // api.addEventListener({
    //     name: 'resetPost',
    // }, function (ret, err) {
    //     switch (ret.value.type) {
    //         case 'remove':
    //             $('li#'+ret.value.postGuid).remove();
    //             break;
    //         case 'like':
    //             if(ret.value.from ==='my'){
    //                 workPlace.momentsData[ret.value.index].Liked = ret.value.liked;
    //                 workPlace.momentsData[ret.value.index].LikedCount = ret.value.likedCount;
    //             }
    //             break;
    //         case 'comments':
    //             if(ret.value.from ==='my' && ret.value.commentCount ==='add'){
    //                 workPlace.momentsData[ret.value.index].CommentCount ++;
    //             }else if(ret.value.from ==='my' && ret.value.commentCount ==='minus'){
    //                 workPlace.momentsData[ret.value.index].CommentCount --;
    //             }
    //             break;
    //     }
    // });

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function(ret, err) {
        //结束下拉刷新状态
        api.refreshHeaderLoadDone();

        if (workPlace.isLoggedIn) {
            resetValuesFromLocal();

            workPlace.getNotifyUnreads();
            workPlace.getMyDetails();
            workPlace.getTiv();
            workPlace.getTweebucksBalance();
        }
    });

    api.addEventListener({
        name: guideService.GUIDE_MINE.key
    }, function(ret, err){
        if (guideService.check(guideService.GUIDE_MINE.key) === false) {
            var $tivBar = $('.tiv-bar-box');
            var $bannerBox = $('.banner-box');
            var $invite = $('#invite');
            var $tweebuck = $('#tweebuck');
            guideService.openGuidePage(guideService.GUIDE_MINE.key, {
                list: [
                    {
                        mode: 'rightTop',
                        right: 94,
                        top: 4,
                        width: 34,
                        height: 34,
                        content: MSG.guide.mine1
                    },
                    {
                        mode: 'top',
                        left: $tivBar.offset().left,
                        top: $tivBar.offset().top + HEADER_HEIGHT,
                        width: $tivBar.width(),
                        height: $tivBar.height(),
                        content: MSG.guide.mine2
                    },
                    {
                        mode: 'top',
                        left: $bannerBox.offset().left,
                        top: $bannerBox.offset().top + HEADER_HEIGHT,
                        width: $bannerBox.width(),
                        height: $bannerBox.height(),
                        content: MSG.guide.mine3,
                        borderRadius: 'none'
                    },
                    {
                        mode: 'top',
                        left: $invite.offset().left,
                        top: $invite.offset().top + HEADER_HEIGHT,
                        width: $invite.width(),
                        height: $invite.height(),
                        content: MSG.guide.mine4,
                        textAlign: 'left',
                        borderRadius: 'none'
                    },
                    {
                        mode: 'top',
                        left: $tweebuck.offset().left,
                        top: $tweebuck.offset().top + HEADER_HEIGHT,
                        width: $tweebuck.width(),
                        height: $tweebuck.height(),
                        content: MSG.guide.mine5,
                        textAlign: 'left',
                        borderRadius: 'none'
                    }
                ]
            });
        }
    });

    workPlace = new Vue({
        el: '#mine',
        mounted: function () {
            var that = this;
            if(token){
                this.getNotifyUnreads();
                this.getMyDetails();
                this.getTweebucksBalance();
                this.getTiv();
                this.getViewTime();
                this.getTaskList();

                var version = api.appVersion.toString();
                var m = Math.random();
                getAxois("https://tweebaafiles-com.oss-accelerate.aliyuncs.com/check.json?"+m, "GET", {}).then(function (response) {
                    if(api.systemType ==='ios'){
                        that.appleCheck = !!((response.data.version === version && response.data.check) || localStorage.getItem('userId') == "1808307");
                    }
                })
            }
        },
        created: function() {
            this.doTiv();
        },
        data: {
            appleCheck: false,
            myID: BASEINFO ? BASEINFO.UserID : localStorage.getItem('userId'),
            userInfo: {
                coverImg:'',
                myPortrait: USERINFO ? USERINFO.ThumbnailAvatarUrl : localStorage.getItem('thumbnail') || "../../image/default_portrait.png",
                UserName: USERINFO ? USERINFO.UserName : localStorage.getItem('userName'),
                ThumbnailAvatarUrl: USERINFO ? USERINFO.ThumbnailAvatarUrl : localStorage.getItem('thumbnail'),
                tiv: COUNT_TIV || '--',
                tweebuck: COUNT_TWEEBUCK || '--',
                follower: COUNT_FOLLOWER || '--',
                following: USERINFO ? USERINFO.FollowingCount : '--',
                Id:localStorage.getItem('userId'),
                tycoonName: USERINFO ? USERINFO.StoreName : localStorage.getItem('storename'),
                myTags: USERINFO ? USERINFO.PersonalTags : localStorage.getItem('myTags'),
                myIntroduction: USERINFO ? USERINFO.Introduction : '',
            },
            changeTiv:'',
            changeTweebuck:'',
            changeFollower:'',
            taskStatusMap: {},
            message:MSG,
            isLoggedIn: kv.getBool({key: 'isLoggedIn'}),
            unreadsNotify: 0,
            tivProgress:0,
            unreadCSMessage:0,
            productCount:"--",
            momentCount:"--",
            viewTime:"--",
            tasksList: {},
            hasSign: true,   // 是否已经签到
            signItem: {},     // 记录签到的条目
            nextLevel: {
                level: 1,
                tiv: 10,
                bean: 0.88,
                img: '../../image/mine/tiv-gift1.png'
            },
            isGetReward:true,
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            formatChange:function (value) {
                if(value){
                    if(value > 0){
                        return '+'+value;
                    }else{
                        return value;
                    }
                }
            },
            toThousand: function (value) {
                if(value || value === 0 ){
                    var N = Number(value);
                    if(N > 1000){
                        return Math.round(N / 100) / 10 + "K";
                    }else{
                        return value;
                    }
                }else{
                    return '--'
                }
            }
        },
        methods:{
            doTiv: function() {
                var value = +this.userInfo.tiv;
                var item;
                for (var key in TIV_LEVEL) {
                    item = TIV_LEVEL[key];
                    if (value <= item.tiv) {
                        this.nextLevel = item;
                        break;
                    }
                }
                if (value <= 100) {
                    this.tivProgress = {
                        width: (value / this.nextLevel.tiv * 100) + "%",
                    };
                }
            },
            toSign: function() {
                var that = this;
                if (this.hasSign === true) {
                    alert(MSG.tasks.hasSign);
                } else {
                    var URL = "/api-task/userevent/save";
                    var traceId = Date.now() + '-' + this.myID + '-' + 6;
                    var param = {
                        "eventType": 6,
                        "traceId": traceId,
                        "userId": this.myID
                    };
                    loading('show');
                    apiTask.post(URL, param).done(function (rep) {
                        if (rep.code === 0) {
                            setTimeout(function () {
                                apiTask.loopTaskList(TASK_CODE.SIGN, -1, function () {
                                    loading('hide');
                                    that.hasSign = true;
                                    api.execScript({
                                        name: 'root',
                                        script: "hasSignTips();"
                                    });
                                    confirmTiV({
                                        value: that.signItem.reward,
                                        content: that.signItem.name,
                                        onWarning: function() {
                                        },
                                        onPrimary: function () {

                                        },
                                        onAside: function () {

                                        }
                                    });
                                    // 刷新本页
                                    that.getTiv();
                                });
                            }, 1000);
                        } else {
                            loading('hide');
                            console.error(JSON.stringify(ret));
                        }
                    });

                }
            },
            getTaskList: function () {
                var that = this;
                var url = "/api-task/usertask/main";
                var lang = (lan === "zh" ? "zh_CN" : "en_US");
                var param = {
                    "lang": lang,
                    "userId": that.myID
                };
                apiTask.get(url, param).done(function (rep) {
                    if (rep.code === 0) {
                        var tasksList = rep.tasks;
                        var dailys = tasksList.dailys;
                        if (dailys) {
                            for (var i = 0, len = dailys.length; i < len; i++) {
                                var item = dailys[i];
                                if (item.id === TASK_CODE.SIGN) {
                                    that.signItem = item;
                                    if (item.status === 2 || item.status === 3) {
                                        that.hasSign = true;
                                        api.execScript({
                                            name: 'root',
                                            script: "hasSignTips();"
                                        });
                                    } else {
                                        that.hasSign = false;
                                        api.execScript({
                                            name: 'root',
                                            script: "hasSignTips('true');"
                                        });

                                    }
                                    break;
                                }
                            }
                        }
                        var list = rep.tasks.novices;
                        var data = {};

                        data.all = list.length;
                        data.count = 0;
                        data.id = 1;
                        list.forEach(function (item, inx){
                            this.taskStatusMap[item.id] = item.status;
                            if(Number(item.status) === 2){
                                data.count ++;
                                data.id += 1;
                            }
                        }.bind(this));
                        if (data.id === 1 && data.count === 1){
                            data.id = 1;
                        }
                        this.tasksList = data;
                    } else {
                        console.error({ msg: JSON.stringify(rep) });
                    }
                }.bind(this));
            },
            getNotifyUnreads: function() {
                var that = this;
                var userName = localStorage.getItem('userName');
                //console.log("[" + api.deviceName + "] userName: " + userName);
                apiNotify.get("/notification/" + userName + "/total_unread", {}).done(function (rep) {
                    if (rep.code === 0) {
                        that.unreadsNotify = rep.data;
                    } else {
                        api.toast({
                            msg: rep.responseText,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error("[" + api.deviceName + "] getNotifyUnreads: " + JSON.stringify(err));
                });
            },
            openNotifyPage: function() {
                openTabLayout('NotifyCategory', this.message.notif.title, 'widget://html/users/notify-category.html');
            },
            showMyQrCode:function(){
                openTabLayout('mycode', this.message.mine.mycode ,'widget://html/access/mycode.html');
            },
            /**
             * 获取当前用户空间浏览量
             */
            getViewTime:function(){
                var that = this;
                var url = getBaseUrl() + "api/dashboard/v1/ty/" + this.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(that.tag));
                    if(response.data.Code === 0){
                        that.viewTime = response.data.Data.Views;
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');

                });

            },
            /**
             * 获取当前用户信息
             */
            getMyDetails:function () {
                var that = this;
                var url = getBaseUrl() + "api/users/" + this.myID;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    loading("hide");
                    //console.log(JSON.stringify(response));
                    if(response.data.Code === 6000003){
                        localStorage.clear();
                        api.removePrefs({
                            key: 'accessToken'
                        });
                        alert(MSG.tips.accountDel, function () {
                            api.rebootApp();
                        });
                    }else {
                        that.userInfo.tycoonName = response.data.StoreName;
                        that.userInfo.myPortrait = response.data.ThumbnailAvatarUrl;
                        that.userInfo.follower = response.data.FollowersCount;
                        that.userInfo.following = response.data.FollowingCount;
                        that.userInfo.coverImg = response.data.BackgroundUrl;
                        that.userInfo.myIntroduction = response.data.Introduction;
                        that.userInfo.myTags = response.data.PersonalTags;

                        localStorage.setItem('storename', response.data.StoreName);
                        localStorage.setItem('chatPortrait', response.data.ThumbnailAvatarUrl);
                        localStorage.setItem('thumbnail', response.data.ThumbnailAvatarUrl);
                        localStorage.setItem('introduction',response.data.Introduction);
                        localStorage.setItem('myTags',JSON.stringify(response.data.PersonalTags));

                        // that.productCount = response.data.ProductCount;
                        // that.momentCount = response.data.MomentCount;

                        kv.setObject({
                            key: 'userInfo',
                            value: response.data
                        });

                        if(COUNT_FOLLOWER){
                            var V = response.data.FollowersCount - COUNT_FOLLOWER;
                            if(V > 0){
                                that.changeFollower = V;
                            }
                        }
                        kv.setInt({
                            key: 'follower',
                            value: response.data.FollowersCount
                        });
                    }

                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getTiv:function () {
                var that = this;
                apiTiv.get("/api/v1/tiv", {}).done(function (rep) {
                    if (rep.code === 0) {
                        var Tiv = rep.data.completedTiv;

                        if (Tiv.toString().length <= 9) {
                            that.userInfo.tiv = Tiv;
                        } else {
                            that.userInfo.tiv = Math.floor(Tiv);
                        }

                        that.doTiv();

                        if(COUNT_TIV){
                            var V = Number(Tiv) - COUNT_TIV;
                            if(V > 0){
                                that.changeTiv = V.toFixed(2);
                            }
                        }

                        kv.setDouble({
                            key: 'tiv',
                            value: Number(Tiv)
                        });

                        if(Tiv >= 100){
                            that.checkTivReward();
                        }
                    } else {
                        api.toast({
                            msg: rep.responseText,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error("[" + api.deviceName + "] getNotifyUnreads: " + JSON.stringify(err));
                });
            },
            checkTivReward:function(){
                var that = this;
                var url = getBaseUrl() + "api/v2/tiv/reward/check?UserId="+ this.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.isGetReward = response.data.Data.UserTivLevel < 5;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getTweebucksBalance:function () {
                var that = this;
                var url = getBaseUrl() + "api/tweebucks/v1/balance?UserId="+ this.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    // console.log(JSON.stringify(response));
                    var tweebuck = response.data.Data.CompletedSubtotal;
                    that.userInfo.tweebuck = tweebuck.toFixed(2);

                    if(COUNT_TWEEBUCK){
                        var V = Number(tweebuck.toFixed(2)) - COUNT_TWEEBUCK;
                        if(V > 0){
                            that.changeTweebuck = V.toFixed(2);
                        }
                    }

                    kv.setDouble({
                        key: 'tweebuck',
                        value: Number(tweebuck.toFixed(2))
                    });

                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            rewardTweebucks:function(){
                var that = this;
                var url = getBaseUrl() + "api/v2/tiv/reward/tweebucks?UserId="+ this.myID;
                loading('show');
                getAxois(url, "POST", {}).then(function (response) {
                    loading('hide');
                    var next,tweebeanValue;
                    switch (response.data.Data.UserTivLevel) {
                        case 0:
                            next = 10;
                            tweebeanValue = 0.88;
                            break;
                        case 1:
                            next = 25;
                            tweebeanValue = 1.88;
                            break;
                        case 2:
                            next = 45;
                            tweebeanValue = 2.22;
                            break;
                        case 3:
                            next = 70;
                            tweebeanValue = 6.68;
                            break;
                        case 4:
                            next = 100;
                            tweebeanValue = 8.88;
                            break;
                    }
                    if(response.data.Code === 0 && response.data.Data.RewardedTweebucks !== 0){

                        api.openFrame({
                            name: 'dialogGiftBag',
                            url: 'widget://html/dialog/dialog-tweebean.html',
                            rect: {
                                x: 0,
                                y: 0,
                                w: 'auto',
                                h: 'auto'
                            },
                            pageParam: {
                                value: response.data.Data.RewardedTweebucks,
                                nextValue: next
                            },
                            bounces: false,
                            bgColor:'rgba(0,0,0,0)',
                            fixedOn: 'ui_layout'
                        });


                        api.removeEventListener({
                            name: 'dialogTweebeanAside'
                        });
                        api.addEventListener({
                            name: 'dialogTweebeanAside'
                        }, function() {
                            that.openPages('tweebuck');
                        });


                    }else if(response.data.Data.RewardedTweebucks === 0){
                        var content;
                        if (lan === 'zh') {
                            content = MSG.tasks.getGiftTip + next + MSG.tasks.getGiftTip2 + tweebeanValue + MSG.tasks.getGiftTip3;
                        } else {
                            content = MSG.tasks.getGiftTip + tweebeanValue + MSG.tasks.getGiftTip2 + next + MSG.tasks.getGiftTip3;
                        }
                        api.openFrame({
                            name: 'dialog',
                            url: 'widget://html/dialog/dialog.html',
                            rect: {
                                x: 0,
                                y: 0,
                                w: 'auto',
                                h: 'auto'
                            },
                            pageParam: {
                                title: MSG.tasks.getGiftTipTitle,
                                content: content,
                                primaryText:MSG.tasks.primary,
                                showClose:true
                            },
                            bounces: false,
                            bgColor:'rgba(0,0,0,0)',
                            fixedOn: 'ui_layout'
                        });


                    }
                    that.isGetReward = true;
                    if(that.userInfo.tiv >= 100){
                        that.checkTivReward();
                    }
                    that.getTweebucksBalance();

                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            openTask: function() {
                openTabLayout('tasks', MSG.mine.tasks ,'widget://html/discovery/tasks.html');
            },

            createPost: function() {
                openWindows('addMoment', 'widget://html/users/add-moment.html');
            },
            createProduct: function() {
                var name = this.message.mine.selectProductType;
                openTabLayout('prepareAdd',name,'widget://html/products/prepare-add.html');
            },
            showHelpMenu: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.mine.faq,
                        callback: function () {
                            that.openPages('faq');
                        }
                    },
                    {
                        text: MSG.mine.waysEarn,
                        callback: function () {
                            that.waysEarnPage();
                        }
                    },
                    // {
                    //     text: MSG.mine.service,
                    //     callback: function () {
                    //         that.openCustomer();
                    //     }
                    // }
                ])
            },
            openPages:function (type) {
                var that = this;
                var url,name;
                var pageParam = {};
                switch (type) {
                    case "moments":
                        url = '../users/my-post-list.html';
                        name = that.message.mine.myMoment;
                        break;
                    case "novice":
                        url = 'widget://html/frame/novice.html';
                        name = '';
                        pageParam = {
                            id: this.tasksList.id
                        };
                        if (this.tasksList.count === this.tasksList.all){
                            url = 'widget://html/access/faq-new.html';
                            name = that.message.mine.help;
                            // api.execScript({
                            //     name: 'root',
                            //     script: 'switchToIndex(0, "home");'
                            // });
                            // return;
                        }
                        break;
                    case "invite":
                        url = '../access/invite.html';
                        name = that.message.mine.inviteFriend;
                        break;
                    case "favorite":
                        url = '../users/my-favorite-list.html';
                        name = that.message.mine.myFavorite;
                        break;
                    case "tiv":
                        that.changeTiv = '';
                        url = 'widget://html/business/tiv-statement.html';
                        name = that.message.mine.myTIV;
                        break;
                    case "tweebuck":
                        that.changeTweebuck = '';
                        url = '../tweebucks/tweebuck.html';
                        name = that.message.mine.Tweebank;
                        break;
                    case "dataAnalytics":
                        url = '../analytics/analytics.html';
                        name = that.message.mine.dataAnalytics;
                        break;
                    case "faq":
                        url = 'widget://html/access/faq.html';
                        name = that.message.mine.faq;
                        break;
                    case "myProduct":
                        url = '../products/myproducts.html';
                        name = that.message.mine.myProduct;
                        break;
                    case "suggestProduct":
                        url = '../products/suggest-product.html';
                        name = that.message.mine.suggestProduct;
                        break;
                    case "mySuggested":
                        url = '../products/mysuggest.html';
                        // url = '../products/myproducts.html';
                        name = that.message.mine.mySuggested;
                        break;
                    case "myPresale":
                        url = '../products/mypresale.html';
                        name = that.message.mine.myPresale;
                        break;
                    case "myTweelog":
                        url = '../tweelog/myTweeLog.html';
                        name = that.message.tweeLog.myTweelog;
                        break;
                    case "orderlist":
                        url = 'widget://html/products/order-list.html';
                        name = that.message.mine.sold;
                        break;
                    case "purchasesList":
                        url = 'widget://html/business/purchases-list.html';
                        name = that.message.mine.purchases;
                        break;
                    case "configuration":
                        url = '../users/configuration.html';
                        name = that.message.mine.setting;
                        break;
                    case "helpCenter":
                        url = 'widget://html/access/faq-new.html';
                        name = that.message.mine.help;
                        break;
                    case "downloadManager":
                        url = 'widget://html/users/download-manager.html';
                        name = that.message.mine.downloadManager;
                        break;
                    case "myProfile":
                        url = '../users/my-profile.html';
                        name = that.message.mine.editProfile;
                        openTabLayout(type,name,url, {
                            userInfo: this.userInfo
                        });
                        return;
                    case "portrait":
                        openChangePortrait();
                        return;
                }
                openTabLayout(type,name,url, pageParam);
            },
            openCustomer:function(){

                if(this.huaweiCheck){
                    chatToService();
                }else{
                    MQCustomerSerivce();
                }

            },
            toFollowList:function(type){
                var unread = this.changeFollower;
                openTabLayout('followList', MSG.general[type], 'widget://html/users/follow-list.html', {
                    type: type,
                    unread: +unread
                });
                this.changeFollower ='';
            },
            toActivityList:function (type) {
                var name  = type ==='post'? this.message.mine.addActivity:this.message.mine.joinActivity;
                openTabLayout('myActivityList',name,'widget://html/discovery/my-activity-list.html',
                    {
                        type:type
                    }
                );
            },
            waysEarnPage:function(){
                openBrowser('',shareH5Host + '/html/earn.html?lang='+lan,this.message.mine.waysEarn)
            },
            openEditTycoonPlace: function () {
                openTabLayout('editTycoonplace','', 'widget://html/users/tycoonplace-edit.html',{},true);
            },
            TweebeanGiftBag:function(config){
                var that = this;
                api.openFrame({
                    name: 'dialogGiftBag',
                    url: 'widget://html/dialog/dialog-tweebean.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        value: config.value,
                        nextValue: config.nextValue
                    },
                    bounces: false,
                    bgColor:'rgba(0,0,0,0)',
                    fixedOn: 'ui_layout'
                });

                api.removeEventListener({
                    name: 'dialogTweebeanAside'
                });
                api.addEventListener({
                    name: 'dialogTweebeanAside'
                }, function() {
                    that.openPages('tiv');
                });
            }
        }

    });

};


function openTycoonPlace() {
    var userId = localStorage.getItem('userId');
    var avatar = localStorage.getItem('chatPortrait');
    var userStoreName = localStorage.getItem('storeName');
    openUserTycoonPlace(userId, userStoreName, avatar, 'mine');
}

function refreshPage() {
    location.reload();
}
