var pictures = [];
apiready = function () {
    api.setWinAttr({
        bounces: false
    });
    var imgW = $('#width').width();
    var imgW2 = imgW -5;
    $('#uploadImgBox .img-li').height(imgW);
    $('#uploadImgBox #getPhotosNew').height(imgW2);

    getPhotoWall();
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false,
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.general.done,
            color:'#4578F3',
            fontSize:'16',
            fontWeight:'600'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {

        if(ret.type ==='right'){
            savePhotoWall();
        }else{
            back();
        }
    });

};
function getPhotoWall() {
    loading('show');
    var myGuid = localStorage.getItem('userGuid');
    var url = getBaseUrl() + "/api/v2/users/album?OwnerGuid="+myGuid;
    getAxois(url, "GET", {}).then(function (response) {
        if(response.data.Photos && response.data.Photos.length>0){
            var pic = response.data.Photos.reverse();
            var len = pic.length;
            remaining = remaining - len;
            for(i=0; i<len; i++){
                if(!pic[i].DownloadUrl && pic[i].PictureUrl){
                    pic[i].DownloadUrl = pic[i].PictureUrl
                }
                // var PIC = pic[i].ThumbnailUrl ? pic[i].ThumbnailUrl : pic[i].DownloadUrl;
                var picData =  {
                    "MediaType" : "Picture",
                    "FileName" : "testimage.png",
                    "MediaFileUrl" : pic[i].MediaFileUrl || pic[i].DownloadUrl,
                    "DownloadUrl":pic[i].DownloadUrl,
                    "ThumbnailUrl" : pic[i].ThumbnailUrl || pic[i].DownloadUrl
                };
                $('#uploadImgBox').prepend(
                    getPhotoItem(i+'D', liWith, pic[i].DownloadUrl, false)
                );
                $("#p" + i +'D').data("picture", picData);
                // var img = "<img class='img-fluid' id ='p" + i + "' src=" + PIC + " alt='image' data-guid='"+ pic[i].Guid +"' data-picture='"+ JSON.stringify(pic[i]) +"'>";
                // $('#uploadImgBox').append('<li class="ui-col ui-col-33 img-li" style="height: ' + liWith + 'px"><i class="icon iconfont icon-tuodong drag-handle" ></i><i class="icon icon-tweebaa icon-trash-solid" style="color: #dadada !important;"></i><div class="media-box">' + img + '</div></li>');
            }

            loading('hide');
            Sortable.create(document.getElementById('uploadImgBox'),
                {
                    animation: 150, onEnd: function (e) {

                    },
                    ghostClass:'.img-li',
                    handle:'.drag-handle'
                });

        }

    }).catch(function (error) {
        loading('hide');
        console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
    });
}

var sending = false;
function savePhotoWall() {
    if(sending){
        return false;
    }
    pictures = [];
    $("#uploadImgBox").find('img').each(function (index) {
        var pic = $(this).data('picture');
        pic.DisplayOrder = index;
        pictures.push(pic);
    });
    // $("#uploadImgBox").find('img').each(function (index) {
    //     var pic = typeof $(this).data('picture') === 'string' ? JSON.parse($(this).data('picture')) : $(this).data('picture');
    //     pic.DisplayOrder = index;
    //     pictures.push(pic);
    // });
    var myGuid = localStorage.getItem('userGuid');
    var url = getBaseUrl() + "/api/v2/users/album";
    var paramStr = {
        "OwnerGuid" : myGuid,
        "Photos" :pictures
    };
    //console.log(JSON.stringify(paramStr));
    sending = true;
    if(imgUploading){
        api.toast({
            msg: MSG.tips.uploadDataTips,
            duration: 2000,
            location: 'middle'
        });
        setTimeout(function () {
            savePhotoWall();
        },2000)
    }else{
        loading('show');
        getAxois(url, "POST", paramStr).then(function (response) {
            //console.log(JSON.stringify(response));
            loading('hide');
            api.sendEvent({
                name: 'workplaceReload',
                extra: {
                    type: "photoWall",
                }
            });
            // api.sendEvent({
            //     name: 'tycoonplaceReload',
            //     extra: {
            //         type: "photowall",
            //     }
            // });
            back();
        }).catch(function (error) {
            loading('hide');
            if(error.response.data.Message === 'user can upload up to 12 photos'){
                messages(MSG.profile.maxPhotos, 'error', 'top', 3);
            }else{
                messages(MSG.tips.systemError, 'error', 'top', 3);
            }
        });
    }

}
