//share to weChat

function shareToWeChat(type,ShareUrl,name,content,thumbnail) {
    loading('show');
    var icon = thumbnail || 'https://tweebaafiles.oss-cn-beijing.aliyuncs.com/tweebaa/default-avatar.png';
    // var title = type ==='session'? name : content;
    var title = name;
    api.download({
        url: icon,
        report: true,
        cache: true,
        allowResume: true
    }, function(Ret, err) {
        loading('hide');
        if (Ret.state == 1) {
            var wx = api.require('wxPlus');
            wx.isInstalled(function (ret, err) {
                if (ret.installed) {
                    ClosePopUpBox();
                    wx.shareWebpage({
                        scene: type,
                        title: title || MSG.general.tweebaa || "Tweebaa",
                        thumb: Ret.savePath || '../../image/logo.png',
                        description:content ||'',
                        contentUrl: ShareUrl
                    }, function (ret, err) {
                        if (ret.status) {
                            api.toast({
                                msg: MSG.tips.shareSuccessful,
                                duration: 2000,
                                location: 'bottom'
                            });
                        } else {
                            if (err.code === 3) {

                            } else if (err.code === 2) {
                                api.toast({
                                    msg: MSG.tips.shareCanceled,
                                    duration: 2000,
                                    location: 'bottom'
                                });
                            }
                        }

                    });
                } else {
                    api.toast({
                        msg: MSG.tips.wechatNotInstall,
                        duration: 2000,
                        location: 'bottom'
                    });
                }
            });
        }
    });
}

function shareToFacebook(ShareUrl,name,content) {
    ClosePopUpBox();
    var pic = '../../image/logo.png';
    api.openApp({
        iosUrl: "https://www.facebook.com/sharer.php?u=" + ShareUrl,
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "https://www.facebook.com/sharer.php?u=" + ShareUrl
    });
    // var systemType = api.systemType;
    // if(systemType === 'ios'){
    //     api.openApp({
    //         iosUrl: "https://www.facebook.com/sharer.php?u=" + ShareUrl,
    //         androidPkg: 'android.intent.action.VIEW',
    //         mimeType: 'text/html',
    //         uri: "https://www.facebook.com/sharer.php?u=" + ShareUrl
    //     });
    // }else {
    //     var facebook = api.require('facebook');
    //     facebook.shareLinked({
    //         url: ShareUrl,
    //         imgUrl: pic,
    //         description: content,
    //         title: name
    //     }, function(ret, err){
    //         if(ret.status) {
    //             //api.alert({msg:JSON.stringify(ret)});
    //         } else {
    //             api.toast({
    //                 msg: $.i18n.prop('shareCanceled'),
    //                 duration: 2000,
    //                 location: 'bottom'
    //             });
    //         }
    //     });
    // }

}

function shareToGoogle(ShareUrl,name,content) {
    api.openApp({
        iosUrl: "https://plus.google.com/share?url=" + ShareUrl,
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "https://plus.google.com/share?url=" + ShareUrl
    });
}

function shareToTwitter(ShareUrl,name,content) {
    ClosePopUpBox();
    api.openApp({
        iosUrl: "https://twitter.com/intent/tweet?url=" + ShareUrl + "&text=" + name,
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "https://twitter.com/intent/tweet?url=" + ShareUrl + "&text=" + name
    });
}

function shareToWhatsApp(ShareUrl,name,content) {
    ClosePopUpBox();
    api.openApp({
        iosUrl: "whatsapp://send?text="+ encodeURIComponent(content) + encodeURIComponent("\n\n"+ShareUrl)+"&via=lopscoop",
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "whatsapp://send?text="+ encodeURIComponent(content) + encodeURIComponent("\n\n"+ShareUrl)+"&via=lopscoop",
    });
}

function shareToQQZone(ShareUrl,name,content) {
    ClosePopUpBox();
    api.openApp({
        iosUrl: "http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?summary=" + name + "&url=" + ShareUrl,
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?summary=" + name + "&url=" + ShareUrl
    });
}

function shareToWeibo(ShareUrl,name,content,thumbnail) {
    ClosePopUpBox();
    var weiboPlus= api.require('weiboPlus');
    weiboPlus.shareWebPage({
        text: content,
        title: name,
        description: content,
        thumb: thumbnail,
        contentUrl: ShareUrl
    }, function(ret, err) {

        if (ret.status) {
            api.toast({
                msg: MSG.tips.shareSuccessful,
                duration: 2000,
                location: 'bottom'
            });

        }else{
            api.toast({
                msg: MSG.tips.shareCanceled,
                duration: 2000,
                location: 'bottom'
            });
        }
    });
}

function shareToMail() {
    var title = $("#name").text() || $("#content").text();
    var url = 'mailto:?body=' + title + $('#shareURL').attr("data-shareUrl");
    $('#mailLink').attr('href', url);
    setTimeout(function () {
        $('#mailLink')[0].click();
    }, 500);
}

function shareToclipboard(ShareUrl) {
    //console.log(ShareUrl);
    var clipBoard = api.require('clipBoard');
    clipBoard.set({
        value: ShareUrl
    }, function (ret, err) {
        if (ret) {
            // messages($.i18n.prop('copied'), 'success', 'top', 2);
            api.toast({
                msg: MSG.tips.copied,
                duration: 4000,
                location: 'middle'
            });

            ClosePopUpBox();
        }
    });
}

function generatePoster(Guid,postId,type) {
    var url;
    if(type==='prod'){
        url= getBaseUrl()+"api/product/poster/guid?productGuid="+ postId +"&lang="+ lan;
    }else{
        url= getBaseUrl()+"api/post/poster/guid?postGuid="+ Guid +"&lang="+ lan;
    }
    //console.log(url);
    loading('show');

    getAxois(url, "GET", {}).then(function (response) {
        var img = response.data.posterURL;
        api.download({
            url: img,
            report: true,
            cache: true,
            allowResume: true
        }, function (ret, err) {
            if (ret.state === 1) {
                var Url= ret.savePath;
                loading('hide');
                api.saveMediaToAlbum({
                    path: Url,
                    groupName:"Tweebaa"
                }, function(ret, err) {
                    if (ret && ret.status) {
                        api.toast({
                            msg: MSG.tips.posterDownloadSuccess,
                            duration: 4000,
                            location: 'middle'
                        });
                        ClosePopUpBox();
                    }
                });

            }
        });
    }).catch(function (error) {
        loading('hide');
        console.log(JSON.stringify(error) + '#######################');
        messages($.i18n.prop('systemError'), 'error', 'top', 3);
    });
}

function shareMore(ShareUrl){
    var sharedModule = api.require('shareAction');
    sharedModule.share({
        path: ShareUrl,
        type: 'url'
    });
    ClosePopUpBox();
}
