var mPages = 0;
var pPages = 0;
var sPages = 0;

var PAGE_SIZE = 10;

var token;
apiready = function () {
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName: '推主空间'});

    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    api.setWinAttr({
        slidBackEnabled: false,
        bounces: false
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if (tycoonplace.listBtn === 'post' && tycoonplace.momentsLoad && !tycoonplace.bottomLoading && !tycoonplace.isLoading) {
            mPages++;
            tycoonplace.getMoments(mPages);
        } else if (tycoonplace.listBtn === 'product' && tycoonplace.productsLoad && !tycoonplace.bottomLoading && !tycoonplace.isLoading) {
            pPages++;
            tycoonplace.getProducts(pPages);
        } else if (tycoonplace.listBtn === 'suggest' && tycoonplace.suggestLoad && !tycoonplace.bottomLoading && !tycoonplace.isLoading) {
            sPages++;
            tycoonplace.getSuggests(sPages);
        }
    });

    api.addEventListener({
        name: 'selectedProdCategory',
    }, function (ret, err) {
        tycoonplace.prodFilter.categoryId = ret.value.category.id;
        tycoonplace.prodFilter.displayFilter = ret.value.category[lan];
        pPages = 0;
        tycoonplace.useFilter = true;
        tycoonplace.getProducts(0);
    });

    var kv = api.require('snKVStorage');
    var TCPOSTDATA = {};
    var TCPORDDATA = {};

    var hasTCPostData = kv.has({
        key: 'TYcoonPostData',
    });

    if (hasTCPostData) {
        TCPOSTDATA = kv.getObject({
            key: 'TYcoonPostData',
        });
    }
    var hasTCPordData = kv.has({
        key: 'TYcoonPordData',
    });

    if (hasTCPordData) {
        TCPORDDATA = kv.getObject({
            key: 'TYcoonPordData',
        });
    }

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        tycoonplace.$forceUpdate();
    });

    //同步详情页和列表页数据
    api.addEventListener({
        name: 'resetPost',
    }, function (ret, err) {
        switch (ret.value.type) {
            case 'remove':
                $('li#' + ret.value.postGuid).remove();
                break;
            case 'like':
                if (ret.value.from === 'tycoon') {
                    tycoonplace.momentsData[ret.value.index].Liked = ret.value.liked;
                    tycoonplace.momentsData[ret.value.index].LikedCount = ret.value.likedCount;
                }
                break;
            case 'comments':
                if (ret.value.from === 'tycoon' && ret.value.commentCount === 'add') {
                    tycoonplace.momentsData[ret.value.index].commentCount++;
                } else if (ret.value.from === 'tycoon' && ret.value.commentCount === 'minus') {
                    tycoonplace.momentsData[ret.value.index].commentCount--;
                }
                break;
        }
    });

    // api.addEventListener({
    //     name: 'swiperight'
    // }, function (ret, err) {
    //     tycoonplace.setAnalyticsInfo();
    // });
    var userID = localStorage.getItem('userId');
    var time = 0;

    function setTime() {
        setTimeout(function () {
            time++;
            if (time === 30 && userID) {
                AddTivNew('VIEW_TYCOONPLACE', {
                    visitedCustomerId: api.pageParam.userId
                });
            }
            setTime();

        }, 1000)
    }

    setTime();

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var tycoonplace = new Vue({
        el: '#tycoonplace',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
            this.getUserDetails();
            this.getTycoonTweeLogs();
            this.getViewTime();
            this.getTiv();
            //写入字体大小
            var fontSize = localStorage.getItem('chatFontSize');
            if (fontSize) {
                var style = '<style> .moment-content, .translation-text\{font-size: ' + getRightPxFromFontSize(fontSize) + 'px !important; line-height: 1.3 !important;\}</style>';
                $('head').append(style);
            }
            // 顶部Tabs样式
            $('.ui-tabs').removeClass('zh en es').addClass(lan);
        },
        created: function() {
            this.storename = userRemarkService.get(api.pageParam.userId, api.pageParam.storeName) || '';
        },
        data: {
            appleCheck: appleCheck,
            page: 'tycoonplace',
            userInfo: {
                FollowersCount: '-',
                FollowingCount: '-',
                MomentCount: '-',
                ProductCount: '-'
            },
            storeName: '',
            avatarUrl: api.pageParam.AvatarUrl || '',
            bigAvatarUrl: '',
            listBtn: 'post',   // product, suggest, post, photo
            momentsTotal: '-',
            myID: localStorage.getItem('userId'),
            momentsData: TCPOSTDATA['tyPost' + api.pageParam.userId] ? TCPOSTDATA['tyPost' + api.pageParam.userId] : [],
            productsData: TCPORDDATA['tyPord' + api.pageParam.userId] ? TCPORDDATA['tyPord' + api.pageParam.userId] : [],
            productsLoad: true,
            momentsLoad: true,
            photoWall: [],
            photoCount: '-',
            photoPics: [],
            mPages: mPages,
            viewTime: '-',
            viewDuration: 0,
            defaultCurrency: localStorage.getItem('primaryCurrencyCode'),
            bottomLoading: false,
            pPages: pPages,
            isLoading: false,
            imageShow: false,
            repostContent: "",
            condition: {
                pageSize: PAGE_SIZE,
                sort: null,
                userId: localStorage.getItem('userId')
            },
            TiV: '',
            evaluationList: [],
            suggestLoad: true,
            isNavTop: false,
            navOffset: 0,
            searchBox: false,
            useFilter: false,
            prodFilter: {
                displayFilter: '',
                categoryId: '',
                orderBy: '',   // 可选项。 其值只有两个固定选项“NAME” 和 “TWEEBUCK_PRICE” 或者为空
                desc: true,//可选项。 默认值是true降序。
                q: ''//可选项。 对产品名称的模糊查询
            },
            tweeLogList:'',
            message: MSG
        },
        filters: {
            formatTime: function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            ifNull: function (value) {
                if (!value) {
                    return 0;
                } else {
                    return value;
                }
            },
            filterContent: function (value) {
                if (value && value.length > 40) {
                    return value.slice(0, 40) + '...';
                } else {
                    return value
                }
            },
            toFixed1: function (value) {

                if (value || value === 0) {
                    var N = Number(value);
                    if (N > 1000) {
                        return Math.round(N / 100) / 10 + "K";
                    } else {
                        return value;
                    }
                } else {
                    return '--'
                }

            }
        },
        methods: {
            _initDom: function () {
                var that = this;
                var $win = $(window);
                var $header = $('.ui-header');
                var heightHeader = $header.height();
                var $icon = $header.find('.icon-tweebaa');
                var $pageTitle = $('#pageTitle');
                var $tycoonNav = $('#tycoonNav');
                var $tycoonList = $('.tycoonList');
                var heightNav = $tycoonNav.height() + 5;
                var offsetTop = $tycoonNav.offset().top;
                var h = offsetTop - $header.height();
                var contentHeight = api.winHeight - 40 - 30;
                $tycoonList.css({
                    minHeight: contentHeight
                });

                this.navOffset = h;

                // console.log('offsetTop: ' + offsetTop);

                $win.scroll(function () {
                    var top = $win.scrollTop();
                    // console.log('top: ' + top);
                    if (top >= h) {
                        that.isNavTop = true;
                        $icon.css({"background": "none", "color": "#4d4d4d"});
                        $header.removeClass('header-transparent');
                        $pageTitle.html(tycoonplace.storeName).css({
                            opacity: 1
                        });
                        $tycoonNav.addClass('fixed');
                        $tycoonList.css({
                            marginTop: heightNav
                        });
                    } else {
                        that.isNavTop = false;
                        $icon.css({"background": "rgba(57, 57, 57, 0.4)", "color": "#fff"});
                        $header.addClass('header-transparent');
                        $pageTitle.html('').css({
                            opacity: 0
                        });
                        $tycoonNav.removeClass('fixed');
                        $tycoonList.css({
                            marginTop: 0
                        });
                    }

                });
            },
            /**
             * 刷新瞬间列表
             */
            refreshMoment: function () {
                loading('show');
                mPages = 0;
                this.momentsLoad = true;
                this.getMoments(mPages);
            },
            /**
             * 刷新产品列表
             */
            refreshProduct: function () {
                loading('show');
                pPages = 0;
                this.productsLoad = true;
                this.prodFilter.categoryId = '';
                this.prodFilter.displayFilter = '';
                this.prodFilter.orderBy = '';
                this.prodFilter.desc = true;
                this.prodFilter.q = '';
                this.searchBox = false;
                this.useFilter = false;
                this.getProducts(pPages);
            },
            /**
             * 刷新建议列表
             */
            refreshSuggest: function () {
                loading('show');
                sPages = 0;
                this.suggestLoad = true;
                this.getSuggests(sPages);
            },
            getUserDetails: function () {
                var that = this;
                var url = getBaseUrl() + "/api/users/" + api.pageParam.userId + "?viewerId=" + this.myID;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    that.userInfo = response.data;
                    that.getMoments(0);
                    that.getPhotoWall(response.data.CustomerGuid);
                    that.bigAvatarUrl = response.data.AvatarUrl;
                    that.avatarUrl = response.data.AvatarUrl;
                    that.storeName = userRemarkService.get(api.pageParam.userId, response.data.StoreName);
                    setTimeout(function () {
                        that._initDom();
                    });
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            getTiv: function () {
                var that = this;
                var url = getBaseUrl() + "api/v2/tiv?UserId=" + api.pageParam.userId;
                getAxois(url, "GET", {}).then(function (response) {
                    that.TiV = response.data.Data.CompletedTiv.toFixed(1);
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getViewTime: function () {
                var that = this;
                var url = getBaseUrl() + "api/dashboard/v1/ty/" + api.pageParam.userId;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(that.tag));
                    if (response.data.Code === 0) {
                        that.viewTime = response.data.Data.Views;
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');

                });
            },
            followBtn: function (userGuid) {
                var that = this;
                if (token) {
                    if (this.userInfo.Followed === false) {
                        follow(this.userInfo.CustomerGuid, this.userInfo.UserName, function () {
                            that.userInfo.Followed = true;
                            that.userInfo.FollowersCount++;
                        });
                    } else {
                        disFollow(this.userInfo.CustomerGuid, function () {
                            that.userInfo.Followed = false;
                            that.userInfo.FollowersCount--;
                        });
                    }
                } else {
                    openLogin();
                }
            },
            setRemark: function() {
                var that = this;
                userRemarkService.open({
                    userId: this.userInfo.Id,
                    avatarUrl: this.userInfo.AvatarUrl,
                }, function (name) {
                    that.storeName = name;
                });
            },
            chatToUser: function () {
                var that = this;
                var chatID = localStorage.getItem('chatID');
                if (chatID && that.avatarUrl) {
                    var userinfo = that.userInfo;
                    restartChatPage({
                        targetId: userinfo.UserName + '@new',
                        userName: userinfo.StoreName,
                        userPortrait: that.avatarUrl,
                        conversationType: 'PRIVATE',
                        isTop: false
                    });
                } else {
                    openLogin();
                }
            },
            resetNav: function () {
                var $win = $(window);
                if (this.isNavTop === true) {
                    $win.scrollTop(this.navOffset + 1);
                }
            },
            changeList: function (event, list) {
                if (this.listBtn !== list) {
                    this.listBtn = list;
                    this.resetNav();
                    switch (list) {
                        case 'product':
                            this.refreshProduct();
                            break;
                        case 'suggest':
                            this.refreshSuggest();
                            break;
                        case 'post':
                            this.refreshMoment();
                            break;
                        case 'photo':
                            td.onEvent({
                                eventId: '点击空间相册',
                                eventLabel: '点击推主空间相册'
                            });
                            break;
                    }
                }
            },
            _initListData: function (list) {
                if (list.length > 0) {
                    var currency = lan === 'zh' ? '￥' : '$';
                    var item;
                    for (var i = 0, len = list.length; i < len; i++) {
                        item = list[i];
                        // 价格
                        item.TweebuckPriceText = getExchangeText(item.TweebuckPrice);
                    }
                }
            },

            /**
             * 个人产品分类排序查询
             */
            openCategoryPage: function () {
                openTabLayout('categoryPage', MSG.products.category, 'widget://html/frame/select-category.html', {
                    fromPage: 'tycoonProd'
                });
            },
            openProdSearch: function () {
                this.searchBox = true;
                this.useFilter = true;
            },
            searchProduct: function () {
                $('#searchBox').blur();
                pPages = 0;
                this.getProducts(0);
            },
            openSortMenu: function () {
                var that = this;
                var T = this.$refs.prodFilterBar.offsetTop;
                var mnPopups = api.require('MNPopups');
                mnPopups.open({
                    rect: {
                        w: 180,
                        h: 238
                    },
                    position: {
                        x: api.winWidth - getRightPxFromFontSize(26),
                        y: T + 30
                    },
                    styles: {
                        mask: 'rgba(0,0,0,0.2)',
                        bg: '#fff',
                        corner: 8,
                        cell: {
                            bg: {
                                normal: '#fff',
                                highlight: ''
                            },
                            h: 44,
                            title: {
                                marginL: 20,
                                color: '#000',
                                size: 14,
                                textAlign: 'left'
                            },
                            icon: {
                                marginL: 140,
                                w: 20,
                                h: 20,
                                corner: 0
                            },
                            separateLine: {
                                width: 0.5,
                                marginLR: 10,
                                bg: '#DADADA',
                                hideLastSeparateLine: true
                            }
                        },
                        pointer: {
                            size: 0,
                            xPercent: 90,
                            yPercent: 0,
                            orientation: 'downward'
                        }
                    },
                    datas: [
                        {
                            icon: 'widget://image/placeholder.png',
                            title: MSG.tProduct.default
                        },
                        {
                            icon: 'widget://image/ranking-up.png',
                            title: MSG.tProduct.lowToHigh
                        },
                        {
                            icon: 'widget://image/ranking-down.png',
                            title: MSG.tProduct.highToLow
                        },
                        {
                            icon: 'widget://image/ranking-up.png',
                            title: MSG.tProduct.byName
                        },
                        {
                            icon: 'widget://image/ranking-down.png',
                            title: MSG.tProduct.byNameR
                        }
                    ],
                    animation: true,
                    animationDuration: 100
                }, function (ret) {
                    if (ret) {
                        if (ret.index === 0) {  //默认
                            that.refreshProduct();
                        } else if (ret.index === 1) {   // 价格由低到高
                            that.prodFilter.orderBy = 'TWEEBUCK_PRICE';
                            that.useFilter = true;
                            that.prodFilter.desc = false;
                            that.prodFilter.displayFilter = MSG.tProduct.lowToHigh;
                            pPages = 0;
                            that.getProducts(0);
                        } else if (ret.index === 2) {   // 价格由高到低
                            that.prodFilter.orderBy = 'TWEEBUCK_PRICE';
                            that.useFilter = true;
                            that.prodFilter.desc = true;
                            that.prodFilter.displayFilter = MSG.tProduct.highToLow;
                            pPages = 0;
                            that.getProducts(0);
                        } else if (ret.index === 3) {   // 名字正序
                            that.prodFilter.orderBy = 'NAME';
                            that.useFilter = true;
                            that.prodFilter.desc = false;
                            that.prodFilter.displayFilter = MSG.tProduct.byName;
                            pPages = 0;
                            that.getProducts(0);
                        } else if (ret.index === 4) {   // 名字倒序
                            that.prodFilter.orderBy = 'NAME';
                            that.useFilter = true;
                            that.prodFilter.desc = true;
                            that.prodFilter.displayFilter = MSG.tProduct.byNameR;
                            pPages = 0;
                            that.getProducts(0);
                        }
                    }
                });
            },
            getProducts: function (pPages) {
                var that = this;
                if (that.isLoading) {
                    return false;
                }

                if (pPages !== 0) {
                    that.bottomLoading = true;
                } else {
                    $('#updateTips2').show();
                }
                var url = getBaseUrl() + "/api/v3/users/products?LanguageCode=" + lan;
                var paramStr = {
                    "ownerId": api.pageParam.userId,
                    "currentpage": pPages || 0,
                    "itemsperpage": PAGE_SIZE,
                    "LanguageCode": lan,
                    "ProductToTweebaaDetailRequired": true,
                    "self": false,
                    "businessType": -1,
                    "categoryId": that.prodFilter.categoryId,
                    "orderBy": that.prodFilter.orderBy,
                    "desc": that.prodFilter.desc,
                    "q": that.prodFilter.q
                };
                that.isLoading = true;
                getAxois(url, "POST", paramStr).then(function (response) {
                    //console.log(JSON.stringify(response));
                    // $('#placeHolderLoad1').remove();
                    $('#updateTips2').hide();
                    that.bottomLoading = false;
                    that.isLoading = false;
                    var list;
                    if (pPages === 0) {
                        loading('hide');
                        list = response.data.Data;
                        that._initListData(list);
                        that.productsData = list;
                        var datas = {};
                        if (hasTCPordData) {
                            datas = kv.getObject({
                                key: 'TYcoonPordData',
                            });
                        }
                        datas['tyPord' + api.pageParam.userId] = that.productsData;
                        kv.setObject({
                            key: 'TYcoonPordData',
                            value: datas
                        });
                        if (response.data.Data.length === 0) {
                            that.productsLoad = false;
                        }
                    } else {
                        if (response.data.Data.length !== 0) {
                            list = response.data.Data;
                            that._initListData(list);
                            that.productsData = that.productsData.concat(list);
                        } else {
                            that.productsLoad = false;
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            progressColor:function(index){
                if(!this.productsData[index].BusinessType && this.productsData[index].BusinessType !== 1){
                    return
                }
                var end = moment(this.productsData[index].PreSaleInfo.PreSaleStopUtc).local();
                var now = moment();
                var endDate = end.diff(now, 'hours');
                var endMinute = end.diff(now, 'minutes');
                if(endDate>=0 && endDate < 24 && endMinute >0 ){
                    return 'bk-red'
                }else if(endMinute <= 0 ){
                    return 'bk-green'
                }
            },
            getMoments: function (mPages) {
                var that = this;
                if (that.isLoading) {
                    return false;
                }
                if (mPages !== 0) {
                    that.bottomLoading = true;
                } else {
                    $('#updateTips').show();
                }
                loading('show');
                that.isLoading = true;
                apiMoment.get('/api/v1/blog_posts/browse/' + api.pageParam.userId + '/moment', that.condition).done(function (rep) {
                    $('#updateTips').hide();
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');
                    if (rep.code === 0) {
                        var list = rep.data.blogPosts;
                        if (mPages === 0) {
                            if (list.length !== 0) {
                                that._initMomentsData(list);
                                that.momentsData = list;
                                that._initSwipper();
                                var datas = {};
                                if (hasTCPostData) {
                                    datas = kv.getObject({
                                        key: 'TYcoonPostData',
                                    });
                                }
                                datas['tyPost' + api.pageParam.userId] = that.momentsData;
                                var TYcoonPostDatas = kv.setObject({
                                    key: 'TYcoonPostData',
                                    value: datas
                                });
                            } else {
                                that.momentsLoad = false;
                            }
                        } else {
                            if (list.length !== 0) {
                                that._initMomentsData(list);
                                that.momentsData = that.momentsData.concat(list);
                                that._initSwipper();
                            } else {
                                that.momentsLoad = false;
                            }
                        }
                        that.momentsTotal = rep.data.total;
                        that.condition.sort = rep.data.sort.join(',');
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            getTycoonTweeLogs:function(){
                var that = this;
                var params = {
                    "page": 1,
                    "size": 20,
                };
                apiTweelog.get("/api/v1/tweelog/"+ api.pageParam.userId +"/space", params).done(function (rep) {
                    if (rep.code === 0) {
                        that.tweeLogList = rep.data.list;
                    }

                });
            },
            showStar:function(totalScore){
                if(totalScore){
                    return parseInt(totalScore);
                }else{
                    return 0;
                }
            },
            toDetail:function (index) {
                openTabLayout('tweeLogDetail', '', 'widget://html/tweelog/tweeLog-detail.html',{
                    tweelogInfo:this.tweeLogList[index]
                },true);
            },
            getPhotoWall: function (guid) {
                var that = this;
                var url = getBaseUrl() + "/api/v2/users/album?OwnerGuid=" + guid;
                getAxois(url, "GET", {}).then(function (response) {
                    var list = response.data.Photos;
                    that.photoWall = list;
                    that.photoCount = list.length;
                    for (var i = 0, len = list.length; i < len; i++) {
                        that.photoPics.push(list[i].PictureUrl);
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            preShare: function () {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBarSpace();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    }
                ]);
            },
            toRepostChatPage: function () {
                var userId = api.pageParam.userId;
                var name = MSG.tips.shareTycoonplaceTips;
                var Content = MSG.tips.shareTycoonplaceTips2;
                var thumbnail = this.userInfo.ThumbnailAvatarUrl;
                openShareToChats({
                    title: name,
                    description: Content,
                    imageUrl: thumbnail,
                    extra: {
                        textType: 'tycoonplace',
                        userId: userId,
                        AvatarUrl: thumbnail,
                        userPortrait: thumbnail,
                        storeName: this.storeName,
                    }
                });
            },
            /**
             * 分享个人空间
             */
            openShareBarSpace: function () {
                var userId = api.pageParam.userId;
                var userName = localStorage.getItem('userName') || '';
                var ShareUrl = shareH5Host + '/html/space.html?userId=' + userId + "&storeName=" + this.storeName + "&shareid=" + userName;
                var name = MSG.tips.shareTycoonplaceTips;
                var Content = MSG.tips.shareTycoonplaceTips2;
                var thumbnail = this.userInfo.ThumbnailAvatarUrl;
                new OpenShareBox(ShareUrl, name, Content, userName, '', 'activity', thumbnail, userId);
            },
            openPortrait: function () {
                var UIPhotoViewer = api.require('UIPhotoViewer');
                var that = this;
                tycoonplace.imageShow = true;
                UIPhotoViewer.open({
                    images: [that.bigAvatarUrl],
                    bgColor: '#000',
                    zoomEnabled: true,
                    gestureClose: true
                }, function (ret, err) {
                    if (ret.eventType === 'click') {
                        UIPhotoViewer.close();
                        tycoonplace.imageShow = false;
                    } else if (ret.eventType === 'longPress') {
                        actionSheet([
                            {
                                text: MSG.general.save,
                                callback: function () {
                                    var index = ret.buttonIndex;
                                    if (index === 1) {
                                        loading('show');
                                        api.download({
                                            url: that.bigAvatarUrl,
                                            report: true,
                                            cache: true,
                                            allowResume: true
                                        }, function (ret, err) {
                                            if (ret.state === 1) {
                                                var Url = ret.savePath;
                                                loading('hide');
                                                api.saveMediaToAlbum({
                                                    path: Url,
                                                    groupName: "Tweebaa"
                                                }, function (ret, err) {
                                                    if (ret && ret.status) {
                                                        alert(MSG.tips.saved);

                                                    }
                                                });

                                            }
                                        });
                                    }
                                }
                            }
                        ]);
                    }
                });

            },
            openDetail: function (prodId) {
                var param = {
                    prodId: prodId,
                    userInfo: JSON.stringify(this.userInfo),
                    countryCode: this.userInfo.RegisterCountryCode
                };
                // console.log(JSON.stringify(param));
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            toFollowList: function (type, userId) {
                var param = {
                    type: type,
                    userId: userId
                };
                openTabLayout('followList', MSG.general[type], 'widget://html/users/follow-list.html', param);
                api.sendEvent({
                    name: 'refreshFollowList',
                    extra: param
                });
            },
            reportBtn: function () {
                openReportPage({
                    target: 'USER',
                    targetId: this.userInfo.Id
                });
            },
            setAnalyticsInfo: function () {
                if(api.pageParam.FromPage === 'tycoonFrame'){
                    api.sendEvent({
                        name: 'reCheckCondition',
                    });
                    api.closeFrame({
                        name: 'tycoonFrame'
                    });
                    return;
                }
                td.onEvent({
                    eventId: '退出点击',
                    eventLabel: '点击推主空间退出'
                });
                api.sendEvent({
                    name: 'analytics',
                    extra: {
                        AnalyticsItemTypeId: 3,
                        AnalyticsActionTypeId: 1,
                        CountryCode: localStorage.getItem('countryCode'),
                        ownerId: this.userInfo.Id,
                        StaySeconds: time,
                        viewerId: localStorage.getItem('userId')
                    }
                });
                //退出页面统计点
                td.onPageEnd({pageName: '推主空间'});
                setTimeout(function () {
                    api.closeWin();
                }, 200);
            },
            buyNow: function (index) {
                var product = this.productsData[index];
                var param = {
                    id: product.Id,
                    price: product.TweebuckPrice,
                    shippingFee: product.shippingFee,
                    type: product.ProductType,
                    name: product.Name,
                    thumbnailUrl: product.FeaturedPicture.ThumbnailUrl || product.FeaturedPicture.PictureUrl
                };

                // 如果发布者是tweebaa，那么传toTweebaaId
                if (product.Owner.Id === 1) {
                    param.toTweebaaId = product.LatestProductToTweebaa.ProductToTweebaaId;
                } else {
                    param.seller = this.userInfo;
                    param.toTweebaaId = null;
                }

                openTabLayout("buyNow", this.message.tycoonplace.yourOrder, 'widget://html/tproducts/buynow.html', param);
            },
            getSuggests: function (page) {
                var that = this;
                if (that.isLoading) {
                    return false;
                }
                var url = getBaseUrl() + "/api/suggest-products?ApplicantId=" + api.pageParam.userId
                    + "&currentpage=" + page
                    + "&itemsperpage=" + PAGE_SIZE + "&viewerId=" + this.myID;

                if (page === 0) {
                    loading('show');
                } else {
                    that.bottomLoading = true;
                }
                that.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    // $('#placeHolderLoad').remove();
                    // console.log(JSON.stringify(response.data.Data));
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');

                    if (page === 0) {
                        if (response.data.Data.length !== 0) {
                            that.evaluationList = response.data.Data;
                        } else {
                            that.suggestLoad = false;
                        }
                    } else {
                        if (response.data.Data.length !== 0) {
                            that.evaluationList = that.evaluationList.concat(response.data.Data);
                        } else {
                            that.suggestLoad = false;
                        }
                    }

                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            openEvaluationDetail: function (index) {
                var title = this.message.tycoonplace.evaluation;
                var id = this.evaluationList[index].Id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-detail.html', {
                    evaluationId: id,
                    index: index
                });
            },
            showPhotos: function ($event, Index) {
                var that = this;
                this.imageShow = true;

                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: this.photoPics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: Index,
                    zoomEnabled: true,
                    gestureClose: true
                }, function (Ret, err) {
                    if (Ret.eventType === 'click') {
                        UIPhotoViewer.close();
                        that.imageShow = false;
                    } else if (Ret.eventType === 'longPress') {
                        actionSheet([
                            {
                                text: MSG.general.save,
                                callback: function () {
                                    api.download({
                                        url: picUrls[Ret.index],
                                        report: true,
                                        cache: true,
                                        allowResume: true
                                    }, function (ret, err) {
                                        if (ret.state === 1) {
                                            var Url = ret.savePath;
                                            api.saveMediaToAlbum({
                                                path: Url,
                                                groupName: "Tweebaa"
                                            }, function (ret, err) {
                                                if (ret && ret.status) {
                                                    alert(MSG.tips.saved);
                                                }
                                            });

                                        }
                                    });
                                }
                            }
                        ]);
                    }
                });
            },
        }

    });

};

$('.save-image-btn').on('click', function () {
    loading('show');
    api.download({
        url: $('#downloadImage').val(),
        report: true,
        cache: true,
        allowResume: true
    }, function (ret, err) {
        if (ret.state === 1) {
            var Url = ret.savePath;
            loading('hide');
            api.saveMediaToAlbum({
                path: Url,
                groupName: "Tweebaa"
            }, function (ret, err) {
                if (ret && ret.status) {
                    api.toast({
                        msg: MSG.tips.saved,
                        duration: 2000,
                        location: 'middle'
                    });
                }
            });

        }
    });
});

$('#actionBox').on('click', function (e) {
    var tar = e.target.id;
    if (tar === 'shareBox') {
        CloseActionBox();
    }
});

function CloseActionBox() {
    $('#actionBox').removeClass('show');
}

